//----------------------------------------------------------------------------------------------------
/*
 * Standard client side behavior for entity management ( JavaScript ) 
 */
//----------------------------------------------------------------------------------------------------
/***
window.onTelosysActionError = function(response)
{
	alert("onTelosysActionError");
	alert ("Before new ScreenError");
	var errors = response.getErrors();
	new ScreenError("12", "Bla bla");
	alert ("After new ScreenError");
}
***/
//----------------------------------------------------------------------------------------------------
function trace(msg)
{
	//alert ( "TRACE : \n" + msg);
}
//----------------------------------------------------------------------------------------------------
function checkResponse(response)
{
	if ( ! response.isOK() )
	{
		alert ( "ERROR : \n Response return code = " + response.getReturnCode() );	
	}	
}
//----------------------------------------------------------------------------------------------------
// Call the server side to OPEN the ScreenContext (use a new Screen Context) 
//----------------------------------------------------------------------------------------------------
function actionOpen()
{
	trace ( "actionOpen()  ");
	var response = actions.doOpen();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CLOSE the current Screen Context 
//----------------------------------------------------------------------------------------------------
function actionClose()
{
	trace ( "actionClose()  ");
	var response = actions.doClose();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to SET the given data in the Screen Context 
//----------------------------------------------------------------------------------------------------
function actionSet()
{
	trace ( "actionSet()  ");
	var response = actions.doSet();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to GET the Screen Context data 
//----------------------------------------------------------------------------------------------------
function actionGet()
{
	trace ( "actionGet()  ");
	var response = actions.doGet(); // Update Screen (by default)
	//response.show();
	//var response = actions.doGet(true); // Update Screen 
	//var response = actions.doGet(false); // Do NOT update screen
	
	checkResponse(response);
	// The code below replaces "actions.doGet_DataVoid()"
	if ( response.isOK() && response.dataVoid() )
	{
		alert ( "No data !" );	
	}	
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CLEAR the Screen Context 
//----------------------------------------------------------------------------------------------------
function actionClear()
{
	trace ( "actionClear()  ");
	var response = actions.doClear(); // Update Screen (by default)
	//actions.doClear(false); // Clear context but DO NOT Update Screen	
	checkResponse(response);
}

//----------------------------------------------------------------------------------------------------
// Call the server side to LOAD the entity corresponding to the given Primary Key   
//----------------------------------------------------------------------------------------------------
function actionLoad(params)
{
	trace ( "actionLoad()  ");
	if ( params != null ) // is there some PK parameters to use ?
	{
		for ( p in params )
		{
		    actions.setParameter( p, params[p] );
		}
	}
	else
	{
		if ( typeof window.setKeyParam == "function" ) // is there a default function to set PK parameters ?
		{
			setKeyParam();
		}
	}
	
	var response = actions.doLoad(); // Update Screen (by default)
	checkResponse(response);
	if ( response.isOK() && response.dataNotFound() )
	{
		alert ( "Data not found !" );
	}
}
//----------------------------------------------------------------------------------------------------
// Call the server side to SAVE ( CREATE or UPDATE ) the entity  
//----------------------------------------------------------------------------------------------------
function actionSave()
{
	trace ( "actionSave()  ");
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    var response = actions.doSave();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CREATE the entity  
//----------------------------------------------------------------------------------------------------
function actionInsert()
{
	trace ( "actionInsert()  ");
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    var response = actions.doInsert();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to UPDATE the entity  
//----------------------------------------------------------------------------------------------------
function actionUpdate()
{
	trace ( "actionUpdate()  ");
	//actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
	var response = actions.doUpdate();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to DELETE the entity 
//----------------------------------------------------------------------------------------------------
function actionDelete()
{
   	trace ( "actionDelete()  ");
   	setKeyParam(); // Call setKeyParam() to delete by Primary Key (else delete current)
   	var response = actions.doDelete(); // Clear Screen (by default)
   	//actions.doNotClearContextData();
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    //actions.doDelete(true, true); // Clear Screen && Update Fields & Views
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to EXEC the "search" procedure
// Fixed values :
// "search" : the procedure name ( must be implemented in XxxxxProc.java on the server side )
// "searchResultView" : the logical name of the view in the response
// "search_count" : the name of a response value containing the number of items returned after the search 
//----------------------------------------------------------------------------------------------------
function actionExecSearch(renderer, container)
{
   	trace ( "actionExecSearch(" + renderer + "," + container + ")");
   	
	if ( renderer  == null ) { alert ( "Error in actionExecSearch : renderer parameter is null" ); return ; }
	if ( container == null ) { alert ( "Error in actionExecSearch : container parameter is null" ); return ; }

	//--- Set the action parameters : each non-void field is transmitted as a request parameter
	actions.setParametersFromFields();

	//--- Define the view to retrieve in this action 
	actions.setViewToRetrieve("searchResultView", renderer );
	
	//--- Call the "exec" action for the "search" procedure
	var oResponse = actions.doExec("search");
	
	if ( oResponse.reportsErrors() )
	{
		oResponse.showAllErrors();
		return false ;
	}
	else
	{
		//alert ( "Exec procedure '" + sProcName + "' : Return Code OK " ); 
		var n = oResponse.getValue("search_count");
		if ( n < 1 ) 
		{
			alert("Nothing found");
			return false ;
		}
		else
		{
			//oResponse.show();
			fwkShowActionView(container, oResponse, "searchResultView");
			return true ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
// Default "setKeyParam" function (designed to be overriden in each screen behavior)
//----------------------------------------------------------------------------------------------------
function setKeyParam()
{
    alert("The 'setKeyParam()' function must be overriden in each screen !");
}

//----------------------------------------------------------------------------------------------------
// Clear all the screen fields 
//----------------------------------------------------------------------------------------------------
function clearScreen()
{
	theScreen.clear();
}
//----------------------------------------------------------------------------------------------------
