package org.demo.env;

import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletContext;

import org.objectweb.telosys.auth.TelosysAUTH;
import org.objectweb.telosys.common.Telosys;
import org.objectweb.telosys.common.TelosysContextListener;
import org.objectweb.telosys.dal.TelosysDAL;
import org.objectweb.telosys.dal.sql.ConnectionManager;
import org.objectweb.telosys.rpl.TelosysRPL;
import org.objectweb.telosys.screen.env.ScreenApplication;
import org.objectweb.telosys.uil.TelosysUIL;


/**
 * Application initialization
 *
 */
public class AppInit extends TelosysContextListener
{

    /* (non-Javadoc)
     * @see testsjava.listeners.TelosysContextListener#initTelosys()
     */
    public void initTelosys(ServletContext servletContext, ScreenApplication screenApplication)
    {
        info("=== Main Factory Creation ...");

        //--- External Factory creation
        MainFactory extFactory = new MainFactory();

        info("=== Telosys Initialization ...");
        //Telosys.init(extFactory); // Init via Java ClassPath 
        Telosys.init(extFactory, servletContext);

        //--- Init the different layers
        info("=== Telosys authentication layer initialization ...");
        TelosysAUTH.init();

        info("=== Telosys U.I.L. initialization ...");
        TelosysUIL.init(servletContext);

        info("=== Telosys R.P.L. initialization ...");
        TelosysRPL.init();

        info("=== Telosys D.A.L. initialization ...");
        TelosysDAL.init();
        
        info("=== Telosys DATABASES list : ");
        List dbList = ConnectionManager.getDatabases();
        Iterator it = dbList.iterator();
        while ( it.hasNext() )
        {
            info( " . " + it.next() ) ;
        }
        
    }

    
    /* (non-Javadoc)
     * @see testsjava.listeners.TelosysContextListener#initApplication()
     */
    public void initApplication(ServletContext servletContext, ScreenApplication screenApplication)
    {
        info("=== Application Data initialization ...");
        /*
        try {
        	// Insert here the specific application data initialization
            //AppData.init();
	    } catch (TelosysException ex)
	    {
	        error("Telosys Exception : " + ex.getMessage());
	        ex.printStackTrace();
	    }
	    */
    }

}
