package org.demo.env;

import org.objectweb.telosys.auth.IAppUser;

/**
 * Application User class example
 *
 */
public class User implements IAppUser
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Comment for <code>PROFILE_STANDARD</code>
	 */
	public static final int PROFILE_STANDARD = 0;

	/**
	 * Comment for <code>PROFILE_ADMIN</code>
	 */
	public static final int PROFILE_ADMIN = 1;

	/**
	 * <code>_sLogin</code> Login de l'utilisateur
	 */
	private String _sLogin = "";

	/**
	 * <code>_sNom</code> Nom de l'utilisateur
	 */
	private String _sNom = "";

	/**
	 * <code>_sNom</code> Nom de l'utilisateur
	 */
	private String _sRole = "";

	/**
	 * <code>_iProfile</code> Profile de l'utilisateur
	 */
	private int _iProfile = PROFILE_STANDARD;

	/**
	 * @param sLogin :
	 * @param sNom :
	 * @param iProfile :
	 */
	public User (final String sLogin, final String sNom, final int iProfile)
	{
		_sLogin = sLogin;
		_sNom = sNom;
		_iProfile = iProfile;
	}

	/**
	 * Page de dmarrage de l'utilisateur
	 * 
	 * @see org.telosys.demo.auth.IAppUser#getFirstPage()
	 */
	public final String getFirstPage()
	{
		return null; // Page par dfaut
	}

	/**
	 * Langue de l'utilisateur
	 * 
	 * @see org.telosys.demo.auth.IAppUser#getLanguage()
	 */
	public final String getLanguage()
	{
		return "FR"; // Inutilis
	}

	/**
	 * @return :
	 */
	public final int getProfile()
	{
		return _iProfile;
	}

	/**
	 * @return :
	 */
	public final String getNom()
	{
		return _sNom;
	}

	/**
	 * @return :
	 */
	public final String getLogin()
	{
		return _sLogin;
	}

	/**
	 * @return :
	 */
	public final String getRole()
	{
		return _sRole;
	}

	/**
	 * @return :
	 */
	public final boolean isAdmin()
	{
		return (_iProfile == PROFILE_ADMIN ? true : false);
	}
}