/*
 * TEST2data manager 
 * Created on 12 juil. 2010 ( Time 18:16:27 )
 */

package org.demo.screen.test2;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.dal.dao.DatabaseSession;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenRequestParameters;
import org.objectweb.telosys.rpl.ScreenResponse;
import org.objectweb.telosys.screen.core.ScreenContext;
import org.objectweb.telosys.screen.core.ScreenData;
import org.objectweb.telosys.screen.core.ScreenError;
import org.objectweb.telosys.screen.core.StandardScreenManager;
import org.objectweb.telosys.screen.env.ScreenSession;


/**
 * TEST2data manager ( server-side actions implementation )
 * 
 * Manager without database actions, just to check the XML dialog between client and server
 * 
 * @author Telosys Team
 *
 */
public class Test2Mgr extends StandardScreenManager
{

    /**
     * Default constructor.
     */
    public Test2Mgr()
    {
		//super( TEST2data.class ); // Use the default database
		//super( TEST2data.class, 1 ); // Use the database #1
		super( Test2Data.class, NO_DATABASE ); // Do not use any database
	}

    
    @Override
	public void onCreate(ScreenContext screenContext,
			ScreenRequestParameters params, ScreenSession screenSession,
			DatabaseSession dbSession) throws TelosysException 
	{
    	System.out.println("TEST2 context created on the server side");
    }


	@Override
	public void onReuse(ScreenContext screenContext,
			ScreenRequestParameters params, ScreenSession screenSession,
			DatabaseSession dbSession) throws TelosysException
	{
    	System.out.println("TEST2 context reused on the server side");
    }


	private void notImplemented(ScreenResponse response)
    {
    	response.addError( new ScreenError(1, "Action not implemented on the server side") );    	
    }
    
	public void load(ScreenData screenData, ScreenContext context, ScreenRequest request, ScreenResponse response, DatabaseSession dbSession) throws TelosysException 
	{
    	notImplemented(response);
	}

	public void save(ScreenData screenData, ScreenContext context, ScreenRequest request, ScreenResponse response, DatabaseSession dbSession) throws TelosysException 
	{
    	notImplemented(response);
	}

	public void insert(ScreenData screenData, ScreenContext context, ScreenRequest request, ScreenResponse response, DatabaseSession dbSession) throws TelosysException 
	{
    	notImplemented(response);
	}

	public void update(ScreenData screenData, ScreenContext context, ScreenRequest request, ScreenResponse response, DatabaseSession dbSession) throws TelosysException 
	{
    	notImplemented(response);
	}

	public void delete(ScreenData screenData, ScreenContext context, ScreenRequest request, ScreenResponse response, DatabaseSession dbSession) throws TelosysException 
	{
    	notImplemented(response);
	}
}