package org.demo.service.rpc;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.View;
import org.objectweb.telosys.screen.env.ScreenSession;
import org.objectweb.telosys.service.ServiceRequest;
import org.objectweb.telosys.service.ServiceResponse;
import org.objectweb.telosys.service.StandardScreenService;

/**
 * Simple "Add" service 
 * 
 * @author Telosys Team
 *  
 */
public class Add extends StandardScreenService //implements ScreenService
{
    /* (non-Javadoc)
     * @see org.objectweb.telosys.service.ScreenService#execute(org.objectweb.telosys.screen.env.ScreenSession, org.objectweb.telosys.service.ServiceRequest, org.objectweb.telosys.service.ServiceResponse)
     */
    public View execute(ScreenSession screenSession, ServiceRequest serviceRequest, ServiceResponse serviceResponse) throws TelosysException
    {
        //--- Get parameters without default values 
        long p1 = serviceRequest.getParamAsLong("p1");
        long p2 = serviceRequest.getParamAsLong("p2");

        //--- Get parameters with default values 
        // long p1 = serviceRequest.getParamAsLong("p1", 0);
        // long p2 = serviceRequest.getParamAsLong("p2", 0);
        
        System.out.println("Add : " + p1 + " + " + p2 );
        
        
        long iResult = p1 + p2 ;
        
        //--- Set the response values
        serviceResponse.setValue("result", iResult );
        serviceResponse.setValue("p1", p1 );
        serviceResponse.setValue("p2", p2 );

        return null ; // AJAX call => no forward to a View
    }
}