package org.demo.service.rpc;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.View;
import org.objectweb.telosys.screen.env.ScreenSession;
import org.objectweb.telosys.service.ServiceRequest;
import org.objectweb.telosys.service.ServiceResponse;
import org.objectweb.telosys.service.StandardScreenService;

/**
 * Simple "Ping" service for server testing
 *  
 * @author Telosys Team
 * 
 */
public class Ping extends StandardScreenService
{
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.objectweb.telosys.service.ScreenService#execute(org.objectweb.telosys.screen.env.ScreenSession,
	 *      org.objectweb.telosys.service.ServiceRequest,
	 *      org.objectweb.telosys.service.ServiceResponse)
	 */
	public View execute(ScreenSession screenSession,
			ServiceRequest serviceRequest, ServiceResponse serviceResponse)
			throws TelosysException 
	{
		//--- Set a response value
		serviceResponse.setValue("status", "Ping OK (service server responding) ");
		serviceResponse.setValue("tip", "Take a look at my Java class : " + this.getClass().getName() );
		
		//--- Set the response object
		//serviceResponse.setResult("Ping OK (service server responding) ");

		return null; // RPC ( AJAX call ) => no View to return
	}
}