// Telosys build number : 2098 - Date : October-6-2010 (14:40) - Version : 1.1.0.b 
//------------------------------------------------------------------------------
// TelosysConst_class.js : provides constants
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function TelosysConst()
{
}
//------------------------------------------------------------------------------
TelosysConst.getRequestEndOfLine = function ()
{
	return "\r\n" ;
}
//------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
// Common
//----------------------------------------------------------------------------------------------------
function fwkError(msg)
{
	alert("Telosys JavaScript Framework \nRuntime ERROR :\n" + msg ) ;
}
//----------------------------------------------------------------------------------------------------
function $(sId)
{
	if ( sId == null )
	{
		fwkError("$(id) : Parameter 'id' is null" ) ;
		return null ;
	}
	if ( typeof sId != "string" )
	{
		fwkError("$(id) : Parameter 'id' is not a string ( type = " + typeof sId + " )" ) ;
		return null ;
	}
	var obj = document.getElementById(sId) ; 
	if ( obj == null )
	{
		fwkError("$("+sId+") : Cannot found object for id '"+sId+"'" ) ;
		return null ;
	}
	return obj ;
}
//----------------------------------------------------------------------------------------------------
// Returns the object corresponding to the given argument ( object Id or already an object reference )
//----------------------------------------------------------------------------------------------------
function fwkGetObject(arg, argFuncName )
{
	var sFuncName = ( argFuncName != null ? argFuncName : "fwkGetObject" ) ;
	if ( typeof arg == "string" )
	{
		var obj = document.getElementById(arg) ; 
		if ( obj != null )
		{
			return obj ;
		}
		else
		{
			fwkError( sFuncName + "("+arg+") : Cannot found object for id '"+arg+"'" ) ;
			return null ;
		}
	}
	else if ( typeof arg == "object" )
	{
		return arg ; 
	}
	else
	{
		fwkError ( sFuncName + "() invalid argument type ! ( type = " + typeof arg + " )" ) ;
	}
	return null ;
}
//----------------------------------------------------------------------------------------------------
function fwkGetField(sId)
{
	var oField = document.getElementById(sId) ; 
	if ( oField == null )
	{
		fwkError("fwkGetField() : Cannot found object for id "+sId ) ;
	}
	return oField ;
}
//----------------------------------------------------------------------------------------------------
// CHECKED / NOT CHECKED  ( Check Box and Radio Button )
//----------------------------------------------------------------------------------------------------
function fwkSetChecked(arg, bStatus)
{
	var oField = fwkGetObject(arg, "fwkSetChecked");
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			oField.checked = bStatus ;
		}
		else
		{
			fwkError( "fwkSetChecked() : the given object is not a checkbox or a radio button ! ") ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsChecked(arg)
{
	var oField = fwkGetObject(arg, "fwkIsChecked");
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			return oField.checked ;
		}
		else
		{
			fwkError( "fwkIsChecked() : the given object is not a checkbox or a radio button ! ") ;
		}
	}
	return false  ;
}
//----------------------------------------------------------------------------------------------------
// VALUE
//----------------------------------------------------------------------------------------------------
function fwkGetValue(arg)
{
	var oField = fwkGetObject(arg, "fwkGetValue");
	if ( oField != null )
	{
		if ( oField.getValue ) 
		{
			//--- If the field has a specific "getValue" method ( set by RegisterField ) => use it
			return oField.getValue() ;
		}
		else
		{
			//--- Else (no RegisterField) => try to get the value using the "classic way"
			if ( oField.type == "checkbox" )
			{
				//alert ( "checkbox object" );
				if ( oField.checked ) 
				{
					//alert ( "checkbox CHECKED => return value " );
					return oField.value ;
				}
				/***
				else
				{
					alert ( "checkbox NOT CHECKED => return valueoff if any " );
					if ( oField.valueoff ) // Never defined in FF1, OK in IE
					{
						return oField.valueoff ;		
					}
				}
				**/
				// else : standard HTML : not checked => no value
				return null ;
			}
			else
			{		
				// if ( oField.value ) Do not use this test because value is null when the field is empty
				if ( "value" in oField ) // Check attribute by introspection 
				{
					return oField.value ;		
				}
				else
				{
					fwkError ( "fwkGetValue() : No 'value' attribute for field '" + arg + "' !") ;
				}
			}
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetValue(arg,sValue)
{
	var oField = fwkGetObject(arg, "fwkSetValue");
	if ( oField != null )
	{
		if ( oField.setValue ) 
		{
			//--- If the field has a specific "setValue" method ( set by RegisterField ) => use it
			oField.setValue(sValue) ;
		}
		else
		{
			//--- Else (no RegisterField) => try to get the value using the "classic way"
			if ( oField.type == "checkbox" || oField.type == "radio" )
			{
				fwkError ( "fwkSetValue() : Do not use 'fwkSetValue' on a 'checkbox' or 'radio' field  \n"
				+ "without a Screen Body ( because the field is not 'Registered' ).\n" 				
				+ "Use 'fwkSetChecked' instead." ) ;				
			}
			else
			{
				// if ( oField.value ) Do not use this test because value is null when the field is empty
				if ( "value" in oField ) // Check attribute by introspection 
				{
					oField.value = sValue ;
				}
				else
				{
					fwkError ( "fwkSetValue() : No 'value' attribute for field '" + arg + "' !") ;
				}
			}
		}
	}
}
//----------------------------------------------------------------------------------------------------
// NAME
//----------------------------------------------------------------------------------------------------
function fwkGetName(arg)
{
	var obj = fwkGetObject(arg, "fwkGetName");
	if ( obj != null )
	{
		if ( "name" in obj ) // Check attribute by introspection 
		{
			return obj.name ;
		}
		else
		{
			fwkError ( "fwkGetName() : No 'name' attribute for field '" + arg + "' !") ;
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// TYPE
//----------------------------------------------------------------------------------------------------
function fwkGetType(arg)
{
	var obj = fwkGetObject(arg, "fwkGetType");
	if ( obj != null )
	{
		if ( "type" in obj ) // Check attribute by introspection 
		{
			return obj.type ;
		}
		else
		{
			fwkError ( "fwkGetName() : No 'type' attribute for field '" + arg + "' !") ;
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// POSITION (X,Y) 
// Return an array ( [0]->X, [1]->Y ) or null 
//----------------------------------------------------------------------------------------------------
function fwkGetXY(arg)
{
	var obj = fwkGetObject(arg, "fwkGetXY");
	if ( obj != null )
	{		
		var posX = obj.offsetLeft ;
		var posY = obj.offsetTop;
		//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		//--- If the object is nested into another one ( always at least the "BODY" tag )
		while ( obj.offsetParent ) 
		{
			obj = obj.offsetParent ;
			posX += obj.offsetLeft;
			posY += obj.offsetTop;
			//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		}
		return [ posX, posY ];
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// Returns the POSITION (X,Y) as an array ( [0]->X, [1]->Y ) or null
// The origin (0,0) is the first parent element with position="relative"
//----------------------------------------------------------------------------------------------------
function fwkGetRelativeXY(arg)
{
	var obj = fwkGetObject(arg, "fwkGetRelativeXY");
	if ( obj != null )
	{		
		var posX = obj.offsetLeft ;
		var posY = obj.offsetTop;
		//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		//--- If the object is nested into another one ( always at least the "BODY" tag )
		while ( obj.offsetParent ) 
		{
			obj = obj.offsetParent ;
			if ( obj.style.position == "relative" ) break; // Stop here (this is the XY reference)
			posX += obj.offsetLeft;
			posY += obj.offsetTop;
			//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		}
		return [ posX, posY ];
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// Show an object ( set visible ) at the given X/Y coordinates
//----------------------------------------------------------------------------------------------------
function fwkShowXY(arg, x, y)
{
	//alert("fwkShowXY ( " + arg + ", " + x + ", " + y + ") " );
	var obj = fwkGetObject(arg, "fwkShowXY");
	if ( obj != null )
	{		
		//alert("fwkShowXY : object " + arg + " : found " );
		obj.style.visibility = "visible" ;
		obj.style.position = "absolute" ;
		if ( x != null && y != null )
		{
			obj.style.left = x + "px" ;
			obj.style.top  = y + "px" ;
		}
		else
		{
			obj.style.left = "0px" ;
			obj.style.top  = "0px" ;
			fwkError("fwkShowXY() : argument X or Y is null !");
		}
	}
}

//----------------------------------------------------------------------------------------------------
// Inner HTML
//----------------------------------------------------------------------------------------------------
function fwkGetInnerHTML(arg)
{
	var obj = fwkGetObject(arg, "fwkGetInnerHTML" );
	if ( obj != null )
	{
		if ( "innerHTML" in obj ) // Check attribute by introspection 
		{
			return obj.innerHTML ;
		}
		else
		{
			fwkError("fwkGetInnerHTML() : No 'innerHTML' attribute for this object !");
		}
	}
	return null ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetInnerHTML(arg,sNewHTML)
{
	var obj = fwkGetObject(arg, "fwkSetInnerHTML");
	if ( obj != null )
	{
		if ( "innerHTML" in obj ) // Check attribute by introspection 
		{
			obj.innerHTML = sNewHTML ;
		}
		else
		{
			fwkError("fwkSetInnerHTML() : No 'innerHTML' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkExecuteInnerScript(arg) 
{
	var element = fwkGetObject(arg, "fwkExecuteInnerScript");
	if ( element != null )
	{
		var scripts = element.getElementsByTagName("script");
		for(var i=0; i<scripts.length; i++) 
		{
			eval(scripts[i].innerHTML);
		}
	}
}

//----------------------------------------------------------------------------------------------------
// ENABLE / DISABLE 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonDisabled(oField, bDisabled)
{
	if ( oField != null )
	{
		if ( oField.id != null )
		{
			var sPictoId = oField.id + "_picto" ;
			var oPicto = document.getElementById(sPictoId);
			if ( oPicto != null )
			{
				if ( oPicto.tagName == "IMG" ) 
				{
					oPicto.style.visibility = ( bDisabled ? "hidden" : "visible" ) ;
				}
			}
			else
			{
				var sButtonId = oField.id + "_button" ;
				var oButton = document.getElementById(sButtonId);
				if ( oButton != null )
				{
					if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
					{
						oButton.disabled = bDisabled ;
					}
					else if ( oButton.tagName == "BUTTON" ) 
					{
						oButton.disabled = bDisabled ;
					}
					else if ( oButton.tagName == "IMG" ) 
					{
						oButton.style.visibility = ( bDisabled ? "hidden" : "visible" ) ;
					}
				}		
			}
		}
	}
	else
	{
		fwkError("fwkSetFieldButtonDisabled() : Field argument is null !");	
	}
}
//----------------------------------------------------------------------------------------------------
function fwkEnable(arg)
{
	var obj = fwkGetObject(arg, "fwkEnable");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			obj.disabled = false ;
			fwkSetFieldButtonDisabled(obj, false);
		}
		else
		{
			fwkError("fwkEnable() : No 'disabled' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkDisable(arg)
{
	var obj = fwkGetObject(arg, "fwkDisable");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			obj.disabled = true ;
			fwkSetFieldButtonDisabled(obj, true);
		}
		else
		{
			fwkError("fwkDisable() : No 'disabled' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsEnabled(arg)
{
	var obj = fwkGetObject(arg, "fwkIsEnabled");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			return ( obj.disabled != true ? true : false ) ;
		}
		else
		{
			fwkError("fwkIsEnabled() : No 'disabled' attribute for this object !");
		}
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// VISIBILITY 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonVisibility(oField, sVisibility)
{
	if ( oField != null )
	{
		if ( oField.id != null )
		{
			var sPictoId = oField.id + "_picto" ;
			var oPicto = document.getElementById(sPictoId);
			if ( oPicto != null )
			{
				if ( oPicto.tagName == "IMG" ) 
				{
					oPicto.style.visibility = sVisibility ;
				}
			}
			else
			{
				var sButtonId = oField.id + "_button" ;
				var oButton = document.getElementById(sButtonId);
				if ( oButton != null )
				{
					if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
					else if ( oButton.tagName == "BUTTON" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
					else if ( oButton.tagName == "IMG" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
				}		
			}
		}
	}
	else
	{
		fwkError("fwkSetFieldButtonVisibility() : Field argument is null !");	
	}	
}
//----------------------------------------------------------------------------------------------------
function fwkSetVisible(arg)
{
	var obj = fwkGetObject(arg, "fwkSetVisible");
	if ( obj != null )	
	{
		obj.style.visibility = "visible" ;
		fwkSetFieldButtonVisibility(obj, "visible");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkSetHidden(arg)
{
	var obj = fwkGetObject(arg, "fwkSetHidden");
	if ( obj != null )	
	{
		obj.style.visibility = "hidden" ;
		fwkSetFieldButtonVisibility(obj, "hidden");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsVisible(arg)
{
	var obj = fwkGetObject(arg, "fwkIsVisible");
	if ( obj != null )	
	{
		if ( obj.style.visibility == "visible" ) return true ;
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// READONLY
//----------------------------------------------------------------------------------------------------
function fwkSetReadonly(arg, bStatus)
{
	var obj = fwkGetObject(arg, "fwkSetReadonly");
	if ( obj != null )
	{
		if ( "readOnly" in obj ) // Check attribute by introspection 
		{
			obj.readOnly = bStatus ;
		}
		else
		{
			fwkError("fwkSetReadonly() : No 'readOnly' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsReadonly(arg)
{
	var obj = fwkGetObject(arg, "fwkIsReadonly");
	if ( obj != null )
	{
		if ( "readOnly" in obj ) // Check attribute by introspection 
		{
			return ( obj.readOnly ? true : false ) ;
		}
		else
		{
			fwkError("fwkIsReadonly() : No 'readOnly' attribute for this object !");
		}
	}
	return false  ;
}

//----------------------------------------------------------------------------------------------------
function fwkExecInnerScript( obj ) // v 1.1.0 : deprecated ( DO NOT USE )
{
	if ( obj != null )
	{
		var scripts = obj.getElementsByTagName("script");
		for(var i=0; i<scripts.length; i++) 
		{
			// Execute the content of the <script> tag
			eval(scripts[i].innerHTML); 
		}
	}
	else
	{
    	fwkError("fwkExecInnerScript : null parameter !");
	}
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows a view content in the given container
 * @param  String  the container id or object
 * @param  String  the view content to set in the 'innerHTML' of the container 
 * @return none
 */	
function fwkShowViewContent(pContainer, viewContent)
{
    //if ( pContainer  == null ) { fwkError("fwkShowViewContent : container parameter is null !" ) ; return ; }
    if ( viewContent == null ) { fwkError("fwkShowViewContent : view content parameter is null !" ) ; return ; }

    var oContainer = fwkGetObject(pContainer, "fwkShowViewContent");
    if ( oContainer != null )
    {
        oContainer.innerHTML = viewContent ; // Set the content 
        if ( viewContent != "" )
        {
	        //fwkExecInnerScript( oContainer ); // v 1.1.0
	        fwkExecuteInnerScript(oContainer) ; // v 1.1.0
        }
		//--- If the container has a "onpopulate" event script => call it
		var sScript = oContainer.onpopulate ;
		if ( sScript != null )
		{
			eval ( sScript ) ;
		}
    }
//    else
//    {
//    	fwkError("fwkShowViewContent : Container '" + sContainerId + "' not found in this screen !");
//    }
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows a view of an action response in the given container
 * @param  String  the container id or object
 * @param  Object  the response 
 * @param  String  the view name 
 * @return none
 */	
function fwkShowActionView(pContainer, oResponse, sViewTagName)
{
    if ( pContainer   == null ) { fwkError("fwkShowActionView : container parameter is null !" ) ; return ; }
    if ( oResponse    == null ) { fwkError("fwkShowActionView : response parameter is null !" ) ; return ; }
    if ( sViewTagName == null ) { fwkError("fwkShowActionView : view name parameter is null !" ) ; return ; }
    
    var viewContent = oResponse.getViewContent(sViewTagName) ;
    if ( viewContent != null ) 
    {
		fwkShowViewContent(pContainer, viewContent);
    } 
    else 
    {
		fwkShowViewContent(pContainer, "");
    }
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows the unique view of a service response in the given container
 * @param  String  the container id or object
 * @param  Object  the service response 
 * @return none
 */	
function fwkShowServiceView(pContainer, oResponse)
{
    if ( pContainer == null ) { fwkError("fwkShowServiceView : container parameter is null !" ) ; return ; }
    if ( oResponse  == null ) { fwkError("fwkShowServiceView : response parameter is null !" ) ; return ; }

    var viewContent = oResponse.getServiceViewContent() ;
    if ( viewContent != null ) 
    {
		fwkShowViewContent(pContainer, viewContent);
    } 
    else 
    {
		fwkShowViewContent(pContainer, "");
    }
}

//----------------------------------------------------------------------
function fwkGetIFrameDocument( arg )
{
	var iframe = fwkGetObject(arg, "fwkGetIFrameDocument");
	if ( iframe != null )
	{
		if ( iframe.contentWindow != null ) // IE + FF 
		{
			return iframe.contentWindow.document;
		}
		else if ( iframe.contentDocument != null )
		{
			return iframe.contentDocument;
		}
		else if ( iframe.document != null )
		{
			return iframe.document;
		}
		else
		{
			fwkError ( "fwkGetIFrameDocument() : Cannot get frame content !" ) ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkGetParentDIV(o)
{
//log.warning("fwkGetParentDIV(..)" );
	if ( o == null ) return null ;
	while ( o.parentNode != null )
	{
		o = o.parentNode ;
		if ( o.nodeName == "DIV" ) return o ;
	}
	return null ;
}
//---------------------------------------------------------------------------
function fwkCancelEvent( evt ) // Stop the event NOW !
{
//log.error("fwkCancelEvent( evt ) ++++++++++++++ ");
	if ( evt != null )
	{
		if ( evt.srcElement != null ) // Internet Explorer 
		{
			evt.cancelBubble = true; // Stop propagation 
			evt.returnValue = false; // No default action 
		}
		else if ( evt.target ) // FireFox
		{
			evt.stopPropagation(); // Stop propagation 
			evt.preventDefault(); // No default action 
		}
	}
	else
	{
		fwkError("fwkCancelEvent() : event is null !")
	}
}
//---------------------------------------------------------------------------
/*
 sURL 
 . "http://xxxxx"
 . "new_page" : load new_page using the same path as the current page ( path/current_page -> path/new_page ) 
 . ".." : path1 of path1/path2/current_page
 . "." : path of path/current_page
 . "../.." 
 . "../new_path"
 . "/" : host root ( e.g. : "http://host:8080/" )
*/
function fwkLoadPage(sURL) 
{
	if ( sURL != null && sURL != "" )
	{
		window.location = sURL ; // new entry in history
	}
	else
	{
		fwkError ( "fwkLoadPage : URL is null or void !" ) ;
	}
}
function fwkReplacePage(sURL)
{
	if ( sURL != null && sURL != "" )
	{
		window.location.replace(sURL) ; // same entry in history
	}
	else
	{
		fwkError ( "fwkReplacePage : URL is null or void !" ) ;
	}	
}
function fwkReloadPage() 
{
	window.location.reload() ;
}
//---------------------------------------------------------------------------
function fwkGetLocation() 
{
	return window.location.href ;
}
//---------------------------------------------------------------------------
function fwkSetFocus(arg) 
{
	var o = fwkGetObject(arg, "fwkSetFocus");
	if ( o != null )	
	{
		o.focus();
	}
}
//---------------------------------------------------------------------------
function fwkSubmitForm(arg) 
{
	var o = fwkGetObject(arg, "fwkSubmitForm");
	if ( o != null )	
	{
		o.submit();
	}
}
//---------------------------------------------------------------------------
function fwkResetForm(arg) 
{
	var o = fwkGetObject(arg, "fwkResetForm");
	if ( o != null )	
	{
		o.reset();
	}
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Tools_class.js ( set of static methods )
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function Tools()
{
}
//------------------------------------------------------------------------------
Tools.xmlString = function (sVal)
{
	if ( sVal == null )
	{
		return null ;
	}
	var sXml = sVal ;
	sXml = sXml.replace(/&/g, "&amp;" ); // A faire en premier 
	sXml = sXml.replace(/</g, "&lt;" );
 		sXml = sXml.replace(/>/g, "&gt;" );
	sXml = sXml.replace(/\"/g, "&quot;" );
	/**
	if ( sVal.length != sXml.length )
	{
		alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
	}
	**/
	return sXml ;
}
//------------------------------------------------------------------------------
Tools.getElement = function ( arg )
{
	return element ;
}
//------------------------------------------------------------------------------
// Return the position (X,Y) of an element of the current document
// arg    : String => element Id 
//          Other  => element itself
// return : array ( [0] -> x , [1] -> y )
Tools.getPosition = function ( arg )
{
	var oElement = null ;
	if ( typeof arg == "string" )
	{
		//alert ( "Trace: arg is a String => getElementById ('" + arg + "')" );
		oElement = document.getElementById(arg);
		if ( oElement == null )
		{
			alert ( "Error: Tools.getPosition() : Cannot find element with id = '" + arg + "'" );
			return null ;
		}
	}
	else
	{
		//alert ( "Trace: arg is not a String => ref" );
		oElement = arg;
		if ( oElement == null )
		{
			alert ( "Error: Tools.getPosition() : Element is null ! " );
			return null ;
		}
	}
	
	if ( oElement.offsetParent ) 
	{
		for( var posX = 0, posY = 0; oElement.offsetParent ; oElement = oElement.offsetParent ) 
		{
			posX += oElement.offsetLeft;
			posY += oElement.offsetTop;
		}
		return [ posX, posY ];
	} 
	else 
	{
		return [ oElement.x, oElement.y ];
	}
}
//------------------------------------------------------------------------------
Tools.fieldMessageClass = null ;
Tools.fieldMessageXOffset = null ;
Tools.fieldMessageYOffset = null ;
Tools.setFieldMessageClass = function ( sClassName )
{
	Tools.fieldMessageClass = sClassName ;
}
Tools.setFieldMessageOffset = function ( iXOffset, iYOffset )
{
	Tools.fieldMessageXOffset = iXOffset ;
	Tools.fieldMessageYOffset = iYOffset ;
}
//------------------------------------------------------------------------------
Tools.fieldMessage = function (id, msg)
{
	function _onClick()
	{
		//alert("On Click ! this.id = "  + this.id );
		this.style.visibility = "hidden" ;
	}
	
	var position = Tools.getPosition(id); // (X,Y)
	if ( position != null )
	{
		var x = position[0];
		var y = position[1];
		//alert ( "Position : x = " + x + " , y = " + y );
		
		var sBubbleId = id + "_msg" ;
		var oBubble = document.getElementById(sBubbleId);
		if ( oBubble == null ) // Not yet created 
		{
			//alert ( "oBubble == null => createElement" );
			oBubble = document.createElement ( "table" ) ; 
			oBubble.id = sBubbleId ;
			//oBubble.className = "bubble" ;
			if ( Tools.fieldMessageClass != null )
			{
				// Apply style class
				oBubble.className = Tools.fieldMessageClass ;
			}
			else
			{
				// Use default style
				oBubble.style.cursor      = "default" ;
				oBubble.style.borderStyle = "solid" ;
				oBubble.style.borderWidth = "1px" ;
				oBubble.style.borderColor = "orange" ;
				oBubble.style.color       = "navy" ; 
				oBubble.style.fontFamily  = "arial" ;
				oBubble.style.fontSize    = "10pt" ;
				oBubble.style.backgroundColor = "#FFCC66" ;
			}
			oBubble.style.position   = "absolute" ;
			oBubble.style.visibility = "hidden" ;
			oBubble.onclick = _onClick ;
			document.body.appendChild(oBubble);
			//--- Create Row (TR) and Cell (TD)
			var oTR = oBubble.insertRow(0);
			var oTD = oTR.insertCell(0);
		}
		if ( oBubble != null )  
		{
			//alert ( "oBubble != null => set attributes ..." );
			var oTD = oBubble.rows[0].cells[0];
			if ( oTD != null )
			{
				oTD.innerHTML = msg ;
			}
			else
			{
				alert("Error: Cannot find cell ( table.rows[0].cells[0] )" );
			}
			var xOffset = ( Tools.fieldMessageXOffset != null ? Tools.fieldMessageXOffset : 10 ) ;
			var yOffset = ( Tools.fieldMessageYOffset != null ? Tools.fieldMessageYOffset : 12 ) ;
			oBubble.style.left       = x + xOffset ;
			oBubble.style.top        = y + yOffset ;
			oBubble.style.visibility = "visible" ;
		}
		else
		{
			alert ( "Error: Cannot get or create bubble DIV !" ) ;
		}
	}
	else
	{
		alert("Error: Cannot find position for id '" + id + "' !");
	}
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

/**
 * Map class with methods like Java HashMap or Hashtable
 * @author Laurent GUERIN
 */

//------------------------------------------------------------------------------
function Map()
{
	//------------------------------------------------------------------------------
	// PRIVATE INSTANCE ATTRIBUTE(S)
	//------------------------------------------------------------------------------
	var _oMap = new Object ;
	
	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.put = function( key, value )
	{
		if ( key != null )
		{
			_oMap[key] = value ;
		}
	}
	
	//------------------------------------------------------------------------------
	this.get = function( key )
	{
		if ( key != null )
		{
			var value = _oMap[key];
			return ( value === undefined ? null : value )
		}
		return null;
	}
	
	//------------------------------------------------------------------------------
	this.remove = function( key )
	{
		if ( key != null )
		{
			delete _oMap[key];
		}
	}
	
	//------------------------------------------------------------------------------
	this.clear = function()
	{
		for ( var key in _oMap )
		{
			delete _oMap[key];
		}
	}
	
	//------------------------------------------------------------------------------
	this.size = function()
	{
		var i = 0 ;
		for ( var key in _oMap )
		{
			i++ ;
		}
		return i;
	}
	
	//------------------------------------------------------------------------------
	this.containsKey = function(key) 
	{
		if ( key != null )
		{
			return ( _oMap[key] === undefined ? false : true )
		}
		return false;
	}
	
	//------------------------------------------------------------------------------
	this.keysArray = function ()
	{
		var array = new Array();
		for ( var key in _oMap )
		{
			array.push(key);
		}
		return array;
	}
	
	//------------------------------------------------------------------------------
	this.keysString = function ()
	{
		var s = "";
		var i = 0 ;
		for ( var key in _oMap )
		{
			if ( i > 0 ) 
			{
				s += ",";
			}
			s += key ;
			i++;
		}
		return s;
	}
	
	//------------------------------------------------------------------------------
	this.show = function ()
	{
		var s = "";
		for ( var key in _oMap )
		{
			var value = _oMap[key];
			s += "\n. " + key + " : " + value ;
		}
		alert("Map content : " + s);
	}
}

//------------------------------------------------------------------------------
// Browser_class.js 
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Browser()
{
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------
	this.NAV_NULL = 0 ;
	this.NAV_MOZILLA_FIREFOX   = 1 ; 
	this.NAV_INTERNET_EXPLORER = 2 ;

	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	this.iBrowserType = this.NAV_NULL ;
	
	
	//------------------------------------------------------------------------------
	// INITIALIZATIONS
	//------------------------------------------------------------------------------
	{
		//var sNavigName = navigator.appName ;
		if ( navigator.appName.indexOf("Netscape") >= 0 )
		{
			this.iBrowserType = this.NAV_MOZILLA_FIREFOX ;
		}
		else if ( navigator.appName.indexOf("Microsoft") >= 0 )
		{
			this.iBrowserType = this.NAV_INTERNET_EXPLORER ;
		}
	}

	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.isMozilla = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_MOZILLA_FIREFOX ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.isInternetExplorer = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_INTERNET_EXPLORER ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.getType = function() // STRING
	{
		switch ( this.iBrowserType )
		{
			case this.NAV_MOZILLA_FIREFOX :   return "Mozilla/Firefox" ;
			case this.NAV_INTERNET_EXPLORER : return "Internet Explorer" ;
		}
		return "???" ;
	}
	
}
//------------------------------------------------------------------------------
// Static properties
//------------------------------------------------------------------------------
Browser.browser = new Browser() ; 
//------------------------------------------------------------------------------
// Static methods
//------------------------------------------------------------------------------
Browser.getBrowser = function ()
{
	return Browser.browser ;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Keyboard_class.js : keyboard management
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
// Mozilla/Firefox behavior :
// Standard Keys : 1) onKeyPress + 2) onKeyDown ( no order ?,  2 distinct events )
// Fct Keys      : 1) onKeyDown + 2) onKeyPress ( F1..F12, Esc, Tab, Arrows, End, Home, Del )
// CAPS, Ctrl, Alt : onKeyDown ( NO onKeyPress )
//------------------------------------------------------------------------------
// Internet Explorer behavior :
// Standard Keys : onKeyPress ONLY ( NO onKeyDown )
// Fct Keys      : onKeyDown  ONLY ( NO onKeyPress ) ( F1..F12, Tab, )
// ESC Key       : 1) onKeyDown + 2) onKeyPress
// CAPS, Ctrl, Alt, Arrows, End, Home, Del : onKeyDown ( NO onKeyPress )
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function KeyAction(oFct, iType, bStop)
{
	this.oFunction = oFct ;
	this.iEvtType  = iType ;
	this.bStop     = bStop ;
}

//------------------------------------------------------------------------------
// STATIC CONSTANTS
//------------------------------------------------------------------------------
Keyboard.EVT_KEY_PRESS = 1 ;
Keyboard.EVT_KEY_DOWN  = 2 ;

//--- KEY CODES :
Keyboard.ESC = 27 ;
Keyboard.DEL = 46 ;

Keyboard.CTRL = 17 ;
Keyboard.ALT  = 18 ;
Keyboard.INS  = 45 ;
Keyboard.BACKSPACE = 8 ;
Keyboard.SHIFT = 16 ;

Keyboard.ARROW_UP    = 38 ;
Keyboard.ARROW_DOWN  = 40 ;
Keyboard.ARROW_LEFT  = 37 ;
Keyboard.ARROW_RIGHT = 39 ;

Keyboard.HOME      = 36 ;
Keyboard.END       = 35 ;
Keyboard.PAGE_UP   = 33 ;
Keyboard.PAGE_DOWN = 34 ;

Keyboard.F1  = 112 ;
Keyboard.F2  = 113 ;
Keyboard.F3  = 114 ;
Keyboard.F4  = 115 ;
Keyboard.F5  = 116 ;
Keyboard.F6  = 117 ;
Keyboard.F7  = 118 ;
Keyboard.F8  = 119 ;
Keyboard.F9  = 120 ;
Keyboard.F10 = 121 ;
Keyboard.F11 = 122 ;
Keyboard.F12 = 123 ;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Keyboard()
{
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	//this.browser = Browser.getBrowser();
	this.aKeyActions = new Array();
	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.desc = function()
	{
		//return ( "keyboard object for browser " + this.browser.getType() ) ;
		return ( "keyboard object : " + this.aKeyActions + " key(s) mapped") ;
	}
	//------------------------------------------------------------------------------
	this.setKeyAction = function( iKey, oFunction, iEventType )
	{
		//alert ( "setKeyAction : key = " + iKey ) ;
		if ( iKey      == null ) alert ( "ERROR: keyAction() : KEY parameter is null !" );
		if ( oFunction == null ) 
		{
			this.aKeyActions[iKey] = new KeyAction ( null, iEventType, true );
		}
		else
		{		
			if ( ! oFunction instanceof Function ) 
			{
				alert ( "ERROR: keyAction() : ACTION is not a function !" );
			}
			this.aKeyActions[iKey] = new KeyAction ( oFunction, iEventType, true );
		}
	}
	//------------------------------------------------------------------------------
	this.getNbKeyActions = function() // INT
	{
		return this.aKeyActions.length ;
	}
	//------------------------------------------------------------------------------
	this.showKeyActions = function() // VOID
	{
		var action = null ;
		var s = "Key Actions : \n" ;
		for ( var i=0 ; i < this.aKeyActions.length ; i++ )
		{
			action = this.aKeyActions[i];
			if ( action != null )
			{
				s += i + " -> " + action + "\n" ;
			}
		}
		alert(s);
	}
	//------------------------------------------------------------------------------
	this.keyPress = function(evt)
	{
		//alert ( " keyPress " );
		if ( window.event )
		{
			//iKeyCode = event.keyCode ;
			this.processKeyCode(window.event.keyCode, Keyboard.EVT_KEY_PRESS );
		}
		else
		{
			if ( evt ) // Mozilla - Firefox 
			{
				this.processKeyCode(evt.keyCode, Keyboard.EVT_KEY_PRESS, evt);
			}
		}
	}
	//------------------------------------------------------------------------------
	this.keyDown = function(evt)
	{
		//alert ( " keyDown " );
		if ( window.event )
		{
			this.processKeyCode(window.event.keyCode, Keyboard.EVT_KEY_DOWN );
		}
		else
		{
			if ( evt ) // Mozilla - Firefox 
			{
				this.processKeyCode(evt.keyCode, Keyboard.EVT_KEY_DOWN, evt);
			}
		}
		return false ;
	}
	//------------------------------------------------------------------------------
	this.processKeyCode = function(iKeyCode, iEvtType, evt )
	{
		//alert("processKeyCode("+iKeyCode+","+iEvtType+")"  );
		//--- Is there an action associated with this KeyCode ?
		var oAction = this.aKeyActions[iKeyCode] ;
		if ( oAction != null )
		{
			//--- 1) STOP PROPAGATION
			if ( window.event )
			{
			    window.event.cancelBubble = true;
			    window.event.returnValue  = false;
			    window.event.keyCode      = -1 ;
			}
			else
			{
				if ( evt ) // Mozilla - Firefox 
				{
				    evt.stopPropagation();
				    evt.preventDefault();
				    // evt.preventBubble(); // Sans effet
				    // evt.cancelBubble = true ; // Sans effet
				    //evt.keyCode = 0 ; // Impossible (Read-Only)
				}
			}
			//--- 2) CALL THE ACTION FUNCTION
			if ( oAction.iEvtType == iEvtType )
			{
				if ( oAction.oFunction != null )
				{
					oAction.oFunction();
				}
			}
		}
	/***
		else
		{
			alert ( "No specific action for the key " + iKeyCode ) ;
		}
	***/
		//alert("END OF processKeyCode("+iKeyCode+") evt.processed = " + evt.processed );
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
// Static properties
//------------------------------------------------------------------------------
Keyboard.keyboard = new Keyboard() ; 
//------------------------------------------------------------------------------
// Static methods
//------------------------------------------------------------------------------
Keyboard.getKeyboard = function ()
{
	return Keyboard.keyboard ;
}
//------------------------------------------------------------------------------
Keyboard.onKeyPress = function (evt)
{
	//alert ( "Keyboard.onKeyPress " );
	Keyboard.keyboard.keyPress(evt) ;
	//return false ;
}
//------------------------------------------------------------------------------
Keyboard.onKeyDown = function (evt)
{
	//alert ( "Keyboard.onKeyDown " );
	Keyboard.keyboard.keyDown(evt) ;
	//return false ;
}
//------------------------------------------------------------------------------
Keyboard.onHelp = function () // Method to catch the IE "onHelp" event ( F1 key )
{
	window.event.returnValue = false;
	alert("fwkOnHelp");
}
//------------------------------------------------------------------------------
// METHODE : Permet de catcher l'vnement standard sur la touche 'F1'
/**
function document.onhelp()
{
	window.event.returnValue = false;
}
**/		
//------------------------------------------------------------------------------
{
	var browser = Browser.getBrowser() ;
	if ( browser.isInternetExplorer() )
	{
		//alert ( "Keyboard Config for IE" ) ;
		document.onhelp = Keyboard.onHelp ;
		// Only the KeyDown is used 
		document.onkeydown = Keyboard.onKeyDown ;
	}
	if ( browser.isMozilla() )
	{
		//alert ( "Keyboard Config for Mozilla" ) ;
		document.onkeydown  = Keyboard.onKeyDown ;
		document.onkeypress = Keyboard.onKeyPress ;	
		//document.onkeypress = Keyboard.keyboard.keyPress ; // NOT OK ( the instance method doesn't access attributes !) 
	}
}

//------------------------------------------------------------------------------
// ListView_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ListView( sListId, sListName, sItemName, oActions, fResponseProcessor )
{
	//==============================================================================
	// STANDARD ATTRIBUTES & METHODS
	//==============================================================================
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ListView] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	
	//--- Check constructor parameters 
	if ( arguments.length < 4 )
	{
		_error ( "constructor : 4 or 5 arguments expected ( " + arguments.length + " arguments )" ) ;
	}
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _sListId             = sListId ; 
	var _sListName           = sListName ; 
	var _sItemName           = sItemName ; 
	var _oActions            = oActions ;
	var _fResponseProcessor  = fResponseProcessor ;
	
	var _sSelectedRowColor   = "D2CDAC" ; // Default selected color
	var _sOriginalRowColor   = null ;
	
	var _oSelectedRow        = null ; // the row <TR> currently selected
	
	var _eventSelectRow      = null ;
	var _eventInsertRow      = null ;
	var _eventAddRow         = null ;
	var _eventDeleteRow      = null ;
	var _eventClearList      = null ;
	var _eventSortList       = null ;
	
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _chekEvent( oFunction )
	{
		if ( oFunction == null )
		{
			_error ( "setEvent : no FUNCTION argument ! ");
			return null ;
		}
		if ( typeof oFunction != "function" )
		{
			_error ( "setEvent : the argument is not a function ! ");
			return null ;
		}
		return oFunction ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	// Setters
	//------------------------------------------------------------------------------
	this.setSelectedRowColor = function ( sColor ) 
	{
		_sSelectedRowColor = sColor ;
	}
	//------------------------------------------------------------------------------
	this.setEventSelectRow = function ( oFunction ) 
	{		
		_eventSelectRow = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	this.setEventInsertRow = function ( oFunction ) 
	{
		_eventInsertRow = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	this.setEventAddRow = function ( oFunction ) 
	{
		_eventAddRow = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	this.setEventDeleteRow = function ( oFunction ) 
	{
		_eventDeleteRow = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	this.setEventClearList = function ( oFunction ) 
	{
		_eventClearList = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	this.setEventSortList = function ( oFunction ) 
	{
		_eventSortList = _chekEvent( oFunction );
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// Getters
	//------------------------------------------------------------------------------
	this.getListId = function() 
	{
		return _sListId ;
	}
	//------------------------------------------------------------------------------
	this.getListName = function() 
	{
		return _sListName ;
	}
	//------------------------------------------------------------------------------
	this.getItemName = function() 
	{
		return _sItemName ;
	}
	//------------------------------------------------------------------------------
	this.getActions = function() 
	{
		return _oActions ;
	}
	//------------------------------------------------------------------------------
	this.getResponseProcessor = function() 
	{
		return _fResponseProcessor ;
	}
	//------------------------------------------------------------------------------
	this.getSelectedRow = function () 
	{
		return _oSelectedRow ;
	}
	//------------------------------------------------------------------------------
	this.getSelectedRowIndex = function () 
	{
		if ( _oSelectedRow != null )
		{
			return _oSelectedRow.rowIndex ;
		}
		return -1 ;
	}
	//------------------------------------------------------------------------------
	this.getSelectedRowColor = function () 
	{
		return _sSelectedRowColor ;
	}
	//------------------------------------------------------------------------------
	this.show = function () 
	{
		var sActions = ( _oActions != null ) ? "set (not null)" : "not set (null)"  ;
		var sResponseProcessor = ( _fResponseProcessor != null ) ? "set (not null)" : "not set (null)"  ;
		
		var sMsg = "ListView instance : " ;
		sMsg += "\n . List Id   : " + _sListId ;
		sMsg += "\n . List Name : " + _sListName ;
		sMsg += "\n . Item Name : " + _sItemName  ;
		sMsg += "\n . Selected row color : " + _sSelectedRowColor ; 
		sMsg += "\n . Actions   : " + sActions ;
		sMsg += "\n . Response Processor : " + sResponseProcessor ;
		alert( sMsg ); 
	}
	//------------------------------------------------------------------------------
	this.highlightRow = function(oTR) 
	{
		if ( oTR == null ) { _error ( "highlightRow : TR argument is null ! "); return; }
		//--- Restore the original color of the current selected row 
		if ( _oSelectedRow != null && _sOriginalRowColor != null )
		{
			// oTBody.selectedRow.style.backgroundColor = oTBody.originalRowColor ;  //--- Normal color
			_oSelectedRow.style.backgroundColor = _sOriginalRowColor ;
		}
		//--- Highlight the given row 
		//oTBody.originalRowColor = oTR.style.backgroundColor ;
		//oTBody.selectedRow = oTR ;
		//oTBody.selectedRow.style.backgroundColor = oListView.getSelectedRowColor() ; //--- Selected color	
		_sOriginalRowColor = oTR.style.backgroundColor ;
		_oSelectedRow = oTR ;
		_oSelectedRow.style.backgroundColor = _sSelectedRowColor ;		
	}
	//------------------------------------------------------------------------------
		
	//------------------------------------------------------------------------------
	// LIST MANAGEMENT METHODS
	//------------------------------------------------------------------------------
	//this.doSelect = function(iOldRowIndex, iNewRowIndex) 
	this.doSelect = function(iNewRowIndex) 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventSelectRow != null )
		{
			bOkToContinue = _eventSelectRow( _sListName, _sItemName, iOldRowIndex, iNewRowIndex );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListSelect ( _sListName, _sItemName, iOldRowIndex, iNewRowIndex ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
	this.doInsert = function(iNewRowIndex) 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventInsertRow != null )
		{
			bOkToContinue = _eventInsertRow( _sListName, _sItemName, iOldRowIndex, iNewRowIndex );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListInsert ( _sListName, _sItemName, iOldRowIndex, iNewRowIndex ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
	this.doAdd = function() 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventAddRow != null )
		{
			bOkToContinue = _eventAddRow( _sListName, _sItemName, iOldRowIndex );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListAdd ( _sListName, _sItemName, iOldRowIndex ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
	this.doDelete = function(iRowIndexToDelete) 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventDeleteRow != null )
		{
			bOkToContinue = _eventDeleteRow( _sListName, _sItemName, iOldRowIndex, iRowIndexToDelete );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListRemove ( _sListName, _sItemName, iOldRowIndex, iRowIndexToDelete ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
	this.doClear = function() 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventClearList != null )
		{
			bOkToContinue = _eventClearList( _sListName, _sItemName, iOldRowIndex );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListClear ( _sListName, _sItemName, iOldRowIndex ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
	this.doSort = function( sField, sOrder ) 
	{
		var iOldRowIndex = this.getSelectedRowIndex() ;
		var bOkToContinue = true ;
		if ( _eventSortList != null )
		{
			bOkToContinue = _eventSortList( _sListName, _sItemName, iOldRowIndex, sField, sOrder );
		}
		else 
		{
			if ( _oActions != null )
			{
				var response = _oActions.doListSort ( _sListName, _sItemName, iOldRowIndex, sField, sOrder ) ;
				if ( _fResponseProcessor != null )
				{
					bOkToContinue = _fResponseProcessor(response);			
				}
			}
		}
		return bOkToContinue ;
	}
	//------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------
// ListView_func.js
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function fwkBindListView ( oListView )
{
	if ( oListView != null )
	{
		var oTBody = fwkGetTBody ( oListView.getListId() );
		if ( oTBody != null )
		{
			oTBody.listView = oListView ;
		}
		else
		{
			alert("ERROR : fwkBindListView() : cannot get TBody ! id '" + sListID + "'" );		
		}
	}
	else
	{
		alert("ERROR : fwkBindListView() : list view argument is null !" );		
	}
}

//------------------------------------------------------------------------------
function fwkCheckListView( oListView )
{
	if ( oListView == null )
	{
		alert("ERROR : no list view instance in the TBody object ! " );				
	}
}

function fwkPrivateSelectRow( oTR, bSimpleSelect )
{
	//alert ( "TRACE : fwkPrivateSelectRow(...," + bSimpleSelect + " ) ... ");
	
	if ( oTR == null )
	{
		alert ( "ERROR : fwkSelectRow() : no argument ! ");
		return ;
	}

	var oTBody = oTR.parentNode;
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );

	var iNewRowIndex = oTR.rowIndex ;
	if ( iNewRowIndex == oListView.getSelectedRowIndex() )
	{
		//--- This row is already selected => noting to do
		return ; 
	}
	
	var bOkToContinue = true ;
	if ( bSimpleSelect )
	{
		bOkToContinue = oListView.doSelect(iNewRowIndex) ;
	}
	
	if ( bOkToContinue )
	{
		oListView.highlightRow(oTR);
	}
}

function fwkCancelEvent( evt )
{
	if ( window.event ) // Microsoft Internet Explorer
	{
		window.event.cancelBubble = true;   
	}
	else if ( evt != null ) // Mozilla, Netscape, FireFox
	{
		if ( evt.stopPropagation == null ) 
		{
			alert ( "ERROR : fwkCancelEvent : no 'stopPropagation' method in event object ! ");
		}
		else 
		{
			evt.stopPropagation();
		}
	}
}

function fwkGetParent( oObject, sNodeName )
{
	var oParent = oObject.parentNode;
	while ( oParent != null )
	{
		if ( oParent.nodeName == sNodeName )
		{
			return oParent ; // Found
		}
		oParent = oParent.parentNode;
	}
	alert ( "ERROR : Cannot found '" + sNodeName + "' parent node for '" + oObject.nodeName + "' object " );
	return null ;
}

function fwkInitNewRow( oNewTR, oTBody )
{
	//--- Get TABLE
	var oTable = fwkGetParent( oNewTR, "TABLE" );
	if ( oTable == null ) return ;
	
	//--- Get TFOOT (from TABLE)
	var oTFoot = oTable.getElementsByTagName("tfoot")[0] ;
	if ( oTFoot == null ) 
	{ 
		alert ( "ERROR : Cannot found <TFOOT> in <TABLE> " ) ; 
		return;
	}
	
	//--- Get TR (from TFOOT)
	var oTemplateTR = oTFoot.getElementsByTagName("tr")[0] ;
	if ( oTemplateTR == null ) 
	{ 
		alert ( "ERROR : Cannot found <TR> TEMPLATE in <TFOOT>  "  ) ; 
		return;
	}

	//--- Clone the TEMPLATE ROW
	var oClone = oTemplateTR.cloneNode(true); // Std DOM ( OK with IE and FF )
	//--- Replace the new row by the TEMPLATE ROW
	//oNewTR.replaceNode(oClone); // IE DOM extension ( Specific IE )
	oTBody.replaceChild(oClone, oNewTR ); // Std DOM ( OK with IE and FF )
	
	//--- Select the new Row
	fwkPrivateSelectRow( oClone, false );
}

//------------------------------------------------------------------------------
// PUBLIC (visible methods)
//------------------------------------------------------------------------------
function fwkGetTBody ( sId, argAlert )  
{
	var bAlert = true ;
	if ( arguments.length > 1 )
	{
		bAlert = argAlert ;
	}
	//--- Get the rows container ( tbody or table )
	var oElement = document.getElementById(sId);
	if ( oElement == null )
	{
		if ( bAlert ) 
		{
			alert ( "ERROR : fwkGetTBody : No element with id = '" + sId + "'"  ) ;
		}
		return null ; 
	}
	
	//--- Get the TBODY element
	var oTBody = null ;
	if ( oElement.nodeName == "TABLE" )
	{
		oTBody = oElement.getElementsByTagName("tbody")[0] ; ;
	}
	else if ( oElement.nodeName == "TBODY" )
	{
		oTBody = oElement ;
	}
	if ( oTBody == null )
	{
		alert ( "ERROR : fwkGetTBody : Element with id = '" + sId + "' is not a 'TABLE' or 'TBODY' "  ) ;
		return null ; 
	}
	return oTBody ;
}
//------------------------------------------------------------------------------
function fwkSelectRow( oTR )
{
	fwkPrivateSelectRow( oTR, true ) ;
}

//------------------------------------------------------------------------------
function fwkSelectFirstRow( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody )
	{
		if ( oTBody.rows.length > 0 ) 
		{
			fwkPrivateSelectRow( oTBody.rows[0], true ) ;
		}
	}
}

//------------------------------------------------------------------------------
function fwkInsertRow( oObject, evt )
{
	fwkCancelEvent(evt); // Cancel Event (vite Click -> Select Row)

	if ( oObject == null )
	{
		alert ( "ERROR : fwkInsertRow() : no object argument ! ");
		return ;
	}
	
	//--- Get TR
	var oTR = fwkGetParent( oObject, "TR" );
	if ( oTR == null ) return ;
	
	//--- Get TBODY
	var oTBody = fwkGetParent( oTR, "TBODY" );
	if ( oTBody == null ) return ;
	
	var iNewRowIndex = oTR.rowIndex ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );
	var bOkToContinue = oListView.doInsert(iNewRowIndex) ;
	
	if ( bOkToContinue )
	{
		//--- Insert a new row in the TBODY rows collection
		//var oNewTR = oTBody.insertRow(oTR.rowIndex);	
		var oNewTR = oTBody.insertRow(iNewRowIndex);	
		//--- Initialize the new row with the template row and select it
		fwkInitNewRow( oNewTR, oTBody );
	}
}

//------------------------------------------------------------------------------
function fwkAddRow ( sId )  
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doAdd() ;
	
	if ( bOkToContinue )
	{
		//--- Add a new row at the end of the list 
		var oNewTR = oTBody.insertRow( oTBody.rows.length ); // Ok / IE & Mozilla	
		//--- Initialize the new row with the template row and select it
		fwkInitNewRow( oNewTR, oTBody );
	}
}

//------------------------------------------------------------------------------
function fwkDeleteRow (oObject) // NB nom "deleteRow" rserv sous Mozilla 
{
	//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
	//cancelEvent inutile la ligne est supprime => pas de propagation
	if ( oObject == null )
	{
		alert ( "ERROR : fwkInsertRow() : no object argument ! ");
		return ;
	}
	
	//--- Get TR
	var oTR = fwkGetParent( oObject, "TR" );
	if ( oTR == null ) return ;

	//--- Get TBODY
	var oTBody = fwkGetParent( oTR, "TBODY" );
	if ( oTBody == null ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	
	//alert ( "rowIndex to delete : " + oTR.rowIndex );
	var iRowIndexToDelete = oTR.rowIndex ;

	//--- Current Index and Index to delete
	var bDeleteCurrentRow = false ;
	if ( iRowIndexToDelete == oListView.getSelectedRowIndex() )
	{
		bDeleteCurrentRow = true ;
	}
	
	var bOkToContinue = oListView.doDelete(iRowIndexToDelete) ;

	if ( bOkToContinue )
	{
		//--- Delete the row 
		oTBody.deleteRow(iRowIndexToDelete);
		
		//--- Select the new current row 
		if ( bDeleteCurrentRow == true )
		{
			if ( oTBody.rows.length > 0 ) // Si il reste au moins une ligne
			{
				if ( iRowIndexToDelete < oTBody.rows.length )
				{
					fwkPrivateSelectRow( oTBody.rows [ iRowIndexToDelete ], false );
				}
				else
				{
					fwkPrivateSelectRow( oTBody.rows [ oTBody.rows.length-1 ], false ) ;
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
function fwkClearList( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;

	//--- Already void => nothing to do 
	if ( oTBody.rows.length == 0 ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doClear() ;
	
	if ( bOkToContinue )
	{
		//--- Clear the "view" list
		while ( oTBody.rows.length > 0 )
		{
			oTBody.deleteRow(0);
		}	
	}
}
//------------------------------------------------------------------------------
function fwkSortList( sId, sField, sOrder )
{
//alert("fwkSortList( " + sId + ", " + sField + ", " + sOrder + " )" );

	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;

	//--- The list is void => nothing to do 
	if ( oTBody.rows.length == 0 ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doSort(sField, sOrder) ;
	
}

//------------------------------------------------------------------------------
function fwkGetRowCount( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody )
	{
		return oTBody.rows.length ;
	}
	return 0 ;
}

//------------------------------------------------------------------------------
function fwkSetColValue(sId, iColIndex, sValue)
{
	var oTBody = fwkGetTBody ( sId, false ); // No alert if no tbody
	if ( oTBody == null ) return ;

	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var oTR = oListView.getSelectedRow() ;
	

	if ( oTR != null )
	{
		if ( iColIndex < 0 )
		{
			alert("ERROR : fwkSetColValue : invalid column index ( " + iColIndex + " ) < 0 " );
			return ;
		}
		if ( iColIndex >= oTR.cells.length )
		{
			alert("ERROR : fwkSetColValue : invalid column index ( " + iColIndex + " ) >= cells.length ( " + this._currentLineTR.cells.length + " )" );
			return ;
		}
		
		var cell = oTR.cells[iColIndex] ;
		if ( cell != null )
		{
			cell.innerHTML = sValue ;
			//cell.innerText = sValue ; // NOK : do not use
		}
		else
		{
			alert("ERROR : fwkSetColValue : cell[" + iColIndex + "] is null !");
		}
	}
}

/***
//------------------------------------------------------------------------------
// OBJECT "ListDetail"
//------------------------------------------------------------------------------
function ListView( sDivListId )
{
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowUp = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowUp ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveUp : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
	
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex > 0 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex-1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex-1]);		
		}
		else
		{
			alert("On est au dbut !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowDown = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowDown ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveRowDown : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex < this._oTBodyList.rows.length-1 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex+1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex+1]);		
		}
		else
		{
			alert("On est  la fin !");
		}
	}		
	//------------------------------------------------------------------------------	
} //--- End of object definition 
***/
//------------------------------------------------------------------------------
// SimpleDate_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function SimpleDate( sDate, sFormat )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	//--- Date Value  ( 0 => Date Value is NULL )
	var _iDay     = 0 ; 
	var _iMonth   = 0 ; 
	var _iYear    = 0 ; 
	
	//--- Date Format
	var _sFormat      = null ;
	var _parsedFormat = null ;
	
	try {
		if ( sFormat == null )
		{
			sFormat = "YYYY-MM-DD" ; // ISO format
		}
		//--- Build the Date Value
		_buildDate( sDate, sFormat ) ;
	} 
	catch (ex) {
		alert ( "SimpleDate(" + sDate + "," + sFormat + ") : ERROR : " + ex.message );
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _setNull() 
	{
		_iDay     = 0 ; 
		_iMonth   = 0 ; 
		_iYear    = 0 ; 
	}
	//------------------------------------------------------------------------------
	function _parseFormat( sFormat ) // throws Error
	{
		//--- Check format length 
		if ( sFormat.length != 6 && sFormat.length != 8 && sFormat.length != 10 )
		{
			throw new Error ( "Invalid date format " + sFormat + " : length != 6, 8, 10 " ); 
		}
		var sFormatUC = sFormat.toUpperCase();
		
		//--- Separator identification 
		var sSep = null ;
		var iNbSep = 0 ;
		for ( var i = 0 ; i < sFormatUC.length ; i++ ) 
		{
			c = sFormatUC.charAt(i) ;
			if ( c != 'D' && c != 'M' && c != 'Y'  )  // separator
			{
				//alert ( "Separator = " + c ) ;
				if ( sSep != null && sSep != c )
				{
					// 2 different separators => error 
					throw new Error ( "Invalid date format " + sFormat + " : different separators " ); 
				}
				sSep = c ;
				iNbSep++ ;
			}
		}

		//--- Split format parts ( "DD", "MM" and "YY" or "YYYY" ) 
		var arrayFormat = null ;
		if ( iNbSep == 2 ) // 2 separators
		{
			//--- Split the format in 3 parts 
			arrayFormat = sFormatUC.split(sSep);
			if ( arrayFormat.length != 3 )
			{
				throw new Error ( "Invalid date format " + sFormat + " : " + arrayFormat.length + " parts !" ); 
			}
		}
		else if ( iNbSep == 0 ) // No separators
		{
			arrayFormat = new Array(3) ;
			if ( sFormatUC.length == 6 ) //  2c + 2c + 2c 
			{
				arrayFormat[0] = sFormatUC.substr(0,2);
				arrayFormat[1] = sFormatUC.substr(2,2);
				arrayFormat[2] = sFormatUC.substr(4,2);				
			}
			else if ( sFormatUC.length == 8 )
			{
				var iYYYY = sFormatUC.indexOf("YYYY") ;
				if ( iYYYY == 0 ) // Format starts with "YYYY" ( "YYYY...." )
				{
					arrayFormat[0] = sFormatUC.substr(0,4);
					arrayFormat[1] = sFormatUC.substr(4,2);
					arrayFormat[2] = sFormatUC.substr(6,2);									
				}
				else if ( iYYYY == 2 ) // "YYYY" in the middle ( "..YYYY.." )
				{
					arrayFormat[0] = sFormatUC.substr(0,2);
					arrayFormat[1] = sFormatUC.substr(2,4);
					arrayFormat[2] = sFormatUC.substr(6,2);									
				}
				else if ( iYYYY == 4 ) // "YYYY" at the end ( "....YYYY" )
				{
					arrayFormat[0] = sFormatUC.substr(0,2);
					arrayFormat[1] = sFormatUC.substr(2,2);
					arrayFormat[2] = sFormatUC.substr(4,4);									
				}
				else
				{
					throw new Error ( "Invalid date format " + sFormat + " : length = 8 and YYYY not found " ); 
				}
			}
			else
			{
				throw new Error ( "Invalid date format " + sFormat + " : length != 6 and != 8 " ); 
			}
		}
		else
		{
			throw new Error ( "Invalid date format " + sFormat + " : number of separators != 2 " ); 
		}
		
		//--- Check format parts ( "DD", "MM" and "YY" or "YYYY" ) 
		for ( var x=0 ; x < 3 ; x++ )
		{
			var sPart = arrayFormat[x];
			if ( sPart != "DD" && sPart != "MM" && sPart != "YY" && sPart != "YYYY" )
			{
				throw new Error ( "Invalid date format " + sFormat + " : invalid part " + sPart ); 
			}
		}
		
		var parsedFormat = arrayFormat ;
		parsedFormat[3] = sSep ;
		return parsedFormat ;
	}
	//------------------------------------------------------------------------------
	function _parseDate( sDate, parsedFormat ) 
	{
		var sSep = parsedFormat[3] ;
		var parsedDate = null ;
		if ( sSep != null )
		{
			//--- Split the date with the format separator
			parsedDate = sDate.split(sSep);
		}
		else
		{
			//--- Split the date with the format parts 
			parsedDate = new Array(3) ;
			var iStart = 0 ;
			for ( var i=0 ; i < 3 ; i++ )
			{
				var iSize = parsedFormat[i].length ;
				parsedDate[i] = sDate.substr(iStart, iSize ) ;
				iStart = iStart + iSize ;
			}
		}
		return parsedDate ;
	}
	//------------------------------------------------------------------------------
	function _buildDate( sDate, sFormat ) 
	{
		//alert("_buildDate(" + sDate + "," + sFormat + ")" );
		
		var parsedFormat = _parseFormat(sFormat);  // throws Error	

		//--- Keep the format in the instance (original and parsed)
		_sFormat      = sFormat ;
		_parsedFormat = parsedFormat ;

		//--- Build the Date Value
		if ( sDate == null )
		{
			//--- No date value
			_setNull(); 
		}
		else
		{
			_buildDateWithParsedFormat( sDate, parsedFormat );
		}

	}
	//------------------------------------------------------------------------------	
	function _buildDateWithParsedFormat( sDate, parsedFormat )
	{
		var parsedDate   = _parseDate  (sDate, parsedFormat);
		//alert("_buildDateWithParsedFormat : " + sDate + "\n parsedDate = " + parsedDate + "\n parsedFormat = " + parsedFormat );
		
		//--- Get Integer Values for date parts ( Day, Month, Year )
		var iDay   = 0 ;
		var iMonth = 0 ;
		var iYear  = 0 ;
		for ( var i=0 ; i < 3 ; i++ )
		{
			     if ( parsedFormat[i] == "DD" ) iDay   = parseInt( parsedDate[i],10) ;
			else if ( parsedFormat[i] == "MM" ) iMonth = parseInt( parsedDate[i],10) ;
			else if ( parsedFormat[i] == "YY" || parsedFormat[i] == "YYYY" ) 
			{
				iYear  = parseInt(parsedDate[i],10) ;
				if ( iYear < 100 ) iYear = iYear + 2000 ;
			}
		}
		
		//--- If the date parts are valid 
		if ( _isValid( iYear, iMonth, iDay ) )
		{
			//--- Set instance attributes : Day, Month, Year
			_iYear  = iYear ;
			_iMonth = iMonth ;
			_iDay   = iDay ;
		}
		else
		{
			throw new Error ( "Invalid date : " + sDate );
		}
	}
	//------------------------------------------------------------------------------
	function _isValid( iYear, iMonth, iDay ) // boolean
	{
		var aDaysByMonth = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		//--- If lap year, february is one day longer
		if ( ( iYear % 4 == 0 && iYear % 100 != 0 ) || iYear % 400 == 0 )  
		{
			aDaysByMonth[2] = 29  ; // 29 days for February
		}
		if ( ( iYear  < 0 ) || ( iYear  > 9999 ) )  return false ;
		if ( ( iMonth < 1 ) || ( iMonth > 12 ) )  return false ;
		if ( ( iDay   < 1 ) || ( iDay   > aDaysByMonth[iMonth] ) )  return false ;
		//--- OK   
		return true ;		
	}
	//------------------------------------------------------------------------------
	function _format( parsedFormat )  // throws Error
	{
		//alert( "_format( " + parsedFormat + ")" );
		var sFormatedDate = "" ;
		var sSeparator = parsedFormat[3] ;
		if ( sSeparator == null ) sSeparator = "" ;
		//--- For each part of the format ( Day, Month, Year ) ... 
		var sDatePart   = "" ;
		var sFormatPart = null ;
		for ( var i=0 ; i < 3 ; i++ )
		{
			//alert( "_format() i = " + i );
			if ( i > 0 ) 
			{
				sFormatedDate += sSeparator ;
			}
			sFormatPart = parsedFormat[i] ;
			/***
			     if ( sFormatPart.charAt(0) == 'Y' ) sDatePart = ""+_iYear ;
			else if ( sFormatPart.charAt(0) == 'M' ) sDatePart = ""+_iMonth ;
			else if ( sFormatPart.charAt(0) == 'D' ) sDatePart = ""+_iDay ; 
			else throw new Error ( "Invalid format : part = " + sFormatPart );
			if ( sDatePart.length < sFormatPart.length )
			{
				var iDelta = sFormatPart.length - sDatePart.length ;
				     if ( iDelta == 1 ) sDatePart = "0"+sDatePart ;
				else if ( iDelta == 2 ) sDatePart = "00"+sDatePart ;
				else if ( iDelta == 3 ) sDatePart = "000"+sDatePart ;
				else throw new Error ( "Invalid format : part = " + sFormatPart + " invalid length "); 
			}
			***/
			     if ( sFormatPart == "YYYY" ) sDatePart = ""+_iYear ;
			else if ( sFormatPart == "YY"   ) sDatePart = ""+(_iYear%100) ;
			else if ( sFormatPart == "MM"   ) sDatePart = ""+_iMonth ;
			else if ( sFormatPart == "DD"   ) sDatePart = ""+_iDay ; 
			else throw new Error ( "Invalid format : part = " + sFormatPart );
			while ( sDatePart.length < sFormatPart.length )
			{
				sDatePart = "0"+sDatePart ;
			}
			sFormatedDate += sDatePart ;
		}
		return sFormatedDate ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.toString = function () 
	{
		return "day=" + _iDay + " month=" + _iMonth + " year=" + _iYear + " (format=" + _sFormat + ")" ;
	}
	//------------------------------------------------------------------------------
	this.show = function () 
	{
		alert("Date Value : day = " + _iDay + " month = " + _iMonth + " year = " + _iYear
			+ ( this.isNull() ? " ( NULL ) " : "" )
		    + "\nFormat : " + _sFormat 
		    + "\nParsed Format : " + _parsedFormat 
		    ) ;
	}
	//------------------------------------------------------------------------------
	// sFormat can be null (use the initial format )
	this.format = function ( sFormat ) // throws Error
	{
		//alert( "format() : Date = " + this.toString() );
		if ( this.isNull() )
		{
			return null ;
		}
		else
		{
			var sFormatedDate = null ;
			//try {
				var parsedFormat = _parsedFormat ;
				if ( sFormat != null )
				{
					parsedFormat = _parseFormat( sFormat ) ;
				}
				sFormatedDate = _format ( parsedFormat );
			/**
			}
			catch ( ex ) {
				alert ( "ERROR : \nSimpleDate - format() : \n" + ex.message );
			}
			**/
			return sFormatedDate ;
		}
	}
	//------------------------------------------------------------------------------
	this.isNull = function () 
	{
		return ( _iDay == 0 ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.getDay = function () 
	{
		return _iDay ;
	}
	//------------------------------------------------------------------------------
	this.getMonth = function () 
	{
		return _iMonth ;
	}
	//------------------------------------------------------------------------------
	this.getYear = function () 
	{
		return _iYear ;
	}
	//------------------------------------------------------------------------------
	this.getFormat = function () 
	{
		return _sFormat ;
	}
	//------------------------------------------------------------------------------
	this.setFormat = function ( sFormat ) // throws Error
	{
		// try {
			_parsedFormat = _parseFormat( sFormat ); // throws Error
			_sFormat      = sFormat ;
		/**
		}
		catch (ex) {
			alert ( "ERROR : \nSimpleDate - setFormat() : \n" + ex.message );
		}
		**/
	}
	//------------------------------------------------------------------------------
	/**
	 * Set a new date value according with the current format
	 * The current format is only used to know the order of the date parts ( DD, MM, YY )
	 * The new date value can have a separator different from original format ( . - / ) or no separator 
	 **/
	this.setDate = function ( sDate ) // throws Error
	{
		if ( sDate == null )
		{	
			_setNull();
		}
		else
		{
			if ( _parsedFormat == null )
			{
				throw new Error( "Format is null : cannot set date ! " );
			}
			var sSeparator  = null ;
			var sYearFormat = null ;
			if ( sDate.length == 6 ) // Only digits "DD", "MM", "YY"
			{
				sSeparator  = null ; // no separator
				sYearFormat = "YY" ; // Year on 2 digits
			}
			else if ( sDate.length == 8 ) // 6 digits + 2 separators OR 8 digits 
			{
				if ( sDate.indexOf("/") >= 0 ) // At least a "/"
				{
					sSeparator  = "/" ;  // separator
					sYearFormat = "YY" ; // Year on 2 digits
				}
				else if ( sDate.indexOf("-") >= 0 ) // At least a "-"
				{
					sSeparator  = "-" ;  // separator
					sYearFormat = "YY" ; // Year on 2 digits
				}
				else if ( sDate.indexOf(".") >= 0 ) // At least a "."
				{
					sSeparator  = "." ;  // separator
					sYearFormat = "YY" ; // Year on 2 digits
				}
				else
				{
					sSeparator  = null ;   // no separator 
					sYearFormat = "YYYY" ; // Year on 4 digits
				}
			}
			else if ( sDate.length == 10 ) // 8 digits + 2 separators 
			{
				     if ( sDate.indexOf("/") >= 0 ) sSeparator  = "/" ;
				else if ( sDate.indexOf("-") >= 0 ) sSeparator  = "-" ;
				else if ( sDate.indexOf(".") >= 0 ) sSeparator  = "." ;
				else throw new Error("Invalid date : " + sDate );
				sYearFormat = "YYYY" ;
			}
			else
			{
				throw new Error( "Invalid date : " + sDate );
			}
			
			//--- Copy the current parsed format (other instance)
			var parsedFormat = _parsedFormat.concat() ; // no "copy" method => use "concat()"
			//--- Set the new "INPUT FORMAT" for date parsing : can change 'YEAR format' (but keep order)
			for ( var i=0 ; i < 3 ; i++ )
			{
				if ( parsedFormat[i].charAt(0) == 'Y' )
				{
					parsedFormat[i] = sYearFormat ;
				}
			}
			//--- Set the separator detected in the date
			parsedFormat[3] = sSeparator ;

			//--- Build the Date Value 	
			_buildDateWithParsedFormat( sDate, parsedFormat ) ;
			
		}
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenMessage_class.js
// Telosys framework
// Author  : Laurent Gurin
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenMessage( code, text, type )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iCode = code ;
	var _sText = text ;
	var _iType = type ;

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.getCode = function () 
	{
		return _iCode ;
	}
	//------------------------------------------------------------------------------
	this.getText = function () 
	{
		return _sText ;
	}
	//------------------------------------------------------------------------------
	this.getType = function () 
	{
		return _iType ;
	}
	//------------------------------------------------------------------------------	
	this.toString = function () 
	{
		return "code=" + _iCode + " text='" + _sText + "' type=" + _iType ;
	}
}
//------------------------------------------------------------------------------
//                                THE  END
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenError_class.js
// Telosys Framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenError( code, text )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iCode = code ;
	var _sText = text ;

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.getCode = function () 
	{
		return _iCode ;
	}
	//------------------------------------------------------------------------------
	this.getText = function () 
	{
		return _sText ;
	}
	//------------------------------------------------------------------------------	
	this.toString = function () 
	{
		return "code=" + _iCode + " text='" + _sText + "'" ;
	}
}
//------------------------------------------------------------------------------
//                                THE  END
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenException_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenException( pNum, pClass, pMessage )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iNum     = pNum ;
	var _sClass   = pClass ;
	var _sMessage = pMessage ;

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.getNum = function () 
	{
		return _iNum ;
	}
	//------------------------------------------------------------------------------
	this.getClass = function () 
	{
		return _sClass ;
	}
	//------------------------------------------------------------------------------
	this.getMessage = function () 
	{
		return _sMessage ;
	}
	//------------------------------------------------------------------------------	
	this.toString = function () 
	{
		return "num=" + _iNum + " class='" + _sClass + "' message='" + _sMessage + "'" ;
	}
}
//------------------------------------------------------------------------------
//                                THE  END
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Fields_func.js : Gestion des champs de saisie (filtrage, validit & formatage)
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//==============================================================================
//          G E S T I O N   D E   L ' E T A T   D E S   C H A M P S  
//==============================================================================
//------------------------------------------------------------------------
var VG_fwkShallowCheckingErrorColor   = "white"  ; // Default error color
var VG_fwkShallowCheckingErrorBgColor = "#cc0000"; // Default error background color
var VG_fwkInvalidCharErrorColor       = "red"; 
//var VG_fwkDefaultStandardColor   = "blue";
//var VG_fwkDefaultStandardBgColor = "orange";
var VG_fwkFieldOnError = null ; // Variable Globale pour le timer
function fwkInvalidChar(oField)  
{
    VG_fwkFieldOnError = oField ;
    if ( oField.style.backgroundColor != VG_fwkInvalidCharErrorColor ) // Pour viter les pb de frappe clavier trs rapide
    {
	    var sInitialBgColor = oField.style.backgroundColor ;
	    //alert("initial BG-Color =" + sInitialBgColor );
		//VG_fwkFieldOnError.style.backgroundColor='red' ;	
		VG_fwkFieldOnError.style.backgroundColor=VG_fwkInvalidCharErrorColor ;
	    //window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='white';", 50);
	    window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='" + sInitialBgColor + "';", 50);
    }
}
/***
//------------------------------------------------------------------------
// Neutralisation de la couleur et des tats "erreur" d'un champ ( Reset )
//------------------------------------------------------------------------
function fwkResetFieldErrorStatus(oField)  //--- (Ver 1.2)
{
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ;
	oField.fwkShallowCheckingErrorFlag = false ;
}
***/
/***
//------------------------------------------------------------------------
// Marquage du champ pour une erreur fonctionnelle ( Foreign Key, etc... )
//------------------------------------------------------------------------
function fwkSetFieldErrorColor(oField)  //--- Champ en erreur
{
	oField.style.backgroundColor='red' ;
	oField.style.color='white';	
	oField.fwkErrorFlag = true ; // (Ver 1.2)
}
function fwkSetFieldStandardColor(oField)  //--- Champ OK ( couleur normale )
{
	//alert(oField.id + "fwkErrorFlag = "+ oField.fwkErrorFlag);
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ; // (Ver 1.2)
}
function fwkIsFieldOnError(oField)  //--- Le champ est-il en erreur (ETAT) (Ver 1.2)
{
	if ( oField == null ) return false ;
	if ( oField.fwkErrorFlag == null ) return false ;
	return oField.fwkErrorFlag ; 
}
***/
//------------------------------------------------------------------------
// Marquage du champ pour une erreur "superficielle" : controle de surface (format, .. )
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkDefineShallowCheckingErrorColors(sColor,sBgColor)
{
	VG_fwkShallowCheckingErrorColor   = sColor
	VG_fwkShallowCheckingErrorBgColor = sBgColor
}
//------------------------------------------------------------------------
function fwkSetFieldShallowCheckingErrorColor(oField) 
{
	oField.fwkShallowCheckingErrorFlag = true ;
	if ( ! oField.fwkInitialColor )
	{
		if ( oField.style.color )
		{
			//alert(  "fwkInitialColor NOT SET : storing style.color " + oField.style.color  );
			oField.fwkInitialColor = oField.style.color ;
		}
		else
		{
			//alert(  "fwkInitialColor NOT SET : no style.color => storing '?' "  );
			oField.fwkInitialColor = "?" ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		if ( oField.style.backgroundColor )
		{
			oField.fwkInitialBgColor = oField.style.backgroundColor ;
		}
		else
		{
			oField.fwkInitialBgColor = "?" ;
		}
	}
	//--- Set the error colors 
	oField.style.color           = VG_fwkShallowCheckingErrorColor;	
	oField.style.backgroundColor = VG_fwkShallowCheckingErrorBgColor ;
}
//------------------------------------------------------------------------
//function fwkSetFieldShallowCheckingStandardColor(oField)
function fwkRestoreInitialColors(oField)
{
	if ( oField == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == false ) return ;
	
	oField.fwkShallowCheckingErrorFlag = false ;	
	if ( ! oField.fwkInitialColor )
	{
		oField.style.color = "" ;
	}
	else
	{
		if ( oField.fwkInitialColor == "?" )
		{
			//oField.style.color = null ; // OK on FireFox ( not OK on IE )
			oField.style.color = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.color = oField.fwkInitialColor ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		oField.style.backgroundColor = "" ;
	}
	else
	{
		if ( oField.fwkInitialBgColor == "?" )
		{
			//oField.style.backgroundColor = null ; // OK on FireFox ( not OK on IE )
			oField.style.backgroundColor = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.backgroundColor = oField.fwkInitialBgColor ;
		}
	}
}
//------------------------------------------------------------------------
/***
function fwkIsFieldOnShallowCheckingError(oField) 
{
	if ( oField == null ) return false ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return false ;
	return oField.fwkShallowCheckingErrorFlag ; 
}
***/
//------------------------------------------------------------------------
function fwkGetOptionalChars(sType)  
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(i+1) ;
	}
	return "";
}
//------------------------------------------------------------------------
function fwkGetPureType(sType)
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(0, i) ;
	}
	return sType;	
}
//==============================================================================
//                     KEY CODE (CHARACTER) INPUT FILTER 
//------------------------------------------------------------------------------
// Use this function in the "onKeyPress" event to call this function for 
// each key press by the user
//==============================================================================
function fwkFilter(oEvent, oField, sType)  
{
	if ( oEvent == null )
	{
		alert ( "ERROR on fwkFilter() : No event parameter !" );
		return ;
	}
	if ( oField == null )
	{
		alert ( "ERROR on fwkFilter() : No field parameter !" );
		return ;
	}
	
	if ( sType == null ) return ;
	//fwkSetFieldShallowCheckingStandardColor(oField);

	var sOptionalChars = fwkGetOptionalChars(sType);
	var sPureType      = fwkGetPureType(sType);
	var sPureTypeUC    = sPureType.toUpperCase() ;
	
	if      ( sPureTypeUC == "INT"        ) return fwkIntFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "NUM"        ) return fwkNumFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "ALPHANUMUC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHANUMLC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHANUM"   ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "ALPHAUC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHALC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHA"      ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "DATE"       ) return fwkDateFilter    (oEvent, oField) ;
	else if ( sPureTypeUC == "SELECTUC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "SELECTLC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "SELECT"     ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, ""  ) ;
}
//------------------------------------------------------------------------
function fwkGetKeyCode(oEvent)  
{
	if ( window.event )
	{
		//--- Internet Explorer
		//window.status = "I.E. : event.keyCode = " + oEvent.keyCode + " / window.event.keyCode = " + window.event.keyCode  ;
		return window.event.keyCode ;
	}
	else
	{
		//--- Mozilla / Firefox : see event attributes : 'keyCode', 'which', 'charCode' ( + altKey, ctrlKey, shiftKey )
		if ( oEvent.keyCode ) // Ctrl Key ( Backspace, Home, Arrows, ... ) 
		{
			//window.status = "Mozilla/Firefox : keyCode = " + oEvent.keyCode ;
			return 0 ;
		}
		else if ( oEvent.which ) // Character 
		{
			//window.status = "Mozilla/Firefox : which = " + oEvent.which + " / charCode = " + oEvent.charCode ;
			return oEvent.which ;
		}
		return 0;
	}
}
//------------------------------------------------------------------------
function fwkSetKeyCode(oEvent, iNewKeyCode )  
{
	if ( window.event ) //--- Internet Explorer
	{
		//window.status = "I.E. : initial keyCode = " + window.event.keyCode  + " / new keyCode = " + iNewKeyCode  ;
		window.event.keyCode = iNewKeyCode ;
	}
	else if ( oEvent.initKeyEvent ) //--- Mozilla / Firefox : 'keyCode' and 'which' are readonly => new event 
	{
		//--- Replace current event by a new created event ( OK with FF 1.5, FF 2.0 / Not OK with FF 1.0 )
		// Cancel the first event, create a new event and dispatch it 
		// because of the 2nd event 'fwkFilter' function is called 2 times if there's a key transformation 
		var oNewEvent = document.createEvent("KeyEvents");
		oNewEvent.initKeyEvent('keypress', true, true, window, false, false, false, false, 0, iNewKeyCode );
		oEvent.preventDefault(); // cancels the original event
		oEvent.target.dispatchEvent(oNewEvent); // dispatch the new event on the target
	}
}
//------------------------------------------------------------------------
// Fonction de filtrage des caractres saisis pour un champ ENTIER
//------------------------------------------------------------------------
function fwkIntFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ; // OK
	}
	else 
	{
		if ( sOpt != null )
		{
			// S'agit-il d'un caractre optionnel ?
			var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
			var sCar = String.fromCharCode(iCar) ;
			if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
			{
				return true ;
				// Vrification qu'un de ces caractres n'a pas dj t saisi 
				/*  Problmatique si le champ est "selected" et que le car  dj t saisi
				if (  ( window.event.srcElement.value.indexOf("-") < 0 )
				   && ( window.event.srcElement.value.indexOf("+") < 0 ) )
				{
					return true ;
				}
				*/
			}
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ NUMERIQUE
//------------------------------------------------------------------------
function fwkNumFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( ( iCar >= 48 && iCar <= 57 ) || ( iCar == 46 ) ) // Chiffres ( 0  9 ) plus le POINT 
	{
		return true ;
	}
	else 
	{
		// S'agit-il d'un caractre optionnel ?
		var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
		var sCar = String.fromCharCode(iCar) ;
		if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
		{
			return true ;
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
function privateAlphaFilter(iCar, sOpt, sUpperLower ) 
{
	//--- Lettres majuscules ( A-Z )
	if ( iCar >=  65 && iCar <=  90 ) 
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return iCar + 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres minuscules ( a-z )
	if ( iCar >=  97 && iCar <= 122 ) 
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return iCar - 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres accentues (          etc... )
	if ( iCar >= 194 )
	{
		return iCar ;
	}
	//--- Caractre optionnel ?
	var sCar = String.fromCharCode(iCar) ;
	if ( sOpt.indexOf(sCar) >= 0 )
	{
		return iCar ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	return 0 ;
}

//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHABETIQUE PUR
//------------------------------------------------------------------------
function fwkAlphaFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	//window.status = ">>> KeyCode : initial = " + iCar + " new = " + iFilteredChar ;	
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		} 
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHANUMERIQUE
//------------------------------------------------------------------------
function fwkAlphaNumFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	//--- Chiffres ( 0  9 )
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ;
	}

	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		}
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ DATE
//------------------------------------------------------------------------
function fwkDateFilter(oEvent, oField) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 

	//if ( iCar >= 47 && iCar <= 57 ) // "/" ou chiffre ( 0  9 ) 
	if ( iCar >= 45 && iCar <= 57 ) // v 0.9.9 : '.' or '-' or '/' or '0' to '9'
	{
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ SELECT
//------------------------------------------------------------------------
function fwkSelectFilter(oEvent, oField, sSelectedChars, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	var iNewChar = iCar ;
	if ( iCar < 31 ) return true ; 

	//--- Conversion ventuelle en majuscules ou minuscules
	if ( ( iCar >=  65 && iCar <=  90 ) && ( sUpperLower == "L" ) ) 
	{
		iNewChar = iCar + 32;  // Convert to Lower Case 
	}
	else if ( ( iCar >=  97 && iCar <= 122 ) && ( sUpperLower == "U" ) )
	{
		iNewChar = iCar - 32;  // Convert to Upper Case
	}
	//--- Le caractre fait-il partie de la liste des caractres acceptables ?
	var sNewChar = String.fromCharCode(iNewChar) ;
	if ( sSelectedChars.indexOf(sNewChar) >= 0 )
	{
		if ( iNewChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iNewChar )  
		}	
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus
	fwkInvalidChar(oField);
	return false ;
}

//==============================================================================
//    C O N T R O L E    D E    V A L I D I T E    E T    F O R M A T A G E
//==============================================================================
//------------------------------------------------------------------------
// Check the field is not null
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckNotNull(oField )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckNotNull() : No field parameter !" );
		return ;
	}
	if ( oField.value == null || oField.value == "" )
	{
		//--- This field is null => error
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else
	{
		//--- This field is not null => OK
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField); 
		//}
		fwkRestoreInitialColors(oField);
	}
}
//------------------------------------------------------------------------
// Check the field match the regular expression
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckRegExp(oField, bCanBeNull, sRegExp )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckRegExp() : No field parameter !" );
		return ;
	}
	var sFieldValue = oField.value ;
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			//--- The field is null and it's not authorized => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field is null, but it's authorized => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}
		return ;
	}
	else
	{
		var re = new RegExp( sRegExp );
		if ( ! sFieldValue.match(re) )
		{
			//--- The field doesn't match the Reg Exp => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field match the Reg Exp  => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}	
	}
}
//------------------------------------------------------------------------
// Fonction de controle de validit et de formatage du champ selon son type
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckField(oField, bCanBeNull, sType, MinValue, MaxValue, sFormat )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckField() : No field parameter !" );
		return ;
	}
	if ( sType == null )
	{
		alert ( "ERROR on fwkCheckField() : No type parameter !" );
		return ;
	}

	var sPureType = fwkGetPureType(sType);
	var sPureTypeUC = sPureType.toUpperCase() ;
	//alert( "fwkCheckField() : Type = "+ sType + " => Pure Type = " + sPureType + " => Pure Type UC = " + sPureTypeUC) ;

/***
	//--- Si le champs est dans un tat "erreur fonctionnelle" ( ForeignKey, etc ... )
	if ( fwkIsFieldOnError(oField) )
	{
		// pour traiter le cas d'une re-saisie  l'identique qui ne provoque pas de "OnChange" 
		fwkSetFieldErrorColor(oField); //--- R-affectation de la couleur correspondant  son tat
		
		// Mise en commentaire YMO: Ne prends pas encompte le reformatage de la nouvelle valeur
		// si celle ci est correcte
		//return ; // Inutile d'aller plus loin
	}
***/
	var bRet = true ;
	var sFieldValue = oField.value ;
	//--- Controle de champ null 
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			bRet = false ;
		}
	}
	else // Champ pas null
	{
		var sOptionalChars = fwkGetOptionalChars(sType);
		//--- Controles de validit du champ  
		if      ( sPureTypeUC == "INT"        ) bRet = fwkCheckInt      (sFieldValue, MinValue, MaxValue) ;
		else if ( sPureTypeUC == "NUM"        ) bRet = fwkCheckNum      (sFieldValue, MinValue, MaxValue) ;
		//else if ( sPureTypeUC == "DATE"       ) bRet = fwkCheckDate     (sFieldValue) ;
		else if ( sPureTypeUC == "DATE"       ) bRet = fwkCheckAndFormatDate(oField, sFormat); // v 0.9.9
		else if ( sPureTypeUC == "ALPHA"      ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHAUC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHALC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "ALPHANUM"   ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHANUMUC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHANUMLC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "SELECT"     ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTUC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTLC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
	}
	if ( bRet == false ) //--- Valeur incorrecte  	
	{
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else //--- Valeur correcte  
	{
		//--- Champ de couleur normale 
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField);
		//}
		fwkRestoreInitialColors(oField);

		//--- Formatage 
		if ( sFieldValue != null && sFieldValue != "" )
		{
			if      ( sPureTypeUC == "INT"      ) oField.value = fwkFormatInt (sFieldValue, sFormat) ;
			else if ( sPureTypeUC == "NUM"      ) oField.value = fwkFormatNum (sFieldValue, sFormat) ;
			//else if ( sPureTypeUC == "DATE"     ) oField.value = fwkFormatDate(sFieldValue, sFormat) ; // Remove in v 0.9.9
		}
	}
}

//------------------------------------------------------------------------
// Controle de cohrence des lments Jour, Mois et Anne d'une date 
//------------------------------------------------------------------------
function fwkValidDate(sJour, sMois, sAnnee) // return type : Boolean
{
	// alert("fwkValidDate('"+sJour+"', '"+sMois+"', '"+sAnnee+"') " ) ;
	try 
	{
		var nbJours = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		var j = parseInt(sJour,10) ;
		var m = parseInt(sMois,10) ;
		var a = parseInt(sAnnee,10) ;
		//--- Si Anne bissextile
		if ( ( a%4 == 0 && a%100 != 0 ) || a%400 == 0 )  nbJours[2] = 29  ; // 29 jours en Fvrier
		
		//alert("fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ) ;
		//window.status = "fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ;
	
		//--- Validite de l'Annee
		if ( ( a < 0 ) || ( a > 9999 ) )  return false ;
		//--- Validite du Mois
		if ( ( m < 1 ) || ( m > 12 ) )  return false ;
		//--- Validite du Jour 
		if ( ( j < 1 ) || ( j > nbJours[m] ) )  return false ;
		//--- OK : Date valide  
		return true ;
	}
	catch (e) 
	{
		//window.status = "fwkValidDate : Exception"  ;
		return false ;
	}
}
//------------------------------------------------------------------------
// Controle de validit d'un champ de type DATE 
//------------------------------------------------------------------------
//function fwkCheckDate(oField) // return type : Boolean
function fwkCheckDate(sFieldValue) // return type : Boolean
{
var i, c ;
var JJ, MM, AA ;

	if ( sFieldValue.length == 6 ) // "JJMMAA" (ne doit contenir que des chiffres)
	{
		//------------------------------------------------------
		// 6 caractres => format attendu : "JJMMAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 6 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
		{
			c = sFieldValue.charCodeAt(i) ;
			if ( c < 48 || c > 57 ) return false ;
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(2,2);
        AA   = sFieldValue.substr(4,2);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length == 8 ) // "JJ/MM/AA" ou "JJMMAAAA" 
	{
		if ( sFieldValue.indexOf("/") >= 0 ) // Si il y a au moins un "/"
		{
			//------------------------------------------------------
			// 8 caractres avec "/" => format attendu : "JJ/MM/AA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre + "/" (code 47) en position 2 et 5
			{
				c = sFieldValue.charCodeAt(i) ;
				if (      ( c < 47 || c > 57 )  
				      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
				      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
				   )
				{
					return false ;
				}
			}
			JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(3,2);
	        AA   = sFieldValue.substr(6,2);
			return fwkValidDate(JJ, MM, AA) ;
		}
		else
		{
			//------------------------------------------------------
			// 8 caractres sans "/" => format attendu : "JJMMAAAA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
			{
				c = sFieldValue.charCodeAt(i) ;
				if ( c < 48 || c > 57 ) return false ;
			}
	        JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(2,2);
	        AA   = sFieldValue.substr(4,4);
			return fwkValidDate(JJ, MM, AA) ;
		}
	}
	else if ( sFieldValue.length == 10 ) // "JJ/MM/AAAA"
	{
		//------------------------------------------------------
		// 10 caractres => format attendu : "JJ/MM/AAAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 10 ; i++ )//--- Chiffre + "/" (code 47) en position 2 et 5
		{
			c = sFieldValue.charCodeAt(i) ;
			if (      ( c < 47 || c > 57 )  
			      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
			      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
			   )
			{
				return false ;
			}
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(3,2);
        AA   = sFieldValue.substr(6,4);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length != 0 )
	{
		return false ;
	}
	return true ; // Date OK
}
//------------------------------------------------------------------------
function fwkCheckAndFormatDate(oField, sFormat) // return type : Boolean
{
	if ( sFormat == null || sFormat == "" ) sFormat = "DD/MM/YYYY" ;
	try {
		//--- Build a SimpleDate object according with the given format
		var date = new SimpleDate( null, sFormat );
		//--- Try to set the new date value 
		date.setDate(oField.value); // error if invalid date
		//--- Format the date and set it as the current field value
		oField.value = date.format();
	} 
	catch (e) {
		return false ;
	}
	return true ;
}

//------------------------------------------------------------------------
// Controle de validit d'un champ de type ENTIER 
//------------------------------------------------------------------------
//function fwkCheckInt(oField) // return type : Boolean
function fwkCheckInt(sFieldValue, iMinValue, iMaxValue) // return type : Boolean
{      
	var re = new RegExp("^[-+]?[0-9]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/*
	//--- Si le signe n'est pas au dbut ( position ZERO ) => erreur
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
*/
	
	var iFieldValue = parseInt(sFieldValue,10) ;
	// NB: parseInt ne controle pas la validit ( "2 2" -> 2, "2a" -> 2, etc...)
	// et ne lve pas d'exception (renvoie NaN si aucun parsing possible)

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( iMinValue != null && iFieldValue < iMinValue ) return false;
	if ( iMaxValue != null && iFieldValue > iMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}


//------------------------------------------------------------------------
// Controle de validit d'un champ de type NUMERIQUE 
//------------------------------------------------------------------------
//function fwkCheckNum(oField) // return Boolean
function fwkCheckNum(sFieldValue, fMinValue, fMaxValue) // return Boolean
{      
	var re = new RegExp("^[-+]?[0-9\.]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/**
	//--- Si le signe n'est pas au dbut ( position ZERO ) 
	// ( et s'il y en a plusieurs, ils ne peuvent pas tre tous  la position 0 )
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
**/

	//--- Si il y a plus d'une marque dcimale ( . )
	var i  = 0;
	var nb = 0;
	for ( i = 0 ; i < sFieldValue.length ; i++ )
	{
		if ( sFieldValue.charAt(i) == '.' ) nb ++;
	}
	if ( nb > 1 ) return false ;

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( fMinValue != null && parseFloat(sFieldValue) < fMinValue ) return false;
	if ( fMaxValue != null && parseFloat(sFieldValue) > fMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}

//------------------------------------------------------------------------
function fwkCheckCharAlpha (c, sOpt, sUpperLower ) // return Boolean
{
	if ( c >=  65 && c <=  90 ) //--- Lettres majuscules ( A-Z )
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return false ; 
		}
		return true ; // OK
	}
	else if ( c >=  97 && c <= 122 ) //--- Lettres minuscules ( a-z )
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return false;
		}
		return true ; // OK
	}
	else if ( c >= 194 ) //--- Lettres accentues (          etc... )
	{
		return true ; // OK
	}
	else //--- Caractre optionnel ?
	{
		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		{
			return false ;
		}
	}
	//--- OK le caractre est acceptable
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlpha (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlpha("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlphaNum (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlphaNum("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		//--- Chiffres ( 0  9 )
		if ( c >= 48 && c <= 57 ) // Chiffres ( 0  9 )
		{
			continue; // OK
		}
		else
		{
			if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
			{
				return false ;
			}
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
function fwkCheckSelect (sFieldValue, sOpt ) // return Boolean
{
	//window.status = "fwkCheckSelect"+sFieldValue+","+sOpt+")" ;
//	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
//		c = sFieldValue.charCodeAt(i) ;		
//		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		if ( sOpt.indexOf(sFieldValue.charAt(i)) < 0 )
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}

//==============================================================================
//    FORMAT FUNCTIONS 
//==============================================================================
//------------------------------------------------------------------------
// Formatage d'un champ de type DATE
//------------------------------------------------------------------------
function fwkFormatDateYMD( sYear, sMonth, sDay, sFormat) // return type : String ( Formated Value )
{
	var sFormatUC = "DD/MM/YYYY" ; // Default Format = French format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	if ( sDay == null || sMonth == null || sYear == null )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is null ! " );
		return "";
	}
	/**
	if ( isNaN(sD) || isNaN(sM) || isNaN(sY) )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is not a number ! " );
		return "";
	}
	**/
	var sDD = null ;
	var sMM = null ;
	var sYY = null ;
	var sYYYY = null ;
	try {
		var iDay = parseInt(sDay,10) ;
		if ( iDay < 1 || iDay > 31 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid day " + iDay ) ;
			return "";
		}
		var iMonth = parseInt(sMonth,10) ;
		if ( iMonth < 1 || iMonth > 12 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid month " + iMonth ) ;
			return "";
		}
		var iYear = parseInt(sYear,10) ;
		if ( iYear < 0 || iYear > 9999 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid year " + iYear ) ;
			return "";
		}
	
		if ( iDay < 10 ) sDD = "0"+iDay; 
		else             sDD =  ""+iDay ;

		if ( iMonth < 10 ) sMM = "0"+iMonth;
		else               sMM =  ""+iMonth ;

		if ( iYear >= 1000 && iYear <= 9999 )
		{
			sYYYY = ""+iYear ;
		}
		else if ( iYear >= 100 && iYear <= 999 )
		{
			sYYYY = "2"+iYear ;
		}
		else if ( iYear >= 10 && iYear <= 99 )
		{
			sYYYY = "20"+iYear ;
		}
		else if ( iYear > 0 && iYear <= 9 )
		{
			sYYYY = "200"+iYear ;
		}
		sYY = sYYYY.substr(2,2);
		
		//TODO : Remplacer par substitution REGEXP
		if ( sFormatUC == "DD/MM/YYYY" ) return sDD+"/"+sMM+"/"+sYYYY ;
		if ( sFormatUC == "DD/MM/YY"   ) return sDD+"/"+sMM+"/"+sYY ;
		if ( sFormatUC == "MM/DD/YYYY" ) return sMM+"/"+sDD+"/"+sYYYY ;
		if ( sFormatUC == "MM/DD/YY"   ) return sMM+"/"+sDD+"/"+sYY ;
		if ( sFormatUC == "DD-MM-YYYY" ) return sDD+"-"+sMM+"-"+sYYYY ;
		if ( sFormatUC == "DD-MM-YY"   ) return sDD+"-"+sMM+"-"+sYY ;
		if ( sFormatUC == "MM-DD-YYYY" ) return sMM+"-"+sDD+"-"+sYYYY ;
		if ( sFormatUC == "MM-DD-YY"   ) return sMM+"-"+sDD+"-"+sYY ;
	} catch(ex) {
		alert("ERROR : fwkFormatDateYMD : Year = " + sYear + " Month = " + sMonth + " Day = " + sDay + " : Exception " + ex.message );		
	}
	
	
}
//------------------------------------------------------------------------
function fwkFormatDate(sVal, sFormat) // return type : String ( Formated Value )
{
var sDD, sMM, sYY, sYYYY ;

	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;
	
	var sFormatUC = "DD/MM/YYYY" ; // Default Format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	//--- Si il y a dj des sparateurs => pas de formatage
	if ( sVal.indexOf("/") >= 0 ) 
	{
		return sVal ;
	}
	else if ( sVal.length == 6 ) // "DDMMYY" 
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = "20"+sYY ;
	}  
	else if ( sVal.length == 8 ) // "DDMMYYYY"  
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = sVal.substr(4,4);
	}
	else
	{
		return sVal ;	
	}
	if ( sFormatUC == "DD/MM/YYYY" ) 
	{
		return sDD+"/"+sMM+"/"+sYYYY ;
	}
	else if ( sFormatUC == "DD/MM/YY" ) 
	{
		return sDD+"/"+sMM+"/"+sYY ;
	}
	/***
	else if ( sFormatUC == "DD-MM-YYYY" ) 
	{
		return sDD+"-"+sMM+"-"+sYYYY ;
	}
	else if ( sFormatUC == "DD-MM-YY" ) 
	{
		return sDD+"-"+sMM+"-"+sYY ;
	}
	else if ( sFormatUC == "MM-DD-YYYY" )  // American format
	{
		return sMM+"-"+sDD+"-"+sYYYY ;
	}
	else if ( sFormatUC == "MM-DD-YY" ) // American format
	{
		return sMM+"-"+sDD+"-"+sYY ;
	}
	else if ( sFormatUC == "YYYY-MM-DD" )  // ISO
	{
		return sYYYY+"-"+sMM+"-"+sDD ;
	}
	***/
	else // No Format
	{
		return sVal ;
	}
}

//------------------------------------------------------------------------
// Formatage d'un champ de type ENTIER
//------------------------------------------------------------------------
//function fwkFormatInt(oField, sFormat) // return type : Void
function fwkFormatInt(sVal, sFormat) // return type : String ( Formated Value )
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )       return sVal ;
//	if ( oField.value.length == 0 ) return ; 	//--- Si le champ est vide => pas de formatage

//	var sVal         = oField.value ;   // Valeur originale du champ 
	var sSigne       = "" ;  // Signe de la valeur originale
	var sUnsignedVal = "" ;  // Valeur originale sans le signe
	var sNewVal      = "" ;  // Valeur formate 
	
	//--- Sparation du signe et de la valeur non signe  
	sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
	if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
	{
		sUnsignedVal = sVal.substr(1) ;
	}
	else
	{
		sSigne = "+" ; // par dfaut 
		sUnsignedVal = sVal ;
	}
	//alert ( "sSigne = "+sSigne + " sUnsignedVal = "+sUnsignedVal ) ;	
	
	//--- Remplissage  gauche avec des ZEROS ?
	var sFiller   = null ;
	var iNbDigits = 0 ;
	if ( sFormat.indexOf("0") >= 0 ) sFiller = "0" ;
	if ( sFiller != null ) 
	{
		var i = 0
		//--- Nb de caractres attendus (dans le format)
		for ( i = 0 ; i < sFormat.length ; i++ )
		{
			if ( sFormat.charAt(i) == '0' ) iNbDigits++ ;
		}
		//--- Nb caractres de remplissage  ajouter
		var iDeltaSize = iNbDigits - sUnsignedVal.length ; 
		if ( iDeltaSize < 0 ) iDeltaSize = 0 ;
		//--- Composition de la chaine de caractres formate sans le signe
		sNewVal = "" ;
		for ( i = 0 ; i < iDeltaSize ; i++ )
		{
			sNewVal += sFiller;
		}
		sNewVal += sUnsignedVal ;
	}
	else
	{
		//--- Aucun formatage 
		sNewVal = sUnsignedVal ;
	}
	//alert ( "sNewVal avant mise en plce du signe = "+sNewVal ) ;	

	//--- Mise en place du signe (si ncessaire)
	if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
	{
		sNewVal = sSigne + sNewVal ;
	}
	else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
	}
	else  // Aucune exigence au niveau du format 
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
	}

	//--- Affectation de la valeur formate dans le champ de saisie
	//oField.value = sNewVal ;      
	return sNewVal ;
}

//------------------------------------------------------------------------
// Formatage d'un champ de type NUMERIQUE
//------------------------------------------------------------------------
//function fwkFormatNum(oField, sFormat) // formatage 
function fwkFormatNum(sVal, sFormat) // // return type : String ( Formated Value ) 
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null )     return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )     return sVal ;
	if ( sFormat.length == 0 ) return sVal ;

	//var sVal               = oField.value ;			// Valeur originale du champ 
	var sSigne             = "" ;  					// Signe de la valeur originale
	var sUnsignedVal       = "" ;   				// Valeur originale sans le signe
	var sUnsignedValBefore = "" ;  					// Valeur originale sans le signe avant le point
	var sUnsignedValAfter  = "" ; 					// Valeur originale sans le signe apres le point
	
	var iNbBefore          = 0;						// Nombre de chiffre avant le point dans le champs
	var iNbAfter           = 0;						// Nombre de chiffre aprs le point dans le champs
	//var iDotPosition       = GetDotPosition( oField.value );	// Position du point dans le champs
	var iDotPosition       = GetDotPosition( sVal );	// Position du point dans le champs
	
	var iNbBeforeFormat    = 0;						// Nombre de chiffre avant le point dans le format
	var iNbAfterFormat     = 0;						// Nombre de chiffre aprs le point dans le format
	var iDotPositionFormat = GetDotPosition( sFormat );			// Position du point dans le format
	var sUnsignedValFormat = "" ; 					// Valeur originale sans le signe dans le format
	
	var sNewVal            = "";  						// Valeur formate
	
	if ( iDotPositionFormat == -1 )
	{
		alert("ERROR \n function fwkFormatNum() : \n Invalid Format ["+ sFormat +"]");
		return sVal ;
	} 
	
		//--- Sparation du signe et de la valeur non signe du champ 
		sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
		{
			sUnsignedVal = sVal.substr(1) ;
			iDotPosition--;
		}
		else
		{
			sSigne = "+" ; // par dfaut 
			sUnsignedVal = sVal ;
		}
		//alert ( "sSigne = "+ sSigne +"\nsUnsignedVal = "+ sUnsignedVal +"\niDotPosition = "+ iDotPosition ) ;
		
		//--- Sparation du signe et de la valeur non signe du format
		sSigneFormat  = sFormat.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigneFormat == "-" ) || ( sSigneFormat == "+" ) )  
		{
			sUnsignedValFormat = sFormat.substr(1) ;
			iDotPositionFormat--;
		}
		else
		{
			sSigneFormat = "+" ; // par dfaut 
			sUnsignedValFormat = sFormat ;
		}
		//alert ( "sSigneFormat = "+ sSigneFormat +"\nsUnsignedValFormat = "+ sUnsignedValFormat +"\niDotPositionFormat = "+ iDotPositionFormat ) ;
		
		//--- Nombre de chiffre avant et aprs le point dans le format
		iNbBeforeFormat = iDotPositionFormat;
		iNbAfterFormat  = ( sUnsignedValFormat.length - iDotPositionFormat - 1);
		
		//alert ( "Format:\niNbBeforeFormat = "+ iNbBeforeFormat +"\niNbAfterFormat = "+ iNbAfterFormat ) ;
		
		// S'il y a un point dans le champ
		if ( iDotPosition > -1 ){
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = iDotPosition;
			iNbAfter  = ( sUnsignedVal.length - iDotPosition - 1);
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
						
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			sUnsignedValAfter = sUnsignedVal.substr(iDotPosition+1, iNbAfter);
			if (iNbAfterFormat >= iNbAfter){
				for( i=0; i < (iNbAfterFormat-iNbAfter); i++){
					sUnsignedValAfter = sUnsignedValAfter +"0";
				}
			}else
			{
				sUnsignedValAfter=sUnsignedValAfter.substr(0,iNbAfterFormat) ;
			}
			
			//alert (sUnsignedValAfter);
		}
		else {
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = sUnsignedVal.length;
			iNbAfter  = 0;
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
			
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			for( i=0; i < (iNbAfterFormat - iNbAfter); i++){
				sUnsignedValAfter = sUnsignedValAfter +"0";
			}
			//alert (sUnsignedValAfter);
		}
		
		sNewVal = sUnsignedValBefore +"."+ sUnsignedValAfter		
		
		//--- Mise en place du signe (si ncessaire)
		if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
		{
			sNewVal = sSigne + sNewVal ;
		}
		else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
		}
		else  // Aucune exigence au niveau du format 
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
		}

		//--- Affectation de la valeur formate dans le champ de saisie
		//oField.value = sNewVal ;
		return sNewVal ;
}
//------------------------------------------------------------------------
// Retourne la position du point dans le format
// 		retourne -1 si format invalide (pas de point ou plus de 1 point)
//------------------------------------------------------------------------
function GetDotPosition(sFormat)
{
	var iPos = null;							// Positon du point dans le format 
	var iNbPoint = 0;							// Nombre de point dans le format
	
	for ( i=0; i < sFormat.length; i++)
	{
		if ( sFormat.charAt(i) == "." )
		{
			iPos = i;
			iNbPoint++;
		}
	}
	
	if ( iNbPoint != 1 ) return -1;
	else return iPos;
}

//==============================================================================
//    
//==============================================================================

//------------------------------------------------------------------------
// setFocus() : Selectionne le champ avec la methode select() 
//              quand c'est possible sinon execute la methode focus()
//------------------------------------------------------------------------
function fwkSetFieldFocus( oHtmlObject ){
		if ( oHtmlObject != null ){
		try {
			oHtmlObject.select();
		}
		catch(e) {
			oHtmlObject.focus();
		}
	}
}



//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// OLD Fonctions 
//------------------------------------------------------------------------
/***
var CaractereDecimal =".";

//------------------------------------------------------------------------
function FormatNum(Chp,NbDecimal) 
{
  if (Chp.value.length == 0) { return true;} // Champ vide
  // Controle de params pour debug :
  // if (arguments.length < 2) { alert('fonction FormatNum : Nombre incorrect de paramtres');return false;} 
  
  if (NombreCaractereDecimal(Chp.value) == 0) { Chp.value = Chp.value + CaractereDecimal ; }
  var i,j = 0;
  i = (Chp.value.length - Chp.value.indexOf(CaractereDecimal) - 1); // Nb chiffres aprs marque dcimale
  for ( j = i ; j < NbDecimal ; j++)
    { Chp.value = Chp.value + "0";}

  return true;
}
***/

//------------------------------------------------------------------------

//------------------------------------------------------------------------
//        F I N 
//------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Fields2_func.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "Date" fields ( cf. RegisterFieldDate )
//----------------------------------------------------------------------
function fwkFieldDateGetValue() // Return the current field value in ISO format
{
	var sRet = null ;
	//alert("fwkFieldDateGetValue() : " + this.value );
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return null ;
	}
		
	if ( this.value == null ) 
	{
		sRet = "";
	}
	else if ( this.value.length == 0 ) 
	{
		sRet = "";
	}
	else
	{
		//--- Convert from field format to ISO format
		try {
			//--- Set the date format as the specific field format
			this.dateValue.setFormat(this.format);
			//--- Try to set the field value in the SimpleDate object
			this.dateValue.setDate(this.value);
			//--- Return the date in ISO format
			sRet = this.dateValue.format("YYYY-MM-DD");
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
	}
	return sRet ;
/**
	try {
		//--- Build a date in the field format 
		var date = new SimpleDate(this.value , this.format );
		//--- Return the date in ISO format
		date.format("YYYY-MM-DD");
		
		// Re affect the current value to check the validity
		//this.date.setDate( this.value ); 
		// Return the ISO format of the date
		//return this.date.format("YYYY-MM-DD");
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
}
//----------------------------------------------------------------------
function fwkFieldDateSetValue(sDateIso)
{
/**
	try {
		//--- Build a date in ISO format 
		var date = new SimpleDate(sDateIso, "YYYY-MM-DD");
		//--- Set the field value with its format 
		this.value = date.format( this.format );
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
	var sRet = null ;
	//alert("fwkFieldDateSetValue( " + sDateIso + " )");
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return ;
	}
	if ( sDateIso == null ) 
	{
		this.value = "";
	}
	else if ( sDateIso.length == 0 ) 
	{
		this.value = "";
	}
	else
	{
		//--- Convert from ISO format to field format 
		try {
			//--- Set the date format as ISO format
			this.dateValue.setFormat("YYYY-MM-DD");
			//alert("fwkFieldDateSetValue : date format = " + this.dateValue.getFormat() + " )");
			//--- Try to set the date value (in ISO format)
			//this.dateValue.show();
			this.dateValue.setDate(sDateIso);
			//this.dateValue.show(); 
			//--- Re-format the date in the specific field format
			sRet = this.dateValue.format(this.format);
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
		this.value = sRet ;
	}
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "CheckBox" fields ( cf. RegisterCheckBox )
//----------------------------------------------------------------------
function fwkCheckboxGetValue()
{
	if ( this.checked ) return this.valueChecked ;
	else return this.valueUnchecked ;
}
//----------------------------------------------------------------------
function fwkCheckboxSetValue(sVal)
{
	if ( sVal == this.valueChecked ) this.checked = true ;
	else this.checked = false ;
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "RadioGroup" fields ( cf. RegisterRadioGroup )
//----------------------------------------------------------------------
function fwkRadioGroupGetValue()
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupGetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( oRadio.checked ) return oRadio.value ;
		}
	}
	//--- No radio selected in this group
	return null ;
}
//----------------------------------------------------------------------
function fwkRadioGroupSetValue(sVal)
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupSetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( sVal == oRadio.value ) 
			{
				oRadio.checked = true ;
			}
			else
			{
				oRadio.checked = false ;
			}
		}
	}
}
//----------------------------------------------------------------------
function fwkRadioGroupSetDisabled(bFlag)
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupSetDisabled() : Radios ["+i+"] is null ! " );
		}
		else
		{
			oRadio.disabled = bFlag ;
		}
	}
}
//----------------------------------------------------------------------
function fwkFieldSetDisabled(bFlag)
{
	//--- Disable the field
	this.disabled = bFlag ;
	//--- If the field has a picto : hide the picto
	if ( this.oPicto )
	{
		if ( bFlag == true ) // disabled
		{
			this.oPicto.style.visibility = "hidden" ;
		}
		else
		{
			this.oPicto.style.visibility = "visible" ;
		}
	}
}
//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "RichTextEditor" fields ( cf. RegisterRichTextEditor )
//----------------------------------------------------------------------
function fwkRTEGetValue()
{
	return fwkRTEGetText(this.id);
}
//----------------------------------------------------------------------
function fwkRTESetValue(sVal)
{
	fwkRTESetText(this.id, sVal )
}
//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "HtmlViewer" fields ( cf. RegisterHtmlViewer )
//----------------------------------------------------------------------
function fwkHtmlViewerSetValue(sVal)
{
	fwkSetInnerHTML(this.id, sVal )
}
//----------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenField_class.js
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function ScreenField(argFieldId, argFieldObject, argScreenZone, argXmlTag, argXmlAttr)
{
	//alert("ScreenField("+argFieldId+", ... ,"+ argScreenZone+","+ argXmlTag+","+ argXmlAttr+")" );
	if ( argFieldId == null )
	{
		throw new Error("ScreenField constructor : Field ID is null" );
		//alert ( "ERROR : ScreenField constructor : Field ID is null !" );
	}
	if ( argFieldObject == null )
	{
		throw new Error("ScreenField constructor : Unknown field with ID = " + argFieldId );
		//alert ( "ERROR : ScreenField constructor : Unknown field with ID = " + this.sId  );
	}

	//==============================================================================
	// PUBLIC ATTRIBUTES
	//==============================================================================
	this.sId      = argFieldId ; // cannot be null 
	this.oField   = argFieldObject; // cannot be null 
	this.sZone    = argScreenZone ;
	this.sXmlTag  = argXmlTag ; // can be null (if no XML mapping)
	this.sXmlAttr = argXmlAttr ; // can be null (if no XML mapping)
}

//------------------------------------------------------------------------------
// ScreenView_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
/**
 * ScreenView class 
 * @param  String  the container Id ( cannot be null )
 * @param  Object  the container object ( cannot be null )
 * @param  String  the screen zone name
 * @param  String  the XML tag name for the view
 * @param  String  the renderer name used to generate the view ( cannot be null )
 */	
function ScreenView ( argContainerId, argContainerObject, argScreenZone, argXmlTag, argRenderer )
{
	if ( argContainerId == null )
	{
		throw new Error("ScreenView constructor : Field ID is null" );
	}
	if ( argContainerObject == null )
	{
		throw new Error("ScreenView constructor : Unknown field with ID = " + argFieldId );
	}
	if ( argXmlTag == null )
	{
		throw new Error("ScreenView constructor : View name (XML tag) is null" );
	}
	if ( argRenderer == null )
	{
		throw new Error("ScreenView constructor : Renderer is null" );
	}

	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _sContainerId = argContainerId ;
	var _oContainer   = argContainerObject ;
	var _sScreenZone  = argScreenZone ;
	var _sXmlTag      = argXmlTag ;
	var _sRenderer    = argRenderer ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenView] : \n\n" + sMsg ) ;
	}
	
	//==============================================================================
	// PUBLIC METHODS
	//==============================================================================
	this.getName = function()
	{
		return _sXmlTag ;
	}
	//------------------------------------------------------------------------------
	this.getRenderer = function()
	{
		return _sRenderer ;
	}
	//------------------------------------------------------------------------------
	this.getScreenZone = function()
	{
		return _sScreenZone ;
	}
	//------------------------------------------------------------------------------
	this.getContainerId = function()
	{
		return _sContainerId ;
	}
	//------------------------------------------------------------------------------
	this.getContainer = function()
	{
		return _oContainer ;
	}
	
	//------------------------------------------------------------------------------	
	/**
     * Set the given content in the view container 
     * @param  the content to set in the innerHTML attribute of the container
     */	
	this.setContent = function(argContent)
	{
		if ( _oContainer != null )
		{
			if ( argContent != null )
			{
				_oContainer.innerHTML = argContent ;
				//--- Eval View JS Scripts / NEW v 0.9.8 ( 13/12/07 )
				var scripts = _oContainer.getElementsByTagName("script");
				for(var i=0; i<scripts.length; i++) 
				{
					eval(scripts[i].innerHTML);
				}
			}
			else
			{
				_oContainer.innerHTML = "" ;			
			}
		}
		else
		{
			_error("View " + _sContainerId + " : container is null " );
		}
	}
	//------------------------------------------------------------------------------	
	/**
     * Clear the content of the view container if the view belongs to the
     * given ScreenZone. If the ScreenZone is null, the view is cleared.
     * @param  the screen zone (can be null) 
     */	
	this.clear = function(argZone)
	{
		if ( argZone != null )
		{
			if ( argZone != _sScreenZone ) return ;
		}
		//this.setContent(""); // v 1.1.0
		if ( _oContainer != null ) _oContainer.innerHTML = "" ;// v 1.1.0
	}
	//------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------
// XmlTags_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
// Needs : 
// - Tools : xmlString()
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// "XmlTags" object
//------------------------------------------------------------------------------
// Extensible collection indexed by "tag name" (as "Java Hashtable")
// For each tag name, hold a string with the attributes
// Example : 
// ["book"]   -> " id='3' price='12' "
// ["author"] -> " name='Zola' "
//------------------------------------------------------------------------------
function XmlTags()
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _oAttributes = new Object();  // The attributes "HashTable" (void)
	var _oChildTags = new Object();  // The child tags "HashTable" (void)
	
	var _sEOL    = TelosysConst.getRequestEndOfLine() ;
	
	//==============================================================================
	// PUBLIC METHODS 
	//==============================================================================

	this.addField = function(sTag, sAttr, sValue) // Add the field value as an attribute for this tag
	{
		var sToAdd = " " + sAttr + "=\"" + Tools.xmlString(sValue) + "\"" ;
		var sCurrent = _oAttributes[sTag] ;
		if ( sCurrent == null )
		{
			_oAttributes[sTag] = sToAdd ;
		}
		else
		{
			_oAttributes[sTag] = sCurrent + sToAdd ;
		}
	}
	
	//------------------------------------------------------------------------------
	this.addChildTag = function(sTag, sChildTagName, sChildTagContent) // Add child tag for this tag
	{
		//alert ( "addChildTag("+ sTag+"," + sChildTagName+"," + sChildTagContent +")" );
		
		var sToAdd = "<"+ sChildTagName +"><![CDATA[" + sChildTagContent + "]]></"+sChildTagName+">" ;
		
		var sCurrent = _oChildTags[sTag] ;
		if ( sCurrent == null )
		{
			_oChildTags[sTag] = sToAdd ;
		}
		else
		{
			_oChildTags[sTag] = sCurrent + _sEOL + sToAdd ;
		}
		// be sure the PK exists
		if ( _oAttributes[sTag] == null ) _oAttributes[sTag] = " " ;
	}
	
	//------------------------------------------------------------------------------
	
	this.getXmlTags = function() // Get all the tags (one line per XML tag)
	{
		var sXml = "" ;
		for ( tag in _oAttributes )
		{
			//--- <tag a="x" b="x" 
			sXml += "<" + tag + _oAttributes[tag] ;
			sChilds = _oChildTags[tag] ;
			if ( sChilds != null )
			{
				//--- "> <child1>xxx</child1> </tag>"
				sXml += ">" + sChilds + "</" + tag + ">" + _sEOL ;
			}
			else
			{			
				sXml += "/>" + _sEOL ;
			}
		}
		return sXml ;
	}
}

//------------------------------------------------------------------------------
// Screen_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// "Screen" Object 
//------------------------------------------------------------------------------
function Screen(argScreenName, argAjaxUrl, argScreenId )
{
	//==============================================================================
	// STANDARD ATTRIBUTES & METHODS
	//==============================================================================
	var _bTrace = false ;
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [Screen] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [Screen] :\n\n" + sMsg ) ;
	}
	
	//------------------------------------------------------------------------------
	if ( argScreenName == null ) _error ( "constructor : 1st argument ( Screen Name ) is null " ) ;
	if ( argAjaxUrl  == null )   _error ( "constructor : 2nd argument ( Ajax URL ) is null " ) ;
	if ( argScreenId == null ) argScreenId = 0 ;

	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	//--- The name of the screen
	var _sScreenName       = argScreenName ;

	//--- The URL used to send the requests
	var _sUrlBase          = argAjaxUrl ;

	//--- The ScreenContext ID in the ScreenSession
	var _iScreenId         = argScreenId ;	 

	var _oInvalidField     = null ;

	//--- The ScreenFields Array ( Filled by "RegisterField()" )
	var _aScreenFields     = new Array() ; 

	//--- The ScreenViews Array ( Filled by "RegisterView()" )
	var _aScreenViews      = new Array() ;
	
	//--- The list of all the elements referenced in the screen ( "elem1,elem2,elemN" )
	var _sElements         = null ;
	
	//--- The registered screen fields serialized in XML format
	var _sSerializedFields = "" ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	
	function _buildElementsList()
	{
		var map = new Map();
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField != null )
			{
				//--- If the field is mapped to a context element 
				if ( oScreenField.sXmlTag != null )
				{
					//--- Store the element name as a map key 
					map.put(oScreenField.sXmlTag, true); 
				}
			}		
		}
		_sElements = map.keysString();
	}
		
	//------------------------------------------------------------------------------
	// Serialize the given ScreenField object (in XML format) 
	//------------------------------------------------------------------------------
	function _serializeScreenField ( oScreenField, oXmlTags )
	{
		var oField = oScreenField.oField ;
		if ( oField == null )
		{
			_error("_serializeField : ScreenField '" + oScreenField.sId + "' : oField attribute is null !" );
		}
		else
		{
			//--- If field marked as "DO NOT SEND TO SERVER" ( Receive only ) => no serialization
			if ( oField.bDoNotSend ) return ;
			
			var sFieldValue = null ;
			if ( oField.getValue )
			{
				sFieldValue = oField.getValue() ;
			}
			else
			{
				sFieldValue = oField.value ;
			}
			if ( oField.isLongText == true )
			{
				//--- Long Text field => add the value as a child tag ( not as an attribute )
				oXmlTags.addChildTag(oScreenField.sXmlTag, oScreenField.sXmlAttr, sFieldValue );
			}
			else
			{
				//--- Classical field => add the value as an attribute
				oXmlTags.addField(oScreenField.sXmlTag, oScreenField.sXmlAttr, sFieldValue );
			}
		}
	}
	
	//------------------------------------------------------------------------------
	// Serialize all the registered fields (in XML format) 
	// or only the fields associated with the given element name (if arg set )
	//------------------------------------------------------------------------------
	function _serializeFields ( argElementName )
	{
		//_trace("_serializeFields()");

		var oXmlTags = new XmlTags();
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				_error("_serializeFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					if ( argElementName != null )
					{
						if ( argElementName == oScreenField.sXmlTag )
						{
							_serializeScreenField ( oScreenField, oXmlTags );
						}
					}
					else
					{
						_serializeScreenField ( oScreenField, oXmlTags );
					}
				}
			}
		}
		return oXmlTags.getXmlTags() ;
	}
	//------------------------------------------------------------------------------
	// Populate all the registered fields from the response object
	//------------------------------------------------------------------------------
	function _populateFields ( response )
	{
		//_trace("_populateFields(response) " );
		//--- If no data in the response => nothing to do
		if ( response.dataVoid() ) return ;
		
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;
		
		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				_error("_populateFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					oField = oScreenField.oField ;
					if ( oField != null )
					{
						//--- Search the field value in the response
						if ( oField.isLongText )
						{
							//--- Get the value from a CHILD TAG
							sFieldValue = response.getDataFieldValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr, true ) ;
						}
						else
						{
							//--- Get the value from an ATTRIBUTE
							sFieldValue = response.getDataFieldValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr, false ) ;
						}
						if ( sFieldValue != null )
						{
							if ( oField.setValue ) 
							{
								oField.setValue(sFieldValue) ;
							}
							else
							{
								oField.value = sFieldValue ;
							}
						}
						// else : the field is not in the response => no change on the screen
					}
					else
					{
						_error("_populateFields() : Field ["+i+"] is null ! " );
					}
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// Populate all the registered view from the response object
	//------------------------------------------------------------------------------
	function _populateViews ( response )
	{
		//_trace("_populateFields(response) " );		
		if ( response.hasView() == false ) return ;
		
		var oScreenView = null ;
		var oContainer  = null ;
		
		//--- For each view registered in this screen 
		for ( var i = 0 ; i < _aScreenViews.length ; i++ )
		{
			oScreenView = _aScreenViews[i] ;
			if ( oScreenView == null )
			{
				_error("_populateViews() : ScreenViews ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to a response view tag 
				if (  oScreenView.getName() != null )
				{
					oContainer = oScreenView.getContainer();
					if ( oContainer == null )
					{
						_error("_populateViews() : Container ["+i+"] is null ! Container id = " + oScreenView.getContainerId() );
					}
					else
					{
						sViewContent = response.getViewContent ( oScreenView.getName() ) ;
						/*** v 1.1.0
						if ( sViewContent != null ) 
						{
							//--- Set the view in the container 
							oScreenView.setContent(sViewContent);
							//oContainer.innerHTML = sViewContent  ;
							//--- If the container has a "onpopulate" event script => call it
							var sScript = oContainer.onpopulate ;
							if ( sScript != null )
							{
								eval ( sScript ) ;
							}
						}
						***/
						if ( sViewContent != null ) // v 1.1.0
						{
							fwkShowViewContent( oContainer, sViewContent ); // v 1.1.0
						}						
					    // else // v 1.1.0.a
					    // { // v 1.1.0.a
							//fwkShowViewContent(pContainer, ""); // v 1.1.0
							//fwkShowViewContent(oContainer, ""); // v 1.1.0.a
					    // } // v 1.1.0.a
						
					}
				}
			}
		}
	}
	
	//==============================================================================
	// PUBLIC METHODS 
	//==============================================================================
	this.setTrace = function ( p ) 
	{
		_bTrace = p ;
	}
	//------------------------------------------------------------------------------
	this.getScreenName = function()
	{
		return _sScreenName ;
	}
	//------------------------------------------------------------------------------
	this.getScreenId = function()
	{
		return _iScreenId ;
	}
	//------------------------------------------------------------------------------
	this.getRequestURL = function() 
	{
		return _sUrlBase ;
	}
	//------------------------------------------------------------------------------
	this.getElementsString = function() 
	{
		if ( _sElements == null )
		{
			//--- Build the elements list
			_buildElementsList();
		}	
		return _sElements ;
	}
	//------------------------------------------------------------------------------
	this.getViews = function() 
	{
		return _aScreenViews ;
	}
	
	//------------------------------------------------------------------------------
	this.ScreenToXml = function( argElementName )
	{
		//_trace ( "ScreenToXml()" );
		var sRet = null ;
    	if ( _aScreenFields.length > 0 ) 
    	{
    		sRet = _serializeFields( argElementName );
    	}
		return sRet ;		
	}

	//------------------------------------------------------------------------------
	this.XmlToScreen = function(response)
	{
		//_trace ( "XmlToScreen()" );
		if ( response.dataNotFound() )
		{
			//_trace("Data not found.");
		}
		else
		{
			//--- Populate FIELDS and VIEWS 
	    	if ( _aScreenFields.length > 0 ) 
	    	{
	    		_populateFields(response);
	    	}
	    	if ( _aScreenViews.length > 0 ) 
	    	{
	    		_populateViews(response);
	    	}
		}		
	}

	//------------------------------------------------------------------------------
	this.RegisterView = function(sContainerId, sScreenZone, sXmlTag, sRenderer )
	{
		if ( sContainerId == null ) 
		{
			_error("RegisterView : no container id !");
			return null ;
		}
		var oContainer = null ;
		try {
			oContainer = document.getElementById(sContainerId);
			if ( oContainer )
			{
				var oScreenView = new ScreenView(sContainerId, oContainer, sScreenZone, sXmlTag, sRenderer);
	    		_aScreenViews.push( oScreenView );
			}
			else
			{
				_error("RegisterView : Container with id " + sContainerId + " not found ! " ) ;
			}
		} catch ( e ) {
			_error ( "Exception in RegisterView()! \n" + e.message ) ;
		}
    	return oContainer ;
	}
	
	//------------------------------------------------------------------------------
	this.RegisterField = function(sFieldId, sScreenZone, sXmlTag, sXmlAttr )
	{
		// _trace("RegisterField(" + sFieldId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		if ( sFieldId == null ) 
		{
			_error("RegisterField : no field id !");
			return null ;
		}
		var oField = null ;
		try {
			oField = document.getElementById(sFieldId);
			if ( oField )
			{
				var oScreenField = new ScreenField(sFieldId, oField, sScreenZone, sXmlTag, sXmlAttr);
	    		_aScreenFields.push( oScreenField );
	    		//--- Is there a picto for the field ?
				var oFieldPicto = document.getElementById(sFieldId+"_picto");
				if ( oFieldPicto )
				{
					oField.oPicto = oFieldPicto ;
					oField.setDisabled = fwkFieldSetDisabled ;
				}
			}
			else
			{
				_error("RegisterField : Object with id " + sFieldId + " not found ! " ) ;
			}
		} catch ( e ) {
			_error ( "Exception in RegisterField()! \n" + e.message ) ;
		}
    	return oField ;
	}
	//------------------------------------------------------------------------------
	this.RegisterFieldDate = function(sId, sScreenZone, sXmlTag, sXmlAttr, sFormat )
	{
		//_trace("RegisterFieldDate(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.getValue  = fwkFieldDateGetValue ;
				obj.setValue  = fwkFieldDateSetValue ;
				obj.format    = sFormat ;
				obj.dateValue = new SimpleDate(null, sFormat);
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterFieldDate : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterHidden = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterComboBox = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterListBox = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterCheckBox = function(sId, sScreenZone, sXmlTag, sXmlAttr, sValOn, sValOff )
	{
		//_trace("RegisterCheckBox(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.valueChecked   = sValOn ;
				obj.valueUnchecked = sValOff ;
				obj.getValue = fwkCheckboxGetValue ;
				obj.setValue = fwkCheckboxSetValue ;
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterCheckBox : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterRadioGroup = function(sId, sScreenZone, sXmlTag, sXmlAttr, aRadioIds )
	{
		//_trace("RegisterRadioGroup(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + "," + aRadioIds + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				//--- Build the "Radio" objects array 
				var aRadios = new Array();
				var oRadio = null ;
				var iRadio = 0 ;
				for ( var i = 0 ; i < aRadioIds.length ; i++ )
				{
					oRadio = document.getElementById( aRadioIds[i] ) ;
					if ( oRadio != null )
					{
						aRadios[iRadio++] = oRadio ;
					}
					else
					{
						_error ( "RegisterRadioGroup() : Radio object not found !  id = " + aRadioIds[i] );
					}
				}
				obj.aRadios = aRadios ;
				//--- Set new methods 
				obj.getValue = fwkRadioGroupGetValue ;
				obj.setValue = fwkRadioGroupSetValue ;			
				obj.setDisabled = fwkRadioGroupSetDisabled ;
				obj.isRadioGroup = true ;
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterRadioGroup : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterTextArea = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.isLongText = true ;
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterTextArea : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterRichTextEditor = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.getValue  = fwkRTEGetValue ;
				obj.setValue  = fwkRTESetValue ;
				obj.isLongText = true ;
				obj.isRichTextEditor = true ;
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterRichTextEditor : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterHtmlViewer = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				//obj.getValue  = xxxx ; // unused
				obj.setValue  = fwkHtmlViewerSetValue ;
				obj.isLongText = true ;
				obj.bDoNotSend = true ;
				obj.isHtmlViewer = true ;
			}
		}
		catch (ex) {
			_error ( "Exception in RegisterHtmlViewer : \n" + ex.message ) ;
		}
	}
			
	//------------------------------------------------------------------------------
	// Clear a specific field passed by reference (object)
	//------------------------------------------------------------------------------
	this.clearField = function ( oField ) // RET : void 
	{
		//_trace ( "Screen.clearField( nodeName=" + oField.nodeName + " id=" + oField.id + ")");
		var sType = oField.type ;
		if ( sType != null )
		{
			switch ( sType )
			{
				case "text" :
				case "file" : 
				case "password" : 
				case "textarea" : 
					oField.value = "" ;
					/**
					// fwkResetFieldErrorStatus(oField); #TODO ????
					try {
						// Option par dfaut (si elle existe)
						if ( oField.fwkDefaultValue != null ) // Par valeur
						{
							oField.value = oField.fwkDefaultValue ;
						}
	  				} catch ( ex ) { 
						oField.value = "" ;
	  				} 
	  				**/
					break ;
						
				case "select-one" : 
				case "select-multiple" :
					oField.selectedIndex = -1 ; // Aucune ligne slectionne (OK / IE & Firefox)
					/**
					try {
						// Option par dfaut (si elle existe)
						if ( oField.fwkDefaultValue != null )	   // Par valeur
						{
							oField.value = oField.fwkDefaultValue ;
						}
						else if ( oField.fwkDefaultIndex != null ) // Par index
						{
							oField.selectedIndex = oField.fwkDefaultIndex ;
						}
	  				} catch ( ex ) { 
		  				oField.selectedIndex = -1 ; 
	  				} 
	  				**/
					break ;
	
				case "checkbox" : 
				case "radio" :
					oField.checked = false ;
					break ;
			}
		}		
		else // NO oField.type 
		{
			if ( oField.isRichTextEditor == true ) // Rich Text Editor 			
			{
				//_trace ( "Screen.clearField( nodeName=" + oField.nodeName + " id=" + oField.id + ") : CLEAR RTE ");			
				fwkRTEClearText(oField); 				
			}
			else if ( oField.isHtmlViewer == true ) // HtmlViewer ( DIV )
			{
				//_trace ( "Screen.clearField( nodeName=" + oField.nodeName + " id=" + oField.id + ") : CLEAR DIV");			
				oField.innerHTML = "" ; // Clear the DIV content
			}
			else if ( oField.isRadioGroup == true ) // RadioGroup widget ( DIV )
			{
				var elements = oField.getElementsByTagName("input") ; 
				if ( elements != null )
				{
					for ( var i=0 ; i < elements.length ; i++ )
					{
						//_trace ( "element["+i+"] : type = " + elements[i].type );
						if ( elements[i].type == "radio" )
						{
							elements[i].checked = false  ;					
						}
					}			
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// Enable / Disable a field
	//------------------------------------------------------------------------------
	this.setFieldDisabled = function ( oField, bFlag ) // RET : void 
	{
		if ( oField.setDisabled ) 
		{
			//--- Specific disabled function for this field
			oField.setDisabled(bFlag) ;
		}
		else
		{
			oField.disabled = bFlag ;
			//fwkSetFieldButtonDisabled(sId, true);
		}
	}
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	this.clearViews = function ( sZone ) // RET : void 
	{
		var oScreenView = null ;
		for ( var i = 0 ; i < _aScreenViews.length ; i++ )
		{
			oScreenView = _aScreenViews[i] ;
			if ( oScreenView != null )
			{
				oScreenView.clear(sZone);
			}
			else
			{
				_error("clearViews() : View ["+i+"] is null ! " );
			}
		}	
	}
	//------------------------------------------------------------------------------
	// Clear the entire screen or a specific zone 
	// sZone arg can be null 
	this.clear = function ( sZone ) // RET : void 
	{
		//_trace("Clear() : sZone = " + sZone );
		var oScreenField = null ;
		var oField = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				_error("clear() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				oField = oScreenField.oField ;
				if ( oField == null )
				{
					_error("clear() : Field ["+i+"] is null ! " );
				}
				else
				{
					if ( sZone == null )
					{
						//_trace("Clear() : field " + i + " - field.type = " + oField.type );
						this.clearField(oField);
					}
					else 
					{
						if ( oScreenField.sZone == sZone )
						{
							this.clearField(oField);
						}
					}
				}			
			}
		}	
		this.clearViews(sZone);
	}
	//------------------------------------------------------------------------------
	// Enable the entire screen or a specific zone 
	// sZone arg can be null 
	//------------------------------------------------------------------------------
	this.enable = function ( sZone ) // RET : void 
	{
		this.setDisabled ( false, sZone ) // RET : void 		
	}
	this.disable = function ( sZone ) // RET : void 
	{
		this.setDisabled ( true, sZone ) // RET : void 		
	}
	this.setDisabled = function ( bFlagDisabled, sZone ) // RET : void 
	{
		var oScreenField = null ;
		var oField = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				_error("setDisabled() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				oField = oScreenField.oField ;
				if ( oField == null )
				{
					_error("setDisabled() : Field ["+i+"] is null ! " );
				}
				else
				{
					if ( sZone == null )
					{
						this.setFieldDisabled(oField, bFlagDisabled );
					}
					else 
					{
						if ( oScreenField.sZone == sZone )
						{
							this.setFieldDisabled(oField, bFlagDisabled );
						}
					}
				}			
			}
		}	
	}
		
	//------------------------------------------------------------------------------
	// METHODE : Desc
	//------------------------------------------------------------------------------
	this.desc = function()
	{
		alert ( "SCREEN OBJECT : \n" +
				"\n . Screen-Name = " + _sScreenName + 
				"\n . Context Id = " + _iScreenId +
				"\n . UrlBase = " + _sUrlBase + 
				"\n . Elements : " + this.getElementsString() +
				"\n . " + _aScreenFields.length + " field(s) " +
				"" );
	}

	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
/***
	this.OnLoad = function () // RET : void
	{
		this.New();
		this.printMessage();
	}
	//------------------------------------------------------------------------------
	this.Exit = function()
	{
		//--- On essaye de fermer l'cran
		try {
			this.close();
		}
		catch (e) {}

		//--- Si l'cran n'a pas t ferm on rinitialise l'cran
		this.New();
		this.printMessage();
	}
	//------------------------------------------------------------------------------
	this.close = function() // TODO ???
	{
		//--- Ecran popup
		if ( _iScreenId > 0 )
		{
			//--- On sort de l'cran
			window.close();
		}
		//--- Premier champ de l'cran
		else 
		{
			try
			{
				//--- On ouvre la page d'accueil
				document.location.href = PageAccueil; // TODO ???
			} catch (e) {}
		}
	}
	//------------------------------------------------------------------------------
***/
	//==============================================================================
	//  GESTION DES CHAMPS ( KeyFields et DataFields ) : Disable / Clear / Check
	//==============================================================================

	//------------------------------------------------------------------------------
	// Check a specific field
	//------------------------------------------------------------------------------
	this.CheckField = function ( oField ) // RET : boolean : true = OK / false = NOK 
	{
		//--- Champ NOT NULL -------------------------------------------------------
		if ( oField.getAttribute("fwkNotNull") )
		{
			// _trace ( "Check field ( id = " +oField.id+ " ) : attribute fwkNotNull found." ) ;
			switch ( oField.getAttribute("type") )
			{
				case "text" :       // Tag "input type=text "
				case "file" :
				case "password" :
				case "textarea" :   // Tag "textarea "
				case "select-one" : // Tag "select"
				// case "checkbox" :  // Not Null n'a pas de sens pour une "Check Box"
				// case "radio" :     // Not Null n'a pas de sens pour un  "Radio Button"
					if ( oField.value == null || oField.value == "" ) 
					{
						_oInvalidField = oField ;
						var memoColor = oField.style.backgroundColor ;
						oField.style.backgroundColor = 'orange' ;
						_error ( "The field "+oField.name+ " ( id = " +oField.id+ " ) is required " );
						oField.style.backgroundColor = memoColor ;
						return false ;
					}
					break ;
			}
		}
		//--- Champ dans l'tat VALEUR INCORRECTE ---------------------------------- 
		if ( fwkIsFieldOnError(oField) || fwkIsFieldOnShallowCheckingError(oField) )
		{
			_oInvalidField = oField ;
			//_trace ( "There is an invalid field (at least) !" );
			return false ;
		}
		return true ;
	}


	//------------------------------------------------------------------------------
	// Fonction de vrification de l'ensemble des champs
	// ( La sortie du champ ventuellement en cours de saisie est force 
	// au niveau de la gestion des touches de fonctions )
	//------------------------------------------------------------------------------
	this.CheckAllFields = function () // RET : boolean : true = OK / false = NOK
	{
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			if ( this.CheckField(_aScreenFields[i]) == false ) return false ;
		}
		//--- Here all the fields are OK
		_oInvalidField = null ;
		return true ; 
	}

	//------------------------------------------------------------------------------
	function _getFieldParamValue ( oScreenField )
	{
		var oField = oScreenField.oField ;
		if ( oField == null )
		{
			_error("_setParamValue : ScreenField '" + oScreenField.sId + "' : oField attribute is null !" );
			return null ;
		}
		else
		{
			//--- If field marked as "DO NOT SEND TO SERVER" ( Receive only ) => do not use as parameter
			if ( oField.bDoNotSend ) return null ;
			
			//--- Long Text field : cannot be send as a parameter
			if ( oField.isLongText == true ) return null ;

			//--- Classical field => use the value as a parameter if not void
			var sFieldValue = null ;
			if ( oField.getValue )
			{
				sFieldValue = oField.getValue() ;
			}
			else
			{
				sFieldValue = oField.value ;
			}
			if ( sFieldValue == "" ) return null ;
			return sFieldValue ;
		}
	}
	//------------------------------------------------------------------------------
	this.setParametersFromFields = function ( argParamMap, argElementName ) // v 1.1.0
	{
		if ( argParamMap == null ) 
		{
			_error("setParametersFromFields : argParamMap is null");
			return ;
		}
		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField != null )
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					if ( argElementName != null )
					{
						if ( argElementName == oScreenField.sXmlTag )
						{
							var sValue = _getFieldParamValue ( oScreenField );
							if ( sValue != null ) argParamMap.put(oScreenField.sXmlAttr, sValue) ;
						}
					}
					else
					{
						var sValue = _getFieldParamValue ( oScreenField );
						if ( sValue != null ) argParamMap.put(oScreenField.sXmlAttr, sValue) ;
					}
				}
			}
		}
	}
	
	//==============================================================================
	//  ACTIONS UTILISATEUR 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Triggers : A SURCHARGER SI NECESSAIRE
	//------------------------------------------------------------------------------
	this.beforeSelect = function () { return true ; }
	this.afterSelect  = function () { return ; }
	this.beforeUpdate = function () { return true ; }
	this.afterUpdate  = function () { return ; }
	this.beforeInsert = function () { return true ; }
	this.afterInsert  = function () { return ; }
	this.beforeDelete = function () { return true ; }
	this.afterDelete  = function () { return ; }

}

//------------------------------------------------------------------------------
// ScreenRequest_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenRequest( )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _bTrace  = false ;
	var _sEOL    = TelosysConst.getRequestEndOfLine() ;
	
	var _sScreenName = null ;
	var _sScreenId   = null ;
	var _sAction     = null ;
	var _sProcedure  = null ;
	var _sElements   = null ;
	
	var _sFlagGet    = null ;
	var _sFlagSet    = null ;
	var _sFlagClear  = null ;
	
	var _oParameters = new Object();
	var _oViews      = null ;

	var _sDataTags   = null ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenRequest] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenRequest] : \n\n" + sMsg ) ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setScreenName = function ( s ) 
	{
		_sScreenName = s ;
	}
	this.getScreenName = function() 
	{
		return _sScreenName ;
	}
	//------------------------------------------------------------------------------
	this.setScreenId = function ( s ) 
	{
		_sScreenId = s ;
	}
	this.getScreenId = function() 
	{
		return _sScreenId ;
	}
	//------------------------------------------------------------------------------
	this.setAction = function ( s ) 
	{
		_sAction = s ;
	}
	this.getAction = function() 
	{
		return _sAction ;
	}
	//------------------------------------------------------------------------------
	this.setProcedure = function ( s ) 
	{
		_sProcedure = s ;
	}
	this.getProcedure = function() 
	{
		return _sProcedure ;
	}
	//------------------------------------------------------------------------------
	this.setElements = function ( s )
	{
		_sElements = s ;
	}
	this.getElements = function()
	{
		return _sElements ;
	}
	//------------------------------------------------------------------------------
	this.setFlagGet = function ( s ) 
	{
		_sFlagGet = s ;
	}
	this.getFlagGet = function() 
	{
		return _sFlagGet ;
	}
	//------------------------------------------------------------------------------
	this.setFlagSet = function ( s ) 
	{
		_sFlagSet = s ;
	}
	this.getFlagSet = function () 
	{
		return _sFlagSet ;
	}
	//------------------------------------------------------------------------------
	this.setFlagClear = function ( s ) 
	{
		_sFlagClear = s ;
	}
	this.getFlagClear = function() 
	{
		return _sFlagClear ;
	}
	
	//------------------------------------------------------------------------------
	// Parameters
	//------------------------------------------------------------------------------
	this.setParameter = function ( sName, sValue ) 
	{		
		_trace ( "setParameter : " + sName + "=" + sValue ) ;
		if ( sName == null )
		{
			_error ( "setParameter() : name = null" );
			return ;
		}
		if ( sValue == null )
		{
			_error ( "setParameter() : value = null" );
			return ;
		}
		if ( _oParameters == null ) { _oParameters = new Object(); }
		_oParameters[sName] = sValue ;
	}
	//------------------------------------------------------------------------------
	this.clearParameters = function () 
	{		
		_trace ( "clearParameters " ) ;
		_oParameters = new Object(); ;
	}
	//------------------------------------------------------------------------------
	this.showParameters = function () 
	{
		if ( _oParameters != null ) 
		{
			var s = "PARAMETERS : \n" ;
			for ( p	in _oParameters )
			{
				s += p + "=" + _oParameters[p] + "\n" ;
			}
			alert( s ); 
		}
		else
		{
			alert( "NO PARAMETERS" ); 
		}
	}
	//------------------------------------------------------------------------------
	// Views
	//------------------------------------------------------------------------------
	this.setView = function ( sName, sRenderer ) 
	{		
		_trace ( "setView : view='" + sName + "' renderer='" + sRenderer +"'") ;
		if ( sName == null )
		{
			_error ( "setView() : name = null" );
			return ;
		}
		if ( sRenderer == null )
		{
			_error ( "setView() : renderer = null" );
			return ;
		}
		if ( _oViews == null ) { _oViews = new Object(); }
		_oViews[sName] = sRenderer ;
	}
	//------------------------------------------------------------------------------
	this.clearViews = function () 
	{		
		_trace ( "clearViews" ) ;
		_oViews = null ;
	}
	//------------------------------------------------------------------------------
	this.showViews = function () 
	{
		if ( _oViews != null ) 
		{
			var s = "VIEWS : \n" ;
			for ( v	in _oViews )
			{
				s += " name='" + v + "' renderer='" + _oViews[v] + "' \n" ;
			}
			alert( s ); 
		}
		else
		{
			alert( "NO VIEWS" ); 
		}
	}

	//------------------------------------------------------------------------------
	// Data XML Tags ( to be inserted between <data> and </data> )
	//------------------------------------------------------------------------------
	this.setData = function ( s ) 
	{
		_trace ( "setData() : \n" + s ) ;
		_sDataTags = s ;
	}
	//------------------------------------------------------------------------------
	this.clearData = function ( s ) 
	{
		_trace ( "clearData()" ) ;
		_sDataTags = null ;
	}
	//------------------------------------------------------------------------------
	this.showData = function () 
	{
		alert ( "DATA : \n" + _sDataTags ) ;
	}
		
	//------------------------------------------------------------------------------
	// Build and return the XML Request
	//------------------------------------------------------------------------------
	this.getXmlRequest = function () 
	{
		var sXml = "<request " 
			+ " screen-name=\"" + _sScreenName + "\" " 
			+ " screen-id=\""   + _sScreenId   + "\" " 
			+ " action=\""      + _sAction     + "\" " ;
		if ( _sAction.toLowerCase() == "exec" ) 
		{
			if ( _sProcedure != null ) 
			{
				sXml += " proc-name=\"" + _sProcedure + "\" " ;
			}
			else
			{
				_error("action 'exec' without procedure name ! ");
			}
		}
		if ( _sElements != null ) 
		{
			sXml += " elements=\"" + _sElements + "\" " ;
		}
		if ( _sFlagGet != null ) 
		{
			sXml += " get=\"" + _sFlagGet + "\" " ;
		}
		if ( _sFlagSet != null ) 
		{
			sXml += " set=\"" + _sFlagSet + "\" " ;
		}
		if ( _sFlagClear != null ) 
		{
			sXml += " clear=\"" + _sFlagClear + "\" " ;
		}		
		sXml += " >" + _sEOL ;

		//--- Parameters list 
		if ( _oParameters != null )
		{
			var sParams = "" ;
			var iParamsCount = 0 ;
			for ( p	in _oParameters )
			{
				sParams += "<param " + p + "=\"" + _oParameters[p] + "\" />" + _sEOL;
				iParamsCount++ ;
			}
			if ( iParamsCount > 0 ) 
			{
				sXml += "<params>" + _sEOL + sParams + "</params>" + _sEOL ;
			}
		}
		
		//--- Views list 
		if ( _oViews != null )
		{
			var sViews = "" ;
			var iViewsCount = 0 ;
			for ( v	in _oViews )
			{
				sViews += "<view name=\"" + v + "\" renderer=\"" + _oViews[v] + "\" />" + _sEOL;
				iViewsCount++ ;
			}
			if ( iViewsCount > 0 ) 
			{
				sXml += "<views>" + _sEOL + sViews + "</views>" + _sEOL;
			}
		}		
		
		//--- Data Tags ( 1 to N )
		if ( _sDataTags != null )
		{
			sXml += "<data>" + _sEOL ;
			sXml += _sDataTags ;
			sXml += "</data>" + _sEOL ;						
		}
		
		//--- End of requet
		sXml += "</request>" + _sEOL ;
		
		_trace( "getXmlRequest() : \n" + sXml ); 
		return sXml ;
	}	
	//------------------------------------------------------------------------------	
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenResponse_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenResponse( oXmlHttpRequest )
{
	//==============================================================================
	// STANDARD ATTRIBUTES & METHODS
	//==============================================================================
	var _bTrace = false ;
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenResponse] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenResponse] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iReadyState     = oXmlHttpRequest.readyState ; // 1, .. , 4 (complete)
	var _iHttpStatusCode = oXmlHttpRequest.status ; // HTTP Status Code ( ie : "200" = "OK" )
	var _sHttpStatusText = oXmlHttpRequest.statusText ; // HTTP Status Text ( ie : "OK" )
	var _sResponseText   = oXmlHttpRequest.responseText ; // Response Body as text 
	var _oResponseXML    = oXmlHttpRequest.responseXML  ; // Response Body as XML Document (DOM tree)
	var _sReturnCode     = "" ; // Telosys Return Code ( ie : "0" for "OK" )
	var _sReturnMessage  = "" ; // Telosys Return Message 
	var _htValues        = null ; // Values hashtable : init by getValues()
	
	var _tagResponse   = null ;
	var _tagReturn     = null ;
	var _tagValues     = null ;
	var _tagData       = null ;
	var _tagView       = null ;
	var _tagOutputErrors = null ;
	
	if ( _iReadyState != 4) // 4 = complete
	{
		//--- Error
		_error("Request state is NOT COMPLETE ( readyState = " + _iReadyState + " ) ");
	}
	else
	{
		if ( _iHttpStatusCode != 200 ) // 200 = OK
		{
			//--- Error
			_error("HTTP ERROR ( Status = " + _iHttpStatusCode + " - " + _sHttpStatusText + " ) ");
		}
		else
		{
			_initFirstLevelTags() ;
		}
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _initFirstLevelTags()  // v 1.0.5
	{
		var root = _oResponseXML.documentElement ;
		if ( null == root )
		{
			_error("Cannot get XML root element" );
			return;
		}
		if ( root.tagName != "response" )
		{
			_error("The XML root tag name is '" +  root.tagName + "' ( 'response' expected )" );
			return;
		}
		_tagResponse = root ;
		
		var nodes = root.childNodes ;
		if ( null == nodes )
		{
			_error("No child nodes in the XML root element" );
			return;
		}
		var n = nodes.length ;
		for ( i=0 ; i < n ; i++ )
		{
			var node = nodes[i] ;
			// _trace ( "Root child node [" + i + "] : nodeName = '" + node.nodeName + "'  nodeType = " + node.nodeType ) ;
			if ( node.nodeType == 1 ) // this node is an element ( = a tag )
			{
				if ( node.nodeName == "return"        ) { _tagReturn     = node ; } 
				if ( node.nodeName == "values"        ) { _tagValues     = node ; } 
				if ( node.nodeName == "data"          ) { _tagData       = node ; } 
				if ( node.nodeName == "view"          ) { _tagView       = node ; } 
				if ( node.nodeName == "output-errors" ) { _tagOutputErrors = node ; } 			
			}
		}
		if ( null == _tagReturn ) 
		{
			_error("No <return> tag in the response !");
		}
		else
		{
			_initReturn( _tagReturn ) ;
		}
	}
	//------------------------------------------------------------------------------
	function _initReturn( tagReturn ) 
	{
		if ( tagReturn != null )
		{
			//--- Get the "code" attribute
			try {
				var sRetCode = tagReturn.getAttribute("code") ;
				if ( sRetCode == null )
				{
					_sReturnCode = "" ;
					_error("No 'code' attribute in the <return> tag !");
				}
				else
				{
					_sReturnCode = sRetCode ;
				}
			} catch (e) {
				_error("Exception on getAttribute('code') in <return> tag !\nException : " + e.message );
			}
			
			//--- Get the "message" attribute
			try {
				var sRetMessage = tagReturn.getAttribute("message") ;
				if ( sRetMessage == null )
				{
					_sReturnMessage = "" ;
					_error("No 'message' attribute in the <return> tag !");
				}
				else
				{
					_sReturnMessage = sRetMessage ;
				}
			} catch (e) {
				_error("Exception on getAttribute('message') in <return> tag !\nException : " + e.message );
			}		
		}
	}
	//------------------------------------------------------------------------------
	/***
	function _getXmlSingleTag ( sTagName, bMandatory ) 
	{
		if ( _oResponseXML == null )
		{
			_error("_getXmlSingleTag(" + sTagName + ") : Xml response is null !");
			return null ;
		}
		var tag = null ;
		try {
			var allTags = _oResponseXML.getElementsByTagName( sTagName ) ;
			if ( allTags != null )
			{
				//_trace ( "_getXmlSingleTag(" + sTagName + ") : " + allTags.length + " element(s)" );			
				//--- There is a single tag for this name so we take the first one
				tag = allTags.item(0) ;
			}
			else
			{
				_error("_getXmlSingleTag() : No tag <" + sTagName + "> in the XML response ! \n getElementsByTagName(..) return null !");
			}
		} catch (e) {
			_error("_getXmlSingleTag(" + sTagName + ") \nException : " + e.message );
		}
		if ( tag == null && bMandatory == true )
		{
			_error("No tag <" + sTagName + "> in the XML response !");
		}
		return tag ;
	}
	***/
	//------------------------------------------------------------------------------
	function _getReturnSubTag ( sTagName ) // v 1.0.5
	{
		var tagReturn = _tagReturn ;
		if ( tagReturn != null )
		{
			//--- Get the SUB TAG  
			var tag = null ;
			try {
				tag = tagReturn.getElementsByTagName( sTagName ).item(0);
			} catch (e) {
				tag = null ;
			}
			return tag ;
		}
		return null ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.isOK = function () 
	{
		if ( ( _iReadyState == 4 ) && ( _iHttpStatusCode == 200 ) && ( _sReturnCode == "0" ) ) 
		{
			return true ;
		}
		else
		{
			return false ;
		}
	}
	//------------------------------------------------------------------------------
	this.reportsErrors = function () // v 1.0.5
	{
		if ( this.isOK() != true ) return true ;
		if ( this.hasExceptions() ) return true ;
		if ( this.hasErrors() ) return true ;
		if ( this.hasOutputErrors() ) return true ;
	}
	//------------------------------------------------------------------------------
	this.hasOutputErrors = function () // v 1.0.5
	{
		return ( _tagOutputErrors != null ) ;
	}
	//------------------------------------------------------------------------------
	function _getErrorCauses (tag) // v 1.0.5
	{
		if ( tag != null )
		{
			var causeTags = null ;
			try {
				causeTags = tag.getElementsByTagName("cause");
			} catch (e) {
				causeTags = null ;
			}
			if ( causeTags != null )
			{
				var causes = [] ;
				var i = 0 ;
				var n = causeTags.length ;
				for ( i = 0 ; i < n ; i++ )
				{
					var o = new Object();
					try {
						var item = causeTags.item(i) ;
						o.exception = item.getAttribute("exception");
						o.message   = item.getAttribute("message");
					} catch (e) {
						_error("getErrorCauses() \nError on getAttribute() !\nException : " + e.message );
						return null ;
					}
					causes[i] = o ;
				} 
				return causes;
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	/***
	this.getViewErrors = function () // v 1.0.5
	{
		return this.getOutputErrors();
		
		//var tagViewErrors = _getXmlSingleTag("view-errors", false) ;
		var tagViewErrors = _tagOutputErrors ;
		if ( tagViewErrors != null )
		{
			var tagErrorList = null ;
			try {
				tagErrorList = tagViewErrors.getElementsByTagName("view-error");
			} catch (e) {
				tagErrorList = null ;
			}
			if ( tagErrorList != null )
			{
				var errors = [] ;
				var i = 0 ;
				var n = tagErrorList.length ;
				for ( i = 0 ; i < n ; i++ )
				{
					var errorObject = new Object();
					try {
						var item = tagErrorList.item(i) ;
						errorObject.view      = item.getAttribute("view"); // <view-error> only 
						errorObject.renderer  = item.getAttribute("renderer"); // <view-error> only 
						errorObject.dataName  = item.getAttribute("name");  // <data-error> only 
						errorObject.dataClass = item.getAttribute("class"); // <data-error> only 
						errorObject.exception = item.getAttribute("exception");
						errorObject.message   = item.getAttribute("message");
					} catch (e) {
						_error("getViewErrors() \nError on getAttribute() !\nException : " + e.message );
						return null ;
					}
					errorObject.causes = _getErrorCauses(item);
					errors[i] = errorObject ;
				} 
				return errors;
			}
		}
		return null ;
	}
	***/
	//------------------------------------------------------------------------------
	this.getOutputErrors = function () // v 1.0.5
	{
		if ( _tagOutputErrors != null )
		{
			var nodes = _tagOutputErrors.childNodes ;
			if ( nodes != null )
			{
				var errors = [] ;
				var x = 0 ;
				var n = nodes.length ;
				for ( i=0 ; i < n ; i++ )
				{
					var node = nodes[i] ;
					if ( node.nodeType == 1 ) // this node is an element ( = a tag )
					{
						if ( node.nodeName == "view-error" || node.nodeName == "data-error" ) 
						{
							var errorObject = new Object();
							var item = node ;
							try {
								errorObject.view      = item.getAttribute("view"); // <view-error> only 
								errorObject.renderer  = item.getAttribute("renderer"); // <view-error> only 
								errorObject.dataName  = item.getAttribute("name");  // <data-error> only 
								errorObject.dataClass = item.getAttribute("class"); // <data-error> only 
								errorObject.exception = item.getAttribute("exception");
								errorObject.message   = item.getAttribute("message");
							} catch (e) {
								_error("getOutputErrors() \nError on getAttribute() !\nException : " + e.message );
								return null ;
							}
							errorObject.causes = _getErrorCauses(item);
							errors[x++] = errorObject ;
						}
					}
				}
				return errors;
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.getExceptionsAsText = function () // v 1.0.5
	{
		var exceptions = this.getExceptions();		
		if ( exceptions != null )
		{
			var s = "" ;
			for ( i=0 ; i < exceptions.length ; i++ )
			{
				var e = exceptions[i] ;
				s = s 
					+ "\n=> Exception : " + e.getClass()
					+ "\n   Message : " + e.getMessage()
				/* TODO
				if ( e.getCauses() != null )
				{
					var causes = e.getCauses()
					for ( x=0 ; x < causes.length ; x++ )
					{
						var c = causes[x];
						s = s + "\n  . Cause : " + c.exception + " : " + c.message ;
					}
				}
				*/
				s = s + "\n\n" ;
			}			
			return s ;
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.getErrorsAsText = function () // v 1.0.5
	{
		var errors = this.getErrors();		
		if ( errors != null )
		{
			var s = "" ;
			for ( i=0 ; i < errors.length ; i++ )
			{
				var e = errors[i] ;
				s = s 
					+ "\n=> Error code : " + e.getCode()
					+ "\n   Message : " + e.getText()
				s = s + "\n\n" ;
			}			
			return s ;
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.getOutputErrorsAsText = function () // v 1.0.5
	{
		var errors = this.getOutputErrors();		
		if ( errors != null )
		{
			var s = "" ;
			for ( i=0 ; i < errors.length ; i++ )
			{
				var e = errors[i] ;
				if ( e.view ) {
					s = s + "\n=> View '" + e.view +"'" 
						  + "\n   Renderer : " + e.renderer ;
				}
				if ( e.dataName ) {
					s = s + "\n=> Data name '" + e.dataName +"'" 
						  + "\n   Class : " + e.dataClass ;
				}
				s = s + "\n   Message : " + e.message 
					  + "\n   Exception : " + e.exception ;
				
				if ( e.causes != null )
				{
					var causes = e.causes
					for ( x=0 ; x < causes.length ; x++ )
					{
						var c = causes[x];
						s = s + "\n  . Cause : " + c.exception + " : " + c.message ;
					}
				}
				s = s + "\n\n" ;
			}			
			return s ;
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.showOutputErrors = function ( bSilent ) // v 1.0.5
	{
		var s = this.getOutputErrorsAsText();
		if ( s != null )
		{
			alert( "Output errors : \n" + s ) ;
		}
		else
		{
			if ( true == bSilent ) return ;
			else alert("No output error in the response.\n") ;
		}
	}
	//------------------------------------------------------------------------------
	// Return the response as TEXT flow
	//------------------------------------------------------------------------------
	this.getResponseText = function () 
	{
		return _sResponseText ;
	}
	//------------------------------------------------------------------------------
	this.getResponseXML = function () 
	{
		return _oResponseXML ;
	}
	//------------------------------------------------------------------------------
	this.getReadyState = function () 
	{
		return _iReadyState ;
	}
	//------------------------------------------------------------------------------
	this.getHttpStatusCode = function () 
	{
		return _iHttpStatusCode ;
	}
	//------------------------------------------------------------------------------
	this.getHttpStatusText = function () 
	{
		return _sHttpStatusText ;
	}
	//------------------------------------------------------------------------------
	this.getReturnCode = function () 
	{
		return _sReturnCode ;
	}
	//------------------------------------------------------------------------------
	this.getReturnMessage = function () 
	{
		return _sReturnMessage ;
	}
	//------------------------------------------------------------------------------
	this.dataNotFound = function ()
	{
		return ( _getReturnSubTag ( "not-found" ) != null ) ; // v 1.0.5
	}
	//------------------------------------------------------------------------------
	this.dataFound = function ()
	{
		return ( _getReturnSubTag ( "found" ) != null ) ; // v 1.0.5
	}
	//------------------------------------------------------------------------------
	this.getActionInfos = function ()
	{
		var tag = _tagResponse ;
		if ( tag != null )
		{
			var o = new Object();
			try {
				o.screenName = tag.getAttribute("screen-name");
				o.screenId   = tag.getAttribute("screen-id");
				o.action     = tag.getAttribute("action");
				o.procName   = tag.getAttribute("proc-name");
			} catch (e) {
				_error("getActionInfos() \nError on getAttribute() !\nException : " + e.message );
				return null ;
			}
			return o ;
		}
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// Return true if <response> <data void="true" /> </response> 
	//------------------------------------------------------------------------------
	this.dataVoid = function ()
	{
		var bRet = false ;
		//var tagData = _getXmlSingleTag("data", false) ;
		var tagData = _tagData ;
		if ( tagData != null )
		{
			//--- Get the "void" attribute  
			var attribVoid = null ;
			try {
				attribVoid = tagData.getAttribute("void");
			} catch (e) {
				attribVoid = null ;
			}
			bRet = ( attribVoid != null ? true : false ) ;
		}
		else
		{
			//--- No tag <data> => VOID
			bRet = true ;
		}
		return bRet ;
	}
	
	//------------------------------------------------------------------------------
	this.show = function () 
	{
		var sMsg = "RESPONSE : \n" ;
		sMsg += "Request state : " + _iReadyState + " ( 4 = complete ) \n" ;
		sMsg += "Http Status : " + _iHttpStatusCode + " - " + _sHttpStatusText + " \n" ;
		sMsg += "Response text : \n" + _sResponseText  ;
		alert( sMsg ); 
	}
	//------------------------------------------------------------------------------
	/***
	this.getXmlTagData = function () 
	{
		var tagData = null ;
		try {
			var allTagsData = _oResponseXML.getElementsByTagName( "data" ) ;
			if ( allTagsData != null )
			{
				//--- There is a single tag <data> so we take the first one
				tagData = allTagsData.item(0) ;
			}
		} catch (e) {
			_error("getXmlTagData() \nException : " + e.message );
		}
		return tagData ;
	}
	***/
	//------------------------------------------------------------------------------
	this.getDataFieldValue = function ( sTag, sAttr, bChildTag ) 
	{
		if ( _oResponseXML == null )
		{
			_error("Xml response is null !");
			return null ;
		}
		//--- Get the tag <data>
		//var tagData = _getXmlSingleTag("data", false) ;
		var tagData = _tagData ;
		if ( tagData == null )
		{
			_error("No <data> in the response !");
			return null ;
		}		
		//--- Get the given "element" TAG  
		var xmlTag = null ;
		try {
			xmlTag = tagData.getElementsByTagName(sTag).item(0);
		} catch (e) {
			xmlTag = null ;
		}
		if ( xmlTag == null )
		{
			//_trace(sTag+"." + sAttr + "\nTag not found.");
			return null ;
		}
		var sValue = null ;
		if ( bChildTag == true ) //--- Get the value from CHILD TAG CONTENT ( for "LONG TEXT" )
		{
			var childs = xmlTag.getElementsByTagName(sAttr) ;
			if ( childs != null )
			{
				// only one child with the given name => take the first one 
				if ( childs.length > 0 )
				{
					var childTag = childs.item(0);  // Tag ( type = 1 : ELEMENT_NODE )
					//_trace ( "CHILD TAG : name=" + childTag.nodeName + ", type=" + childTag.nodeType );
					//--- Get the TEXT content of the TAG 
					var childText = childTag.firstChild ; // Content = child node ( type = 3 or 4 : TEXT_NODE or CDATA_SECTION )
					if ( childText != null )
					{
						//_trace ( "CHILD TEXT : name=" + childText.nodeName + ", type=" + childText.nodeType );
						try {
							//_trace ( " value=" + childText.nodeValue );
							sValue = childText.nodeValue ;
						} catch (e) {
							_error("getDataFieldValue("+sTag+","+sAttr+","+bChildTag+") \n"
									+"Error on child.nodeValue (child name : " + child.nodeName + ") \n"
									+"Exception : " + e.message );
							sValue = null ;
						}
					}
				}
			}
		}
		else //--- Get the value from ATTRIBUTE ( standard case )
		{
			try {
				sValue = xmlTag.getAttribute(sAttr) ;
			} catch (e) {
				_error("getDataFieldValue("+sTag+","+sAttr+","+bChildTag+") \n" 
						+ "Error on tag.getAttribute(" + sAttr + ") \n"
						+ "Exception : " + e.message );
				sValue = null ;
			}
		}
		//_trace("getDataFieldValue("+sTag+","+sAttr+","+bChildTag+") : value = '" + sValue + "'" );
		return sValue ;
	}

	//------------------------------------------------------------------------------
	this.hasMessages = function () // v 1.0.5
	{
		return ( _getReturnSubTag ( "messages" ) != null ) ;
	}
	//------------------------------------------------------------------------------
	this.getMessages = function () 
	{
		var tagMessages = _getReturnSubTag ( "messages" );
		if ( tagMessages != null )
		{
			messages = tagMessages.getElementsByTagName("message");
			if ( messages != null )
			{
				var msgList = [] ;
				var i = 0 ;
				var n = messages.length ;
				var msg = null ;
				var code = null ;
				var text = null ;
				var type = null ;
				for ( i = 0 ; i < n ; i++ )
				{
					msg = messages.item(i) ;
					try {
						code = msg.getAttribute("code");							
						text = msg.getAttribute("text");
						type = msg.getAttribute("type");
					} catch (e) {
						_error("getMessages() \nError on getAttribute() !\nException : " + e.message );
						return null ;
					}
					msgList[i] = new ScreenMessage(code, text, type);
				} 
				return msgList;
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.hasErrors = function () // v 1.0.5
	{
		return ( _getReturnSubTag ( "errors" ) != null ) ;
	}
	//------------------------------------------------------------------------------
	this.getErrors = function ()  // v 1.0.5
	{
		var tagErrors = _getReturnSubTag ( "errors" ) ;
		if ( tagErrors != null )
		{
			elements = tagErrors.getElementsByTagName("error");
			if ( elements != null )
			{
				var errors = [] ;
				var i = 0 ;
				var n = elements.length ;
				var element = null ;
				var code = null ;
				var text = null ;
				for ( i = 0 ; i < n ; i++ )
				{
					element = elements.item(i) ;
					try {
						code = element.getAttribute("code");							
						text = element.getAttribute("text");
					} catch (e) {
						_error("getErrors() \nError on getAttribute() !\nException : " + e.message );
						return null ;
					}
					errors[i] = new ScreenError(code, text);
				} 
				return errors;
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.hasExceptions = function () // v 1.0.5
	{
		return ( _getReturnSubTag ( "exceptions" ) != null ) ;
	}
	//------------------------------------------------------------------------------
	// Returns an array of exceptions (or null) if there's no exception in the response
	//------------------------------------------------------------------------------
	this.getExceptions = function () 
	{
		var tagExceptions = _getReturnSubTag ( "exceptions" ) ;
		if ( tagExceptions != null )
		{
			exceptions = tagExceptions.getElementsByTagName("exception");
			if ( exceptions != null )
			{
				var exList = [] ;
				var i = 0 ;
				var n = exceptions.length ;
				var exception = null ;
				var iNum     = null ;
				var sClass   = null ;
				var sMessage = null ;
				for ( i = 0 ; i < n ; i++ )
				{
					exception = exceptions.item(i) ;
					try {
						iNum     = exception.getAttribute("num");							
						sClass   = exception.getAttribute("class");
						sMessage = exception.getAttribute("message");
					} catch (e) {
						_error("getExceptions() \nError on getAttribute() !\nException : " + e.message );
						return null ;
					}
					exList[i] = new ScreenException(iNum, sClass, sMessage);
				} 
				return exList;
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	// Return the value of the given value name
	// <values> <value-name value="xxx" /> </values>
	//------------------------------------------------------------------------------
	this.getValue = function ( sName ) 
	{
		var htValues = this.getValues();
		if ( htValues != null )
		{
			return htValues[sName];
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	this.hasValues = function () // v 1.0.5
	{
		// return ( _getXmlSingleTag("values", false) != null ) ;
		return ( _tagValues != null ) ;
	}
	//------------------------------------------------------------------------------
	// Return all the values of the response ( hashtable )
	// <values> <value-name value="xxx" /> </values>
	//------------------------------------------------------------------------------
	this.getValues = function () 
	{
		if ( _htValues != null ) // if already loaded
		{
			return _htValues ; // return the existing hashtable
		}
		//--- Get the TAG  
		//var tagValues = _getXmlSingleTag("values", false) ;
		var tagValues = _tagValues ;
		if ( tagValues != null )
		{
			try {
				var values = tagValues.getElementsByTagName("value");
				if ( values != null )
				{
					var htValues = new Object() ;
					var value = null ;
					var i = 0 ;
					var n = values.length ;
					for ( i = 0 ; i < n ; i++ ) // for each tag <value>
					{
						value = values.item(i) ;
						if ( value.attributes != null )
						{
							if ( value.attributes.length > 0 )
							{
								// store in the Values HashTable 
								htValues[value.attributes[0].name] = value.attributes[0].value ;
							}								
						}
					} 
					if ( _htValues == null )
					{
						_htValues = htValues ;
					}
					return htValues;
				}
			} catch (ex) {
				_error("getValues() \n Exception : " + ex.message );
				return null ;
			}
		}
		return null ;
	}	
	//------------------------------------------------------------------------------
	this.showValues = function ( bSilent ) 
	{
		var htValues = this.getValues();
		if ( htValues != null )
		{
			var s = "" ;
			for ( name in htValues )
			{
				s = s + "\n . " + name + " = " + htValues[name] ;
			}
			alert ( "Values : " + s ) ;
		}
		else
		{
			if ( true == bSilent ) return ;
			else alert("No value in the response.\n") ;
		}	
	}
	//------------------------------------------------------------------------------
	this.hasView = function ()
	{
	/**
		if ( _tagView != null )
		{
			if ( tagView.hasChildNodes() ) return true ;
			var elements = _tagView.getElementsByTagName( "view" );
			if ( elements != null )
			{
				if ( elements.length > 0 ) return true ;
			}	
		}
		return false ;
	**/
		return ( _tagView != null ) ;
	}
	//------------------------------------------------------------------------------
	this.getViewContent = function ( sViewTagName )
	{
	/***
		if ( null == _tagView ) return null ;
		var elements = _tagView.getElementsByTagName( "view" );
		if ( null == elements ) return null ;
		if ( elements.length < 1 ) return null ;
	***/

//_trace("getViewContent('" + sViewTagName + "')" );

		var tagView = _tagView ; // <view> ... </view>
		if ( null == tagView ) return null ;
		if ( ! tagView.hasChildNodes() )
		{
			return null ;
		}
		//_trace("Element <view> has " + tagView.childNodes.length + " child node(s)" );
		
		//--- Get the tag with a name = sViewTagName
		var oNodeList = tagView.getElementsByTagName( sViewTagName );
		if ( oNodeList == null ) return null ;
		if ( oNodeList.length < 1 ) return null ;
		// Supposed to be unique => Get the fist element of the list 
		var elementView = oNodeList.item(0) ;
		
//_trace("getViewContent('" + sViewTagName + "') : View found " );

		//--- Search the first CDATA-SECTION in the child nodes 
		for ( i = 0 ; i < elementView.childNodes.length ; i++ )
		{
			node = elementView.childNodes[i];
			//_trace ("Node [ " + i + " ] : name = " + node.nodeName + " type = " + node.nodeType + " value = " + node.nodeValue );
			if ( node.nodeType == 4 ) // Type 4 = "#cdata-section" / Type 3 = "#text"
			{
				//_trace ("Node Content found : name = " + node.nodeName + " type = " + node.nodeType + " value = " + node.nodeValue );
				//--- Return the CDATA-SECTION content
				return node.nodeValue ;
			}
		}
		_error( "No CDATA section in the VIEW tag '" + sViewTagName + "'" ) ; 
	}
	//------------------------------------------------------------------------------
	/**
     * Retuns the unique view content of a service response 
     * @return String the content of the view ( ready to set in the 'innerHTML' element attribute )
     */	
	this.getServiceViewContent = function ()
	{
		return this.getViewContent("service-view");
	}	
	
	//------------------------------------------------------------------------------
	this.showAllErrors = function()
	{
		var s = "Response errors :\n\n" ;
		
		if ( _iReadyState != 4 ) 			s = s + "AJAX ready state = " + _iReadyState + "\n"
		if ( _iHttpStatusCode != 200 ) 		s = s + "HTTP status code" + _iHttpStatusCode + "\n"
		if ( _sReturnCode != "0" ) 
		{
			s = s + "Return code = " + _sReturnCode + "\n"
			s = s + "Return message = " + _sReturnMessage + "\n"
		}
		
		txt = this.getExceptionsAsText(); 
		if ( txt != null ) s = s + "\n EXCEPTIONS : \n" + txt ;
		
		txt = this.getErrorsAsText();
		if ( txt != null ) s = s + "\n ERRORS : \n" + txt ;
		
		txt = this.getOutputErrorsAsText();
		if ( txt != null ) s = s + "\n OUTPUT ERRORS : \n" + txt ;
		
		alert ( s ) ;
	}
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenServiceLastCall_class.js ( static class )
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function ScreenServiceLastCall()
{
}
//------------------------------------------------------------------------------
ScreenServiceLastCall.requestURL   = "" ;
ScreenServiceLastCall.responseTEXT = "" ;
//------------------------------------------------------------------------------
ScreenServiceLastCall.init = function (req, resp)
{
	if ( req != null && resp != null )
	{
		ScreenServiceLastCall.requestURL   = req ;
		ScreenServiceLastCall.responseTEXT = resp ;
	}
}
//------------------------------------------------------------------------------
ScreenServiceLastCall.show = function()
{
		var  sHtml = 
		"<html><head><title>Last service call</title></head>" +
		"<body style='margin:4px; background-color: #D4D0C8;'>" +
		"<table style='width:100%;height:100%;' >" +
		"<tr style='height:26px;' ><td style='width:70px;' >URL : </td>" +
		"<td><input style='width:100%;' type='text' value='" + ScreenServiceLastCall.requestURL + "' />" +
		"</td></tr>" +
				
		"<tr style='height:100%;' ><td style='width:70px; vertical-align: top;' >Response : </td>" +
		"<td><textarea id='responseArea' style='width:100%;height:100%;overflow: scroll;' readonly='readonly' >" +
		"</textarea>" +
		"</td></tr>" +
		
		"</table>" +
		"</body></html>" ;
		
		var  sParams = 'status=no,resizable=yes,toolbars=no,menubar=no,titlebar=no,statusbar=no,hotkeys=no, width=800, height=500' ;
		
		sParams=sParams + ',screenX=80,screenY=80' ; // NETSCAPE
		sParams=sParams + ',left=80,top=80' ;        // IE
		var win = window.open( "", "LastAction", sParams ) ; // open ( "URL", "name", "parameters" );
		win.document.write ( sHtml ) ;
		win.document.close();

		var responseArea = win.document.getElementById('responseArea');
		if ( responseArea != null )
		{
			responseArea.value = ScreenServiceLastCall.responseTEXT ;
		}
		else
		{
			alert ("ERROR : Cannot found element for id 'responseArea' ");
		}
		win.focus();
}

//------------------------------------------------------------------------------
// ScreenServiceXHR_class.js : XHR object wrapper used by the ScreenService class
// Telosys framework
// Author : Laurent GUERIN 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION 
//------------------------------------------------------------------------------
function ScreenServiceXHR( sDefaultUrlParam )
{
	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------	
	var _bTrace              = false ;
	var _sDefaultUrl         = null ;
	var _oXMLHTTP            = null ; // THE "XMLHttpRequest" object
	var _sRequestContent     = null ; // The last request content
	var _oScreenResponse     = null ; // The last response object
	var _fctProcessResponse  = null ; // External function to process the response
	var _sLastUrlInvoked     = null ;
	
	if ( sDefaultUrlParam != null )
	{
		_sDefaultUrl = sDefaultUrlParam ;
	}
	
	//--- Instance init 	
    if (window.ActiveXObject) 
	{
    	//--- Internet Explorer
    	_oXMLHTTP = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if (window.XMLHttpRequest)
    {
    	//--- Mozilla & Safari
    	_oXMLHTTP = new XMLHttpRequest();
    }

	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenServiceXHR] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenServiceXHR] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	// AJAX response processing : build the response and call the callBackFunction 
	//------------------------------------------------------------------------------
	function _processAjaxResponse() // Called for each state change (1,2,3 & 4)
	{
		//_trace("_processAjaxResponse() : readyState = " + _oXMLHTTP.readyState );
		//--- If new state is "COMPLETE" ...
		if ( _oXMLHTTP.readyState == 4 )
		{
			_trace("_processAjaxResponse() : Response received : \n" + _oXMLHTTP.responseText );
			
	        var sTelosysRedirect = _oXMLHTTP.getResponseHeader("Telosys-Redirect");  // v 0.9.9
	        // NB : if not found Firefox returns NULL and IE returns ""
			if ( sTelosysRedirect != null && sTelosysRedirect != "" ) // v 0.9.9
			{
				//--- Redirection required (the content received is not an XML response)
				_trace("_processAjaxResponse() : Telosys Redirection : '" + sTelosysRedirect + "' " );
				fwkLoadPage( sTelosysRedirect );
			}
			else
			{
				//--- Build the ScreenResponse object
				_trace("_processAjaxResponse() : Build the ScreenResponse object ..." );
				_oScreenResponse = new ScreenResponse(_oXMLHTTP);
				
				//--- Keep the last request URL and the response received ( since v 1.1.0 )
				if ( _oScreenResponse != null )
				{					
					ScreenServiceLastCall.init( _sLastUrlInvoked, _oScreenResponse.getResponseText() );
				}
				else
				{
					ScreenServiceLastCall.init( _sLastUrlInvoked, "ERROR : Response is null !" );
				}
				
				//--- Run the callback if it exists
				if ( _fctProcessResponse != null )
				{
					_trace("_processAjaxResponse() : Run callback function ..." );
					_fctProcessResponse(_oScreenResponse) ;
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// Send HttpRequest to the server 
	//------------------------------------------------------------------------------
	function _sendRequest ( sHttpMethod, sURL, bAsync, sContent, processResponseFunction) // RET : void 
	{
		if ( sHttpMethod == null )
		{
			_error ( "_sendRequest() : HTTP Method is null ! " ); 
			return ;
		}
		if ( sURL == null ) // Use default URL
		{
			sURL = _sDefaultUrl ;
		}
		if ( sURL == null )  // URL still null ? 
		{
			_error ( "_sendRequest() : URL is null ! " ); 
			return ;
		}
		if ( processResponseFunction == null )
		{
			_error ("_sendRequest() : processResponse function is NULL !");
			return ;
		}
		
		if ( _oXMLHTTP == null )
    	{
			_error ( "_sendRequest() : XMLHttpRequest object is null !" );
			return ;
    	}

		_sRequestContent = sContent ;
		_fctProcessResponse = processResponseFunction ;
		
	    _trace( "_sendRequest("+sHttpMethod+","+sURL+","+bAsync+",..,..) : \nContent :\n" + _sRequestContent ); // Show the request 

		//--- (1) Setup the HTTP Request Method and URL 		
		_sLastUrlInvoked = sURL ;
	    _oXMLHTTP.open (sHttpMethod, sURL, bAsync);  // false = SYNCHRONOUS  (true = ASYNCHRONOUS)	    
		if ( sContent != null )
		{
		    _oXMLHTTP.setRequestHeader("Content-Type", "text/xml");
		}

		//--- (2) Configure the callback method (if ASYNCHRONOUS) 
	    if ( bAsync )
	    {
			_oXMLHTTP.onreadystatechange = _processAjaxResponse ;
		}

		//--- (3) Send the request to the server 
	    _oXMLHTTP.send (sContent); // Send the content (via HTTP)
	    
	    //--- (4) if this request is not ASYNCHRONOUS => call the method to process the response
	    if ( ! bAsync )
	    {
			_processAjaxResponse() ;
		}
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setTrace = function ( p ) 
	{
		_bTrace = p ;
	}

	//------------------------------------------------------------------------------
	// Get the last request content (request body)
	//------------------------------------------------------------------------------
	this.getRequest = function() 
	{
		return _sRequestContent ;
	}
	//------------------------------------------------------------------------------
	// Get the Screen Response object
	//------------------------------------------------------------------------------
	this.getResponse = function() 
	{
		return _oScreenResponse ;
	}

	//------------------------------------------------------------------------------
	// SYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.getSync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("getSync(" + sUrl + ", .., ..)" );
		_sendRequest("GET", sUrl, false, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.getAsync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("getAsync(" + sUrl + ", .., ..)" );
		_sendRequest("GET", sUrl, true, sContent, processResponseFunction);
	}
	
	//------------------------------------------------------------------------------
	// SYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.postSync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("postSync(" + sUrl + ", .., ..)" );
		_sendRequest("POST", sUrl, false, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.postAsync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("postAsync(" + sUrl + ", .., ..)" );
		_sendRequest("POST", sUrl, true, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenService_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenService( sServiceName, sRootUrl, fctProcessResponse ) 
{
	var _bTrace = false ;
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenService] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenService] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	if ( arguments.length != 3 )
	{
		_error ( "Constructor : 3 arguments expected !" );
		return ;
	}
	if ( sServiceName == null )
	{
		_error ( "Constructor : 'ServiceName' argument is null !" );
	}
	if ( sRootUrl == null )
	{
		_error ( "Constructor : 'RootUrl' argument is null !" );
	}
	if ( fctProcessResponse == null )
	{
		_error ( "Constructor : 'callback function' argument is null !" );
	}

	_trace( "ScreenService( " + sServiceName + ", " + sRootUrl + ", function )") ;
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================		
	var _sServiceName = sServiceName ;
	var _fctProcessResponse = fctProcessResponse ;
	//var _sRootURL = sRootUrl ;
	if ( sRootUrl.charAt( sRootUrl.length ) != '/' )
	{
		sRootUrl = sRootUrl + "/" ;
	}
	var _sServiceURL = sRootUrl + sServiceName + ".svc" ;
	var _oRequester = new ScreenServiceXHR( _sServiceURL ); // The XHR wrapper
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _buildQueryString()
	{
		var s = "" ;
		//_trace("_buildQueryString() : " + arguments.length + " argument(s)");
		if ( arguments.length > 0 )
		{
			for ( var i = 0 ; i < arguments.length ; i++ )
			{
				if ( i == 0 )
				{
					s = s + "?" ;
				}
				else
				{
					s = s + "&" ;
				}
				//s = s + "p"+(i+1) + "=" + escape(arguments[i]).replace(/\+/g, "%2B"); // escape added in v 1.0.2 (regexp is to force "+" conversion)
				s = s + "p"+(i+1) + "=" + encodeURIComponent(arguments[i]) ; // encode all the characters in UTF-8 percent encoding ( v 1.0.5 )
			}
		}
		//_trace("buildQueryString() : " + s );
		return s ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setTrace = function ( p ) 
	{
		_bTrace = p ;
		_oRequester.setTrace(p);		
	}

	//------------------------------------------------------------------------------
	this.getURL = function () 
	{
		return _sServiceURL ;
	}		
	//------------------------------------------------------------------------------
	this.getName = function () 
	{
		return _sServiceName ;
	}		
	//------------------------------------------------------------------------------
	this.call = function () 
	{
		_trace("call() : " + arguments.length + " argument(s)");
		try {
			//--- Call _buildQueryString() with the arguments received 
			var sFullURL = _sServiceURL + _buildQueryString.apply(this, arguments); 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
	this.callWithParams = function (params) 
	{
		_trace("callWithParams() : " + arguments.length + " argument(s)");
		if ( arguments.length < 1 ) 
		{
			alert ( "ERROR : callWithParams() : no arguments !" );
			return;
		}
		//--- Build the Query String 
		var s = "" ;
		for ( p in params )
		{
			if ( s == "" )
			{
				s = "?" ;
			}
			else
			{
				s = s + "&" ;
			}
			//s = s + p + "=" + params[p] ; 
			//s = s + p + "=" + escape( params[p] ).replace(/\+/g, "%2B"); // escape added in v 1.0.5 (regexp is to force "+" conversion)
			s = s + p + "=" + encodeURIComponent( params[p] ) ; // encode all the characters in UTF-8 percent encoding ( v 1.0.5 )
		}
		_trace("QueryString = '" + s + "'");

		try {
			//---  
			var sFullURL = _sServiceURL + s ; 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
	this.doGet = function () 
	{
		_trace("doGet() : ");
		try {
			//--- Call  
			var sFullURL = _sServiceURL + "?action=get" ; 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenActionsXHR_class.js : XHR object wrapper used by the ScreenActions class
// Telosys framework
// Author  : Laurent Gurin
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// OBJECT 
//------------------------------------------------------------------------------
function ScreenActionsXHR( sDefaultUrlParam )
{
	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------
	var _bTrace          = false ;
	var _sDefaultUrl     = null ;
	var _oSyncXHR        = null ; // THE "XMLHttpRequest" object for SYNCHRONOUS calls
	var _oAsyncXHR       = null ; // THE "XMLHttpRequest" object for ASYNCHRONOUS calls
	
	var _sRequestContent = null ; // The last request content
	var _oScreenResponse = null ; // The last response object
	var _fCallback       = null ; // The current callback function for Async calls
	
	if ( sDefaultUrlParam != null )
	{
		_sDefaultUrl = sDefaultUrlParam ;
	}
	
	//--- Instance init 	
    if (window.ActiveXObject) 
	{
    	//--- Internet Explorer
    	_oSyncXHR  = new ActiveXObject("Microsoft.XMLHTTP");
    	_oAsyncXHR = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if (window.XMLHttpRequest)
    {
    	//--- Mozilla & Safari
    	_oSyncXHR  = new XMLHttpRequest();
    	_oAsyncXHR = new XMLHttpRequest();
    }

	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// 
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenActionsXHR] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenActionsXHR] :\n\n" + sMsg ) ;
	}
	
	//------------------------------------------------------------------------------
	// Build the response object 
	//------------------------------------------------------------------------------
	function _buildScreenResponse (oXHR) 
	{
		_trace( "_buildScreenResponse() : \n" + oXHR.responseText ); // Show the response 
		
        var sTelosysRedirect = oXHR.getResponseHeader("Telosys-Redirect");  // v 0.9.9
        // NB : if not found Firefox returns NULL and IE returns ""
		if ( sTelosysRedirect != null && sTelosysRedirect != "" )
		{
			//--- Redirection required (the content received is not an XML response)
			_trace("_buildScreenResponse() : Telosys Redirection : '" + sTelosysRedirect + "' " );
			fwkLoadPage( sTelosysRedirect );
			return null ; // never reach this line ( only if there's an error in fwkLoadPage )
		}
		else
		{		
			_oScreenResponse = new ScreenResponse(oXHR);
			return _oScreenResponse ;
		}
	}
	//------------------------------------------------------------------------------
	// CALLBACK METHOD USED WITH 'ASYNCHRONUS' CALL
	//------------------------------------------------------------------------------
	function _asyncCallback() // Called for each state change (1,2,3 & 4)
	{
		_trace ("_asyncCallback() : readyState = " + _oAsyncXHR.readyState );
		//--- If new state is "COMPLETE" ...
		if ( _oAsyncXHR.readyState == 4 )
		{
			//--- Build the ScreenResponse object
			var response = _buildScreenResponse(_oAsyncXHR);
			//--- Run the callback if it exists
			if ( _fCallback != null )
			{
				_trace ("_asyncCallback() : call application callback function..." );
				_fCallback(response) ;
			}
		}
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setTrace = function ( p ) 
	{
		_bTrace = p ;
	}

	//------------------------------------------------------------------------------
	// Get the Xml String of the request
	//------------------------------------------------------------------------------
	this.getRequest = function() 
	{
		return _sRequestContent ;
	}

	//------------------------------------------------------------------------------
	// Get the Screen Response object
	//------------------------------------------------------------------------------
	this.getResponse = function() 
	{
		return _oScreenResponse ;
	}

	//------------------------------------------------------------------------------
	// "POST" SYNCHRONOUS
	//------------------------------------------------------------------------------
	this.postSync = function ( sContent, sUrlParam )
	{
		var sURL = _sDefaultUrl ;
		if ( sUrlParam != null )
		{
			sURL = sUrlParam ;
		}

		if ( _oSyncXHR == null )
    	{
			_error ( "postSync : XMLHttpRequest object is null !" );
			return ;
    	}

		if ( sContent != null )
		{
			//_sRequestContent = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\r\n" + sContent ;
			_sRequestContent = sContent ;
		}
		else
		{
			_sRequestContent = null ;
		}
		
		//--- (1) Setup the HTTP Request Method and URL 
	    _oSyncXHR.open ("POST", sURL, false);  // false = SYNCHRONOUS CALL
	    
	    //_oSyncXHR.setRequestHeader("Content-Type", "text/xml;charset=ISO-8859-1");
	    _oSyncXHR.setRequestHeader("Content-Type", "text/xml");

		//--- (2) Synchronous => No callback method (nothing to do "onreadystatechange" is undefined => do not use)
		// _oSyncXHR.onreadystatechange = null  ; // DON'T DO THAT !
		
		//--- (3) Send the request to the server 
	    _oSyncXHR.send (_sRequestContent); // Send the content ( SYNCHRONOUS => continue ... )

		//--- (4) Response received
		_buildScreenResponse( _oSyncXHR );
	}
	
	//------------------------------------------------------------------------------
	// "POST" ASYNCHRONOUS ( with callback function )
	//------------------------------------------------------------------------------
	this.postAsync = function ( sContent, callbackFunction, sUrlParam )
	{
		var sURL = _sDefaultUrl ;
		if ( sUrlParam != null )
		{
			sURL = sUrlParam ;
		}
		if ( callbackFunction == null )
		{
			_error ("postAsync : callback function is NULL !");
			return ;
		}
		_fCallback = callbackFunction ;
		
		if ( _oAsyncXHR == null )
    	{
			_error ( "postAsync : XMLHttpRequest object is null !" );
			return ;
    	}

		if ( sContent != null )
		{
			//_sRequestContent = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\r\n" + sContent ;
			_sRequestContent = sContent ;
		}
		else
		{
			_sRequestContent = null ;
		}
		
		//--- (1) Setup the HTTP Request Method and URL 
	    _oAsyncXHR.open ("POST", sURL, true);  // true = ASYNCHRONOUS CALL
	    
	    //_oAsyncXHR.setRequestHeader("Content-Type", "text/xml;charset=ISO-8859-1");
	    _oAsyncXHR.setRequestHeader("Content-Type", "text/xml");

		//--- (2) Set the callback method
		_oAsyncXHR.onreadystatechange = _asyncCallback ;

		//--- (3) Send the request to the server 
	    _oAsyncXHR.send (_sRequestContent); // Send the content (via HTTP)

	}

	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                              T H E    E N D
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// ScreenActions_class.js ( client stub to invoke server actions )
// Telosys framework
// Author  : Laurent Gurin
//------------------------------------------------------------------------------
 
//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenActions( paramScreen, paramAsyncFlag )
{
	//==============================================================================
	// PRIVATE CONSTANTS
	//==============================================================================

	var RETRIEVE_NOTHING = 0 ;
	
	var RETRIEVE_ALL     = 1 ;
	
	var NOT_SET   = 0 ;
	var ASYNC     = 1 ;
	var SYNC      = 2 ;
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	
	var _bTrace      = false ;
	
	var _oScreen     = null ; 
	
	var _iDefaultMode = SYNC ;
	var _iMode        = NOT_SET ;
	
	var _oRequester  = new ScreenActionsXHR(); // The AJAX requester
	
	var _fPermanentCallback = null ; // Permanent external callback function, set to be used each time an action is called
	var _fTemporaryCallback = null ; // Temporary external callback function, set to be used only one time
	
	var _sFlagClear  = null ; // Request Flag "clear"
	var _sFlagSet    = null ; // Request Flag "set"
	var _sFlagGet    = null ; // Request Flag "get"
	
	var _oParameters = new Map();  // The parameters to send in the action request
	
	var _oElements   = new Map() ; // The elements to retrieve 
	
	var _oViews      = new Map() ; // The views to retrieve
	
	var _bUpdateScreen    = true ;
	var _bClearScreen     = true ;
	
	var _sLastRequestURL  = null ;
	var _sLastRequestXML  = null ;
	var _sLastResponseXML = null ;
	
	var _fInternalResponseProcessor = null ;
	
	//==============================================================================
	// PSEUDO CONSTRUCTOR
	//==============================================================================
	if ( paramScreen != null )
	{
		_oScreen = paramScreen ; 
	}
	else
	{
		alert ( "ERROR in ScreenActions constructor : no screen parameter !" );
	}
	
	if ( paramAsyncFlag != null )
	{		
		_iDefaultMode = ( paramAsyncFlag == true ? ASYNC : SYNC ) ;
	}
	else
	{
		_iDefaultMode = SYNC ;
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE [ScreenActions] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR [ScreenActions] :\n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	// Returns a request with the given action and the parameters to send 
	//------------------------------------------------------------------------------
	this.getRequest = function ( sAction )
	{
		//--- Create a new request 
		var request = new ScreenRequest();
		//--- Init the request 
		request.setScreenName( _oScreen.getScreenName() );
		request.setScreenId  ( _oScreen.getScreenId()   );
		//--- Set the action name ( "get", "set", "load", .. ) 
		if ( sAction )
		{
			request.setAction(sAction);
		}
		
		//--- Set the action FLAGS in the request
		if ( _sFlagClear != null ) { request.setFlagClear(_sFlagClear) } ;
		if ( _sFlagSet   != null ) { request.setFlagSet  (_sFlagSet)   } ;
		if ( _sFlagGet   != null ) { request.setFlagGet  (_sFlagGet)   } ;
		
		//--- Set the action PARAMETERS in the request
		if ( _oParameters.size() > 0 )
		{
			var name = null ;
			var names = _oParameters.keysArray();
			var n = names.length ;			
			// for ( i in names ) // for .. in cannot be used with "prototype.js" 
			for ( var i = 0 ; i < n ; i++ )
			{
				name = names[i] ;
				request.setParameter(name, _oParameters.get(name) );
			}
			//--- Clear the action parameters 
			_oParameters.clear();
		}		
		return request ;
	}
	
	//------------------------------------------------------------------------------
	function _beforeSend()
	{
		// Clear Flags 
		_sFlagClear  = null ; 
		_sFlagSet    = null ; 
		_sFlagGet    = null ; 
	
		// Clear Parameters, Elements and Views 
		_oParameters.clear();
		_oElements.clear();
		_oViews.clear();		
	}
	//------------------------------------------------------------------------------
	// Response processing used by SYNCHRONOUS and ASYNCHRONOUS calls
	//------------------------------------------------------------------------------
	function _processResponse(response)
	{
		_trace("_processResponse(response)...");
	
		var bResponseProcessed = false ;
		
		//--- 1) Keep last response for debug window
		_sLastResponseXML = response.getResponseText(); 

		//--- 2) Process the response for screen impacts ( using the internal processing if any )
		if ( _fInternalResponseProcessor != null )
		{
			_fInternalResponseProcessor(response); // call _updateScreen or _clearScreen or _updateScreenAfterDelete
			_fInternalResponseProcessor = null ; // Just "for once" => unset after use
		}
				
		//--- 3) Call the screen "developer callback function" if any ( supposed to process response errors )
		if ( _fTemporaryCallback != null )
		{
			// There's a specific external temporary callback function => use it 
			_fTemporaryCallback(response) ; 
			_fTemporaryCallback = null ; // Temporary => Just "for once" => unset after use
		}
		else
		{
			if ( _fPermanentCallback != null ) // see setPermanentCallback(..)
			{
				// There's a specific external permanent callback function (for all actions) => use it 
				_fPermanentCallback(response) ;
			}
			else
			{
				// No application callback => Default response error processing
				if ( response.reportsErrors() )
				{
					if ( typeof window.onTelosysActionError == "function" )
					{
						// call the application error handler (if any)
						window.onTelosysActionError(response);
					}
					else
					{
						// by default show all the error messages
						response.showAllErrors();
					}
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// The callback function called by the XHR object when the response has been 
	// received after an ASYNCHRONOUS call
	//------------------------------------------------------------------------------
	function _ajaxAsynchronousCallback(response)
	{
		//--- 1) Hide the "WAIT" SYMBOL 
		// TODO :  HIDE "WAIT"
		
		//--- 2) Process the response
		_processResponse(response);
	}
	//------------------------------------------------------------------------------
	function _sendRequest(req, applicationCallerFunction, responseProcessor )
	{
		_beforeSend();
		
		if ( _oRequester == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The AJAX requester is null ! ");
		}
		if ( _oScreen == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The SCREEN object is null ! ");
		}
		
		_sLastRequestURL = _oScreen.getRequestURL() ;
		_sLastRequestXML = req.getXmlRequest();
		
		// Set the hidden internal response processor to use ( can be null if none )
		_fInternalResponseProcessor = responseProcessor ; // _updateScreen, _clearScreen, _updateScreenAfterDelete or null
		
/***
		_bUpdateScreen = false ;
		if ( bUpdateScreen == null || bUpdateScreen == true )
		{
			_bUpdateScreen = true ;
		}
***/	
		
		//--- Call mode : SYNC or ASYNC ?
		var iCallMode = _iDefaultMode ;
		if ( _iMode != NOT_SET ) 
		{
			iCallMode = _iMode ;
			_iMode = NOT_SET ; // Reset for next call
		}
		
		//--- Use a callback function for post processing ( for SYNC and ASYNC modes )
		if ( _fTemporaryCallback == null ) // not set => use "applicationCallerFunction.callback" if any
		{
			_fTemporaryCallback = ( applicationCallerFunction != null ? applicationCallerFunction.callback : null ) ;
		}
		
		if ( iCallMode == ASYNC )
		{
			//--- Send the request with an ASYNCHRONOUS call
			_oRequester.postAsync ( _sLastRequestXML, _ajaxAsynchronousCallback, _sLastRequestURL );
				
			//--- The request is sent => Display the "WAIT SYMBOL"
			// TODO :  DISPLAY "WAIT"
			
			return null ; // ASYNCHRONOUS => No response to return ( just wait the callback processing )
		}
		else
		{
			//--- No callback function => SYNCHRONOUS call
			_oRequester.postSync ( _sLastRequestXML, _sLastRequestURL ); // SYNC => wait the response	
			
			//--- The responce is here
			var response = _oRequester.getResponse();
			
			_processResponse(response);
			
			return response ; // SYNCHRONOUS => Return the response ( for backward compatibility )
		}
	}
	
	//------------------------------------------------------------------------------
	// Set request elements
	//------------------------------------------------------------------------------
	function _setElements(request, elements)
	{
//	alert("_setElements");
		if ( elements != null ) 
		{
			if ( elements.length == 0 )
			{
				//--- No elements => get all the elements of the screen
				request.setElements(_oScreen.getElementsString());				
			}
			else
			{
				//--- Build the elements list
				var sElementsList = "" ;
				var iNbElements = 0 ;
				for ( i=0 ; i < elements.length ; i++ )
				{
					if ( typeof elements[i] == "string" )
					{
						if ( iNbElements > 0 ) 
						{
							sElementsList += ",";
						}
						sElementsList += elements[i];
						iNbElements++;
					}
				}				
				//--- Set the given elements list in the request
				request.setElements(sElementsList);
			}	
		}
	}	
	
	//------------------------------------------------------------------------------
	// Set a view in the request (with renderer if any)
	//------------------------------------------------------------------------------
/***
	function _setView(request, psViewName, psRenderer )
	{
		var oScreenView = _searchView( psViewName ) ;
		if ( oScreenView != null )
		{
			if ( psRenderer != null )
			{
				request.setView( oScreenView.getName(), psRenderer );
			}
			else
			{
				request.setView( oScreenView.getName(), oScreenView.getRenderer() );
			}
		}
	}
***/
	function _setView(request, psViewName, psRenderer ) // v 1.1.0
	{
		if ( request == null ) _error ( "_setView : request parameter is null" ) ;
		if ( psViewName == null ) _error ( "_setView : view name parameter is null" ) ;
		
		if ( psRenderer != null )
		{
			// A specific renderer is given => just use it
			request.setView( psViewName, psRenderer ); 
		}
		else
		{
			// No renderer => get the renderer associated with the view ( supposed to be a registered view )
			var oScreenView = _searchView( psViewName ) ;
			if ( oScreenView != null )
			{
				request.setView( oScreenView.getName(), oScreenView.getRenderer() );
			}
		}
	}
	//------------------------------------------------------------------------------
	// Set the given views in the request
	//------------------------------------------------------------------------------
	function _setViews(request, views)
	{
		if ( views != null ) 
		{
			if ( views.length == 0 )
			{
				//--- No views => set all the views of the screen in the request
				_setAllViews(request);
			}
			else
			{
				//--- Set the given views in the request
				for ( i=0 ; i < views.length ; i++ )
				{
					if ( typeof views[i] != "string" )
					{
						_error( "_setViews() : argument[" + i + "] is not a String ! type = " + typeof views[i] );					
					}
					else
					{
						var oScreenView = _searchView( views[i] ) ;
						if ( oScreenView != null )
						{
							request.setView( oScreenView.getName(), oScreenView.getRenderer() );						
						}
					}
				}				
			}	
		}
	}
	//------------------------------------------------------------------------------
	// Set all the views of the screen in the request
	//------------------------------------------------------------------------------
	function _setAllViews(request)
	{
		//--- Set views names if any
		var views = _oScreen.getViews();
		if ( views != null )
		{
			var oScreenView = null ;			
			//--- For each view registered in this screen 
			for ( var i = 0 ; i < views.length ; i++ )
			{
				oScreenView = views[i] ;
				if ( oScreenView != null )
				{
					request.setView( oScreenView.getName(), oScreenView.getRenderer() );			
				}
				else
				{
					_error( "_setAllViews() : ScreenViews ["+i+"] is null ! " );					
				}
			}
		}
	}	
	//------------------------------------------------------------------------------
	// Set the elements to retrieve in the request according with the elements list 
	// defined by "setElementToRetrieve()"
	//------------------------------------------------------------------------------
	function _setWhatToRetrieve(request, defaultFlag )
	{
		if ( _oElements == null )
		{
			_error( "_setWhatToRetrieve() : _oElements is null" );	
			return;				
		}
		if ( _oViews == null )
		{
			_error( "_setWhatToRetrieve() : _oViews is null" );					
			return;				
		}
		
		if ( _oElements.size() == 0  &&  _oViews.size() == 0 )
		{
			//--- Nothing specified => Retrieve ALL or NOTHING ( cf Flag ) 
			if ( defaultFlag == RETRIEVE_ALL )
			{
				//--- Retrieve ALL ( everything : elements + views )
				request.setElements( _oScreen.getElementsString() );
				_setAllViews(request);
			}
			else
			{
				//--- Retrieve NOTHING
				request.setElements( "" ); // No elements
				// No views
			}
		}
		else
		{
			_setElementsToRetrieve(request);
			_setViewsToRetrieve(request);
		}
	}
	//------------------------------------------------------------------------------
	// Set the elements to retrieve in the request according with the elements list 
	// defined by "setElementToRetrieve()"
	//------------------------------------------------------------------------------
	function _setElementsToRetrieve(request)
	{
		var sElementsList = null ;
		if ( _oElements.size() > 0 )
		{
			//--- Elements specified
			sElementsList = _oElements.keysString();
		}
		else
		{
			////--- No elements => get all the elements of the screen
			//sElementsList = _oScreen.getElementsString() ;
			//--- No elements => Do not get elements
			sElementsList = "" ;
		}
		request.setElements(sElementsList);
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	// Set the views to retrieve in the request according with the views list 
	// defined by "setViewToRetrieve()"
	//------------------------------------------------------------------------------
	function _setViewsToRetrieve(request)
	{
		//--- Set the views to retrieve 
		if ( _oViews.size() > 0 )
		{
			var names = _oViews.keysArray();
			var n = names.length ;
			var name = null ;
			var renderer = null ;
			for ( var i = 0 ; i < n ; i++ )
			{
				name = names[i] ;
				renderer = _oViews.get(name); // Specific renderer or null for standard renderer
				_setView(request, name, renderer ) ;				
			}
		}
		/** DO NOT GET VIEWS
		else
		{
			_setAllViews(request);
		}
		**/
	}
	//------------------------------------------------------------------------------
	// Search a view (by name) in the views list of the screen
	//------------------------------------------------------------------------------
	function _searchView(psViewName)
	{
		var views = _oScreen.getViews();
		if ( views != null )
		{
			var oScreenView = null ;			
			//--- For each view registered in this screen 
			for ( var i = 0 ; i < views.length ; i++ )
			{
				oScreenView = views[i] ;
				if ( oScreenView != null )
				{
					if ( oScreenView.getName() == psViewName )
					{
						return oScreenView ;
					}
				}
				else
				{
					_error( "_searchView() : ScreenViews ["+i+"] is null ! " );					
				}
			}
			_error( "_searchView() : unknown view '" + psViewName + "' ! " );					
		}
		else
		{
			_error( "_searchView() : no views in this screen ! " );					
		}	
		return null;
	}
	//------------------------------------------------------------------------------
	// Internal response processors
	//------------------------------------------------------------------------------
	function _updateScreen ( response ) 
	{
_trace ( "_updateScreen : flag = " + _bUpdateScreen );	
		if ( response.isOK() && _bUpdateScreen )
		{
			//--- Populate the screen fields and views with XML data recieved
			_oScreen.XmlToScreen(response);
		}
	}
	//------------------------------------------------------------------------------
	function _clearScreen ( response ) 
	{
_trace ( "_clearScreen : flag = " + _bUpdateScreen );	
		if ( response.isOK() && _bUpdateScreen )
		{
			//--- Clear the screen
			_oScreen.clear();
		}
	}
	//------------------------------------------------------------------------------
	function _updateScreenAfterDelete ( response ) 
	{
_trace ( "_updateScreenAfterDelete : _bClearScreen = " + _bClearScreen + "  _bUpdateScreen = " + _bUpdateScreen );	
		if ( response.isOK() )
		{
			if ( _bClearScreen )
			{
				//--- Clear the screen
				_oScreen.clear();
			}
			if ( _bUpdateScreen )
			{
				//--- Populate FIELDS and VIEWS 
				_oScreen.XmlToScreen(response);
			}
		}
	}
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	/**
     * Retuns the Screen instance 
     * @return Object the Screen instance 
     */	
	this.getScreen = function () 
	{
		return _oScreen ;
	}
	//------------------------------------------------------------------------------
	//   FLAGS
	//------------------------------------------------------------------------------
	this.setTrace = function ( p ) 
	{
		_bTrace = p ;
		_oRequester.setTrace(p);
	}
	//------------------------------------------------------------------------------
	this.doNotClearContextData = function () 
	{
		_sFlagClear = "false" ;
	}
	//------------------------------------------------------------------------------
	this.doNotSetContextData = function () 
	{
		_sFlagSet = "false" ;
	}
	//------------------------------------------------------------------------------
	this.doNotGetContextData = function () 
	{
		_sFlagGet = "false" ;
	}
	
	//------------------------------------------------------------------------------
	this.setModeAsync = function () 
	{
		_iMode = ASYNC ;
	}
	this.setModeSync = function () 
	{
		_iMode = SYNC ;
	}
	//------------------------------------------------------------------------------
	this.setDefaultModeAsync = function () 
	{
		_iDefaultMode = ASYNC ;
	}
	this.setDefaultModeSync = function () 
	{
		_iDefaultMode = SYNC ;
	}
	//------------------------------------------------------------------------------
	this.setPermanentCallback = function ( p ) // v 1.0.5 (replace setDefaultCallback)
	{
		_fPermanentCallback = p ;
	}
	//------------------------------------------------------------------------------
	this.setTemporaryCallback = function ( p ) // v 1.0.5 (replace setCallback)
	{
		_fTemporaryCallback = p ;
	}
	
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	//   PARAMETERS
	//------------------------------------------------------------------------------
	this.setParameter = function (sName, sValue) 
	{
		if ( sName == null )
		{
			_error ( "setParameter(name,value) : name is null" ) ;
		}
		if ( sValue == null )
		{
			_error ( "setParameter(name,value) : value is null" ) ;
		}
		_oParameters.put(sName, sValue) ;
	}
	//------------------------------------------------------------------------------
	this.clearParameters = function () 
	{
		_oParameters.clear() ;		
	}
	//------------------------------------------------------------------------------
	this.showParameters = function () 
	{
		_oParameters.show() ;		
	}
	//------------------------------------------------------------------------------
	this.numberOfParameters = function () // v 1.1.0
	{
		return _oParameters.size() ;		
	}
	//------------------------------------------------------------------------------
	//   ELEMENTS TO RETRIEVE
	//------------------------------------------------------------------------------
	this.setElementToRetrieve = function (sElementName) 
	{
		if ( sElementName == null )
		{
			_error ( "setElementToRetrieve(element_name) : element name is null" ) ;
		}
		_oElements.put(sElementName, null) ; 
	}
	//------------------------------------------------------------------------------
	this.setElementsToRetrieve = function () 
	{
		if ( arguments.length > 0 )
		{
			for ( var i=0 ; i<arguments.length ; i++ )
			{
				_oElements.put(arguments[i], null ) ;
			}
		}
		else
		{
			_error ( "setElementsToRetrieve(..) : argument(s) expected !" ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.clearElementsToRetrieve = function () 
	{
		_oElements.clear() ;		
	}
	//------------------------------------------------------------------------------
	this.showElementsToRetrieve = function () 
	{
		_oElements.show() ;		
	}
	//------------------------------------------------------------------------------
	//   VIEWS TO RETRIEVE
	//------------------------------------------------------------------------------
	this.setViewToRetrieve = function (sViewName, sRenderer) 
	{
		if ( sViewName == null )
		{
			_error ( "setViewToRetrieve(name,renderer) : view name is null" ) ;
		}
		_oViews.put(sViewName, sRenderer) ; // sRenderer can be null ( = default renderer )
		/*
		if ( sRenderer != null )
		{
			_oViews.put(sViewName, sRenderer) ;
		}
		else
		{
			_oViews.put(sViewName, "") ;
			//_error ( "setViewToRetrieve(name,renderer) : renderer is null" ) ;
		}
		*/
	}
	//------------------------------------------------------------------------------
	this.setViewsToRetrieve = function () 
	{
		if ( arguments.length > 0 )
		{
			for ( var i=0 ; i<arguments.length ; i++ )
			{
				//_oElements.put(arguments[i], null ) ; // default renderer
				_oViews.put(arguments[i], null ) ; // default renderer // v 1.1.0.a
			}
		}
		else
		{
			_error ( "setViewsToRetrieve(..) : arguments expected !" ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.clearViewsToRetrieve = function () 
	{
		_oViews.clear() ;		
	}
	//------------------------------------------------------------------------------
	this.showViewsToRetrieve = function () 
	{
		_oViews.show() ;		
	}
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	//   A C T I O N S
	//------------------------------------------------------------------------------
	this.doOpen = function () 
	{
		_trace("doOpen()");
		var response = null ;
		try {
			//--- Build the request 
			var request = this.getRequest("open") ;
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller );
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doClose = function () 
	{
		_trace("doClose()");
		var response = null ;
		try {
			//--- Build the request 
			var request = this.getRequest("close") ;
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller );
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doGetViews = function () 
	{
		_trace("doGetViews()");
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("get") ;
			//--- Don't want elements => set "elements" to void list
			request.setElements("");
			//--- Set views and renderer
			_setViews(request, arguments);
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	
	//------------------------------------------------------------------------------
	this.doGetView = function ( psViewName, psRenderer ) 
	{
		_trace("doGetView(" + psViewName + "," + psRenderer + ")" );
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("get") ;
			//--- Don't want elements => set "elements" to void list
			request.setElements("");
			//--- Set the given view
			_setView(request, psViewName, psRenderer ) ;

			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	
	//------------------------------------------------------------------------------
	/**
     * Invokes the standard "GET" action with an elements list
     * @param  Variable list of arguments ( 0 .. N ) 
     *         if the last argument is a boolean it is considered as the update screen flag
     * @return Object  the server response object  
     */	
	this.doGetElements = function () 
	{
		_trace("doGetElements()");
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("get") ;
			_setElements(request, arguments);
			//var bUpdateScreen =_getUpdateScreenFlag(arguments, true);
			
			//--- Send the request 
//			response = _sendRequest(request, arguments.callee.caller, _afterGet, bUpdateScreen );
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
			/***
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
			***/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}

	//------------------------------------------------------------------------------
	/**
     * Invokes the standard "GET" action to get data from the server 
     * Get all the Screen Context elements and all the views
     * @param  boolean true = update the screen, false = no screen update
     * @return Object  the server response object  
     */	
	this.doGet = function ( bUpdateScreen ) 
	{
		_trace("doGet(" + bUpdateScreen + ")");
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("get") ;

			//--- Set what to retrieve : elements and/or views ( RETRIEVE_ALL by default )
			_setWhatToRetrieve(request, RETRIEVE_ALL);

			//--- Send the request 
//			response = _sendRequest(request, arguments.callee.caller, _afterGet, bUpdateScreen );
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
		/**
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
		**/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	/**
     * Invokes the standard "SET" action to update data on the server 
     * Set all the Screen Context elements 
     * @return Object  the server response object  
     */	
	this.doSet = function ( bUpdateScreen ) 
	{
		_trace("doSet(" + bUpdateScreen + ")");
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : false ) ; // default FALSE
		
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("set") ;
			
			var sXmlData = _oScreen.ScreenToXml();
			request.setData(sXmlData);
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
		}
		catch (ex) {
			_error ( ex.message );
		}			
		return response ;
	}
	//------------------------------------------------------------------------------
	/**
     * Invokes the standard "CLEAR" action to clear the Screen Context on the server 
     * @param  boolean true = clear the screen fields, false = do not clear the screen fields
     * @return Object  the server response object  
     */	
	this.doClear = function ( bUpdateScreen ) 
	{
		_trace("doClear(" + bUpdateScreen +")" );
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		var response = null ;
		try {
			//--- Build the request 
			var request = this.getRequest("clear") ;		
			//--- Send the request 
//			response = _sendRequest(request, arguments.callee.caller, _afterClear, bUpdateScreen );
			response = _sendRequest(request, arguments.callee.caller, _clearScreen );
		/**
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( bUpdateScreen == null || bUpdateScreen == true )
				{
					//--- Clear the screen
					_oScreen.clear();
				}
			}
		**/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	
	//------------------------------------------------------------------------------
	//  LOAD ACTIONS
	//------------------------------------------------------------------------------
	this.doLoadViews = function () 
	{
		_trace("doLoadViews()");
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("load") ;
			//--- Don't want elements => set "elements" to void list
			request.setElements("");
			//--- Set views and renderer
			_setViews(request, arguments);
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
			/**
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataNotFound() != true ) // Data Found
				{
					_oScreen.XmlToScreen(response);
				}
			}
			**/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doLoadView = function ( psViewName, psRenderer ) 
	{
		_trace("doLoadView(" + psViewName + "," + psRenderer + ")");
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {
			//--- Build the request 
			var request = this.getRequest("load") ;
			//--- Don't want elements => set "elements" to void list
			request.setElements("");
			//--- Set the given view
			_setView(request, psViewName, psRenderer ) ;
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
			/***
			response = _sendRequest(request);
			//--- Use the response ( View => allways update screen )
			if ( response.isOK() )
			{
				if ( response.dataNotFound() != true ) // Data Found
				{
					_oScreen.XmlToScreen(response);
				}
			}
			**/
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doLoadElements = function () 
	{
		_trace("doLoadElements(...)");
		_bUpdateScreen = true ; // always TRUE
		var response = null ;
		try {
			//--- Build the request 
			var request = this.getRequest("load") ;
			//--- Elements to get after the load
			_setElements(request, arguments);
			//--- Flag to update (or not) the screen fields
			//var bUpdateScreen =_getUpdateScreenFlag(arguments, true);
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
			/**
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataNotFound() != true ) // Data Found
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
			**/
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doLoad = function ( bUpdateScreen ) 
	{
		_trace("doLoad("+bUpdateScreen+")");
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("load") ;
			
			//--- Set what to retrieve : elements and/or views ( RETRIEVE_ALL by default )
			_setWhatToRetrieve(request, RETRIEVE_ALL);
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller, _updateScreen );
			/**
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataNotFound() != true ) // Data Found
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
			**/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	
	//------------------------------------------------------------------------------
/***
	function _afterLoad ( response ) 
	{
alert ( "_afterLoad" );	
		if ( response.isOK() )
		{
			if ( response.dataNotFound() != true ) // Data Found
			{
				if ( _bUpdateScreen )
				{
					//--- Populate the screen fields with XML data recieved
					_oScreen.XmlToScreen(response);
				}
			}
		}
	}
***/
	//------------------------------------------------------------------------------
	this.populateFields = function (response) 
	{
		if ( response.isOK() )
		{
			if ( response.dataNotFound() != true ) // Data Found
			{
				//--- Populate the screen fields with XML data recieved
				_oScreen.XmlToScreen(response);
			}
		}
		else
		{
			//alert("ERROR : cannot populate fields ( response status is not OK ) !");
			_error("populateFields(response) : cannot populate fields ( response status is not OK ) !");
		}
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// param Action : "save", "insert", "update"
	//------------------------------------------------------------------------------
	this.sendScreenData = function ( sAction, applicationCallerFunction, bUpdateScreen )
	{
		_trace("sendScreenData : Action = '" + sAction + "'" );
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest(sAction) ;
			
			//--- Set what to retrieve : elements and/or views ( RETRIEVE_NOTHING by default )
			_setWhatToRetrieve(request, RETRIEVE_NOTHING);
			
			//--- Build the XML tree from screen fields 
			var sXmlData = _oScreen.ScreenToXml();
			request.setData(sXmlData);
			
			//--- Send the request ( retrieve the response )
			//response = _sendRequest(request, applicationCallerFunction, _afterSavInsUpd, bUpdateScreen );
			response = _sendRequest(request, applicationCallerFunction, _updateScreen );
			
			/***
			response = _sendRequest(request);
			
			if ( bUpdateScreen == true )
			{
				if ( response.isOK() )
				{
					//--- Populate FIELDS and VIEWS 
					_oScreen.XmlToScreen(response);
				}
			}			
			***/
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
/***
	function _afterSavInsUpd ( response ) 
	{
alert ( "_afterSavInsUpd" );	
		if ( response.isOK() )
		{
			if ( _bUpdateScreen )
			{
				//--- Populate FIELDS and VIEWS 
				_oScreen.XmlToScreen(response);
			}
		}
	}
***/
	//------------------------------------------------------------------------------
	this.doSave = function ( bUpdateScreen ) 
	{
		_trace("doSave("+bUpdateScreen+")");
		return this.sendScreenData("save", arguments.callee.caller, bUpdateScreen );
	}
	//------------------------------------------------------------------------------
	this.doInsert = function ( bUpdateScreen ) 
	{
		_trace("doInsert("+bUpdateScreen+")");
		return this.sendScreenData("insert", arguments.callee.caller, bUpdateScreen );
	}
	//------------------------------------------------------------------------------
	this.doUpdate = function ( bUpdateScreen ) 
	{
		_trace("doUpdate("+bUpdateScreen+")");
		return this.sendScreenData("update", arguments.callee.caller, bUpdateScreen );
	}
	//------------------------------------------------------------------------------
	this.doDelete = function ( bClearScreen, bUpdateScreen ) 
	{
		_trace("doDelete( " + bClearScreen + ", " + bUpdateScreen + " )" );
		
		_bClearScreen  = ( bClearScreen  != null ? bClearScreen  : true ) ; // default TRUE
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("delete") ;
			
			//--- Set what to retrieve : elements and/or views ( RETRIEVE_NOTHING by default )
			_setWhatToRetrieve(request, RETRIEVE_NOTHING);
			
			//--- Send the request ( retrieve the response )
			//response = _sendRequest(request, arguments.callee.caller);
			response = _sendRequest(request, arguments.callee.caller, _updateScreenAfterDelete);


/***
			if ( response.isOK() )
			{
				if ( bClearScreen == null || bClearScreen == true )
				{
					//--- Clear the screen
					_oScreen.clear();
				}
				if ( bUpdateScreen != null && bUpdateScreen == true )
				{
					//--- Populate FIELDS and VIEWS 
					_oScreen.XmlToScreen(response);
				}
			}
***/
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	
	//------------------------------------------------------------------------------
	// ACTIONS FOR LIST MANAGEMENT
	//------------------------------------------------------------------------------
	this.doListSelect = function ( sListName, sItemName, iOldIndex, iIndex, bUpdateScreen ) 
	{
		_trace("Action : SelectListElement");
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_select") ;		

			request.setParameter( "list", sListName );
			request.setParameter( "item", sItemName );
			request.setParameter( "old-index", iOldIndex );
			request.setParameter( "new-index", iIndex );
			
			//request.setData( _oScreen.ScreenToXml() );
			request.setData( _oScreen.ScreenToXml(sItemName) ); // NEW
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doListInsert = function ( sListName, sItemName, iOldIndex, iIndex, bUpdateScreen ) 
	{
		_trace("Action : ListInsert");
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_insert") ;		

			request.setParameter( "list", sListName );
			request.setParameter( "item", sItemName );
			request.setParameter( "new-index", iIndex );
			request.setParameter( "old-index", iOldIndex );
			
			//request.setData( _oScreen.ScreenToXml() );
			request.setData( _oScreen.ScreenToXml(sItemName) ); // NEW
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doListAdd = function ( sListName, sItemName, iOldIndex, bUpdateScreen ) 
	{
		_trace("Action : ListAdd");
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_add") ;		

			request.setParameter( "list", sListName );
			request.setParameter( "item", sItemName );
			//request.setParameter( "new-index", iIndex );
			request.setParameter( "old-index", iOldIndex );
			
			//request.setData( _oScreen.ScreenToXml() );
			request.setData( _oScreen.ScreenToXml(sItemName) ); // NEW
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doListRemove = function ( sListName, sItemName, iOldIndex, iIndex, bUpdateScreen ) 
	{
		_trace("Action : ListRemove");
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_remove") ;		

			request.setParameter( "list", sListName );
			request.setParameter( "item", sItemName );
			request.setParameter( "new-index", iIndex );
			request.setParameter( "old-index", iOldIndex );
			
			//request.setData( _oScreen.ScreenToXml() );
			request.setData( _oScreen.ScreenToXml(sItemName) ); // NEW
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doListClear = function ( sListName, sItemName, iOldIndex ) 
	{
		_trace("Action : ListClear");
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_clear") ;		

			request.setParameter( "list", sListName );
			//request.setParameter( "item", sItemName );
			//request.setParameter( "new-index", iIndex );
			request.setParameter( "old-index", iOldIndex );
			
			//request.setData( _oScreen.ScreenToXml(sItemName) ); 
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doListSort = function ( sListName, sItemName, iOldIndex, sFieldName, sOrder ) 
	{
		_trace("Action : ListSort");
		if ( arguments.length < 4 )
		{
			_error ( "doListSort() : 4 or 5 arguments expected ( " + arguments.length + " arguments )" ) ;
			return ;
		}
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest("list_sort") ;		

			//--- Set what to retrieve : elements and/or views ( RETRIEVE_NOTHING by default )
			_setWhatToRetrieve(request, RETRIEVE_NOTHING);

			request.setParameter( "list",  sListName );
			//--- Sort parameters 
			request.setParameter( "column", sFieldName );
			if ( sOrder != null ) // order parameter is optional
			{
				request.setParameter( "order", sOrder );
			}
			
			//--- Update current item before sort ?
			if ( sItemName != null && iOldIndex != null )
			{
				request.setParameter( "item", sItemName );
				request.setParameter( "old-index", iOldIndex );
				request.setData( _oScreen.ScreenToXml(sItemName) ); // NEW
			}
			else
			{
				request.setParameter( "item", "" ); // No item to update
				request.setParameter( "old-index", "-1" ); // No item index
			}
			
			//--- Send the request 
			response = _sendRequest(request, arguments.callee.caller);
			if ( response.isOK() )
			{
				//--- Populate the screen fields with list view recieved
				_oScreen.XmlToScreen(response);
			}			
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	this.doExec = function (sProcName, bUpdateScreen) 
	{
		_trace("doExec( "+sProcName+", "+bUpdateScreen+" )");
		_bUpdateScreen = ( bUpdateScreen != null ? bUpdateScreen : true ) ; // default TRUE
		var response = null ;
		if ( sProcName == null )
		{
			_error ( "doExec() : No procedure name (argument is null) " );
		}
		try {	
			//--- Build the request 
			var request = this.getRequest("exec") ;
			//--- Set the procedure name 
			request.setProcedure(sProcName);
			
			//--- Set what to retrieve : elements and/or views 
			//_setWhatToRetrieve(request, RETRIEVE_ALL);
			_setWhatToRetrieve(request, RETRIEVE_NOTHING); // RETRIEVE_NOTHING by default
			
			
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request, arguments.callee.caller, _updateScreen);

			/*** OLD
			if ( response.isOK() )
			{
				//--- Call external method ????
				this.afterExec(request,response);
			}
			***/
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	//------------------------------------------------------------------------------
	this.setParametersFromFields = function ( argElementName ) // v 1.1.0
	{
		_oScreen.setParametersFromFields( _oParameters, argElementName);
	}
			
	//----------------------------------------------------------------------------------------------------
	this.openWindowLastAction = function(sURL, sRequest, sResponse )
	{
		var  sHtml = 
		"<html><head><title>Last screen action</title></head>" +
		"<body style='margin:4px; background-color: #D4D0C8;'>" +
		"<table style='width:100%;height:100%;' >" +
		"<tr style='height:26px;' ><td style='width:70px;' >URL : </td>" +
		"<td><input style='width:100%;' type='text' value='" + sURL + "' />" +
		"</td></tr>" +
		
		"<tr style='height:40%;' ><td style='width:70px; vertical-align: top;' >Request : </td>" +
		"<td><textarea id='requestArea' style='width:100%;height:100%;overflow: scroll;' readonly='readonly' >" +
		"</textarea>" +
		"</td></tr>" +
		
		"<tr style='height:60%;' ><td style='width:70px; vertical-align: top;' >Response : </td>" +
		"<td><textarea id='responseArea' style='width:100%;height:100%;overflow: scroll;' readonly='readonly' >" +
		"</textarea>" +
		"</td></tr>" +
		
		"</table>" +
		"</body></html>" ;
		
		var  sParams = 'status=no,resizable=yes,toolbars=no,menubar=no,titlebar=no,statusbar=no,hotkeys=no' ;
		
		sParams=sParams + ',screenX=80,screenY=80' ; // NETSCAPE
		sParams=sParams + ',left=80,top=80' ;        // IE
		var win = window.open( "", "LastAction", sParams ) ; // open ( "URL", "name", "parameters" );
		win.document.write ( sHtml ) ;
		win.document.close();
		var requestArea = win.document.getElementById('requestArea');
		if ( requestArea != null )
		{
			requestArea.value = sRequest ;
		}
		else
		{
			alert ("ERROR : Cannot found element for id 'requestArea' ");
		}
		var responseArea = win.document.getElementById('responseArea');
		if ( responseArea != null )
		{
			responseArea.value = sResponse ;
		}
		else
		{
			alert ("ERROR : Cannot found element for id 'responseArea' ");
		}
		win.focus();
	}
	//------------------------------------------------------------------------------
	this.showLastAction = function () 
	{
		this.openWindowLastAction(_sLastRequestURL, _sLastRequestXML, _sLastResponseXML);
	}
		
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// TelosysEnv_class.js : Telosys environment object
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
/**
 * This object stores the absolute URLs to access the server side with AJAX calls.
 * It provides different kind of objects ( Screen, Service, Actions, ... )
 *
 * @param String : Application root URL ( required )
 * @param String : Screen Map URL ( required )
 * @param String : Screen Context AJAX calls URL ( required )
 * @param String : Current Screen Name 
 * @param int    : Current Screen ID
 *
 */
//------------------------------------------------------------------------------
 
//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
//function TelosysEnv( sRootUrl, sScreenMapUrl, sAjaxUrl, sScreenName, iScreenId )
function TelosysEnv()
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	//--- URLs 
	var _sRootUrl      = null ;
	var _sScreenMapUrl = null ;
	var _sAjaxUrl      = null ;

	//--- Current Screen Map   
	var _sScreenName   = null ;
	var _iScreenId     = 0 ;
	var _screen        = null ;
	var _actions       = null ;	
	
	//--- Keyboard & browser  
	var _keyboard      = Keyboard.getKeyboard(); 
	var _browser       = Browser.getBrowser() ; 
	
	//alert ( "in TelosysEnv : this = " + this + "\n constructor : \n" + this.constructor ) ;
	
	//==============================================================================
	// CONSTRUCTOR
	//==============================================================================
	_constructor.apply ( this, arguments );  //--- Call the constructor
	function _constructor ( sRootUrl, sScreenMapUrl, sAjaxUrl, sScreenName, iScreenId ) 
	{
		if ( arguments.length != 3 && arguments.length != 5 )
		{
			alert("ERROR : TelosysEnv constructor : 3 or 5 arguments expected ! \n"
				+ "( sRootUrl, sScreenMapUrl, sAjaxUrl [ , sScreenName, iScreenId ] )  ");
			return null ;
		}
		
		_sRootUrl      = sRootUrl ;
		_sScreenMapUrl = sScreenMapUrl ;
		_sAjaxUrl      = sAjaxUrl ;
		
		if ( arguments.length == 5 )
		{
			//--- Initialize the current screen
			_sScreenName = sScreenName ;
			_iScreenId   = iScreenId ;
			_screen      = _createScreen (_sScreenName, _iScreenId) ;
			_actions     = _createActions(_screen);
		}
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _createScreen (sScreenName, sContextId) 
	{
		if ( arguments.length < 2 )
		{
			alert("ERROR : TelosysEnv._createScreen() : 2 arguments expected !");
			return null ;
		}
		//--- Create a new Screen and return it
		return new Screen( sScreenName, _sAjaxUrl, sContextId ) ;
	}
	//------------------------------------------------------------------------------
	function _createActions (oScreen) 
	{
		if ( arguments.length < 1 )
		{
			alert("ERROR : TelosysEnv._createActions() : 1 argument expected !");
			return null ;
		}
		return new ScreenActions( oScreen );
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	/**
	 * Return the absolute root URL of the WebApp 
	 * @return String : the URL
	 */
	this.getRootUrl = function () 
	{
		return _sRootUrl ;
	}

	//------------------------------------------------------------------------------
	// Return the absolute URL for screenmap calls with optional parameters.
	this.getScreenMapUrl = function (sName, sType, sContextId, sContextName, sAction, sParams) 
	{
		if ( arguments.length == 0 ) {
			return _sScreenMapUrl ;
		}
		/**
		if ( arguments.length != 5  ) {
			alert("ERROR : TelosysEnv.getScreenMapUrl() : 0 or 5 arguments expected !");
			return null ;
		}
		*/
		if ( sName == null ) {
			alert("ERROR : TelosysEnv.getScreenMapUrl() : argument 'name' is null !");
			return null ;
		}
		//--- Build the ScreenMap URL with parameters ...
		var s = _sScreenMapUrl + "/" + sName ;
        if ( sType != null ) {
            s = s + "-" + sType ;
        }
        
        if ( sContextId != null ) {
            s = s + "/" + sContextId ;
        }
        if ( sContextName != null ) {
	        if ( sContextId != null  ) {
	        	s = s + "-" + sContextName;
	        }
	        else {
	        	s = s + "/" + sContextName;
	        }
        }
        if ( sAction != null ) {
            s = s + ":" + sAction ;
        }				
        if ( sParams != null ) {
            s = s + "?" + sParams ;
        }				
		return s ;
	}

	//------------------------------------------------------------------------------
	/**
	 * Return the absolute URL for Screen actions calls ( AJAX calls )
	 * @return String : the URL
	 */
	this.getAjaxUrl = function () 
	{
		return _sAjaxUrl ;
	}

	//------------------------------------------------------------------------------
	/**
	 * Returns the current 'Screen' instance 
	 * Runtime error if no current screen
	 * @return Screen : the Screen instance ( or null after runtime error )
	 */
	this.getCurrentScreen = function () 
	{
		if ( _screen != null )
		{
			return _screen ;
		}
		else
		{
			alert("ERROR : TelosysEnv.getCurrentScreen() : No current screen !");
			return null ;
		}
	}
	//------------------------------------------------------------------------------
	/**
	 * Returns the current 'Actions' instance 
	 * Runtime error if not defined
	 * @return Actions : the Actions instance ( or null after runtime error )
	 */
	this.getCurrentActions = function () 
	{
		if ( _actions != null )
		{
			return _actions ;
		}
		else
		{
			alert("ERROR : TelosysEnv.getCurrentActions() : No current actions !");
			return null ;
		}
	}
	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'Screen' object for the given name and id
	 * @param  String : Screen name
	 * @param  int    : Screen context ID
	 * @return Screen : the Screen instance ( or null if error )
	 */
	this.getScreen = function (sScreenName, sContextId) 
	{
		if ( arguments.length < 2 )
		{
			alert("ERROR : TelosysEnv.getScreen() : 2 arguments expected !");
			return null ;
		}
		//--- Create a new Screen and return it
		return new Screen( sScreenName, _sAjaxUrl, sContextId ) ;
	}
	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'Service' object
	 * @param  String   : Service name
	 * @param  Function : Callback function to call to process the service response
	 * @return Service  : the Service instance ( or null if error )
	 */
	this.getService = function ( sServiceName, callbackFunction ) 
	{
		if ( arguments.length < 2 )
		{
			alert("ERROR : TelosysEnv.getService() : 2 arguments expected !");
			return null ;
		}
		return new ScreenService( sServiceName, _sRootUrl, callbackFunction ) ;
	}
	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'ScreenActions' object
	 * 2 signatures :
	 *  . 1 : getActions( ScreenObject )
	 *  . 2 : getActions( ScreenName, ScreenID )
	 * @param  arg1 : Screen object or Screen Name 
	 * @param  arg2 : Screen Id  ( with arg1 = Screen Name )
	 * @return ScreenActions : the ScreenActions instance ( or null if error )
	 */
	this.getActions = function ( arg1, arg2 ) 
	{
		if ( arguments.length == 2 )
		{
			if ( typeof arg1 == "string" && typeof arg2 == "string" )
			{
				return new ScreenActions( this.getScreen(arg1, arg2) );
			}
			else if ( typeof arg1 == "string" && typeof arg2 == "number" )
			{
				return new ScreenActions( this.getScreen(arg1, arg2) );
			}
			else
			{
				alert("ERROR : TelosysEnv.getActions() : invalid arguments type ! "
					+ "\n . argument 1 : '" + ( typeof arg1 ) + "' ( string expected ) " 
					+ "\n . argument 2 : '" + ( typeof arg2 ) + "' ( string or number expected ) " );
				return null ;
			}		
		}
		else if ( arguments.length == 1 )
		{
			if ( typeof arg1 == "object" )
			{
				return new ScreenActions( arg1 );
			}
			else
			{
				alert("ERROR : TelosysEnv.getActions() : the argument is not an object !");
				return null ;
			}
		}
		else
		{
			alert("ERROR : TelosysEnv.getActions() : " + arguments.length + " argument(s) ( 1 or 2 expected ) !");
			return null ;
		}
	}
	//------------------------------------------------------------------------------
	this.getKeyboard = function () 
	{
		return _keyboard ;
	}
	//------------------------------------------------------------------------------
	this.getBrowser = function () 
	{
		return _browser ;
	}
	//------------------------------------------------------------------------------
	this.toString = function () 
	{
		return "Root URL='" + _sRootUrl 
			 + "' - ScreenMap URL='" + _sScreenMapUrl 
			 + "' - Ajax URL='" + _sAjaxUrl + "'" ;
	}	
	//------------------------------------------------------------------------------	
}
//------------------------------------------------------------------------------
//                               T H E      E N D 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Picto_func.js  
// Functions set to managed the field picto actions ( Date Picker, Pick List, ... )
//------------------------------------------------------------------------------

//--------------------------------------------------------------------
// Return the field object associated with the given picto object 
// field.id = "foo" => picto.id = "foo_picto"
//--------------------------------------------------------------------
function fwkGetFieldForPicto(oPicto)
{
  if ( oPicto == null )
  {
    alert("ERROR : fwkGetFieldForPicto(picto) : picto object is null ");
    return null ;
  }
  var sPictoId = oPicto.id ;
  if ( sPictoId == null )
  {
    alert("ERROR : fwkGetFieldForPicto(picto) : picto.id is null ");
    return null ;
  }
  var i = sPictoId.lastIndexOf("_picto");
  if ( i <= 0 )
  {
    alert("ERROR : fwkGetFieldForPicto(picto) : invalid picto.id '" + sPictoId + "' ( xx_picto expected ) ! " );
    return null ;
  }
  var sFieldId = sPictoId.substring(0, i);
  //alert("fwkGetFieldForPicto : \n picto id = " + sPictoId + " \n field id = " + sFieldId );
  var oField = document.getElementById(sFieldId);
  if ( oField == null )
  {
    alert("ERROR : fwkGetFieldForPicto(picto) : field '" + sFieldId + "' not found ");
  }
  return oField ;
}
//--------------------------------------------------------------------
function fwkSetPictoFieldValue(oPicto, sValue)
{
  var oField = fwkGetFieldForPicto(oPicto);
  if ( oField != null )
  {
    oField.value = sValue ;
  }
}
//--------------------------------------------------------------------
function fwkDatePicker(oPicto)
{
  //--- 1) Call any Date Picker that returns a selected date in ISO format
  alert("Show the calendar ..." );
  var sSelectedDate = "2001-03-25" ;
  
  //--- 2) Call the date formater
  // TODO 
  var sFormatedDate = "25/03/2001" ; 
  
  //--- 3) Set the formated date in the field
  fwkSetPictoFieldValue(oPicto, sFormatedDate);
/**
  var oField = fwkGetFieldForPicto(oPicto);
  if ( oField != null )
  {
    oField.value = sFormatedDate ;
  }
**/
}
//--------------------------------------------------------------------
function fwkPickList(oPicto)
{
  //--- 1) Call any "Pick List" that returns a value
  alert("Show the pick list ..." );
  var sValue = "The value" ;
  
  //--- 2) Set the value in the field
  fwkSetPictoFieldValue(oPicto, sValue);
  /**
  var oField = fwkGetFieldForPicto(oPicto);
  if ( oField != null )
  {
    oField.value = sValue ;
  }
  **/
}
//--------------------------------------------------------------------
//------------------------------------------------------------------------------
// Popup_func.js  
// Functions set to managed the popup windows
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Open a popup window
//------------------------------------------------------------------------------
function fwkOpenPopupWindow(argUrl, callback, argWidth, argHeight)
{
	var sUrl = argUrl ;

	//--- Set the standard accessors functions to the current window 
	window.fwkSetPopupReturnObject = function ( oReturn ) 
	{
		//alert("fwkSetPopupReturnObject(" + oReturn + ")" );
		if ( callback )
		{
			callback( oReturn );
		}
		window.fwkPopupReturnObject = oReturn ;
	}
	
	//--- Open the popup window 
	if ( window.showModalDialog )
	{
		//--- IE => use "showModalDialog" with return
		var dialogArguments = "xx" ; // used as a flag to identify IE modal dialog
		var sWindowFeatures = "center:yes;" ;
		if ( argWidth )  sWindowFeatures += "dialogWidth:"  + argWidth + "px;" ;
		if ( argHeight ) sWindowFeatures += "dialogHeight:" + argHeight + "px;" ;
    	var oReturn = window.showModalDialog(sUrl, dialogArguments, sWindowFeatures );
    	window.fwkSetPopupReturnObject(oReturn);
	}
	else
	{
		//--- Non IE => use "open"
		var sWindowName = "Popup"  ;
		//var sWindowFeatures = "resizable=no,scrollbars=no,status=no,toolbar=no,location=no" ;
		//var sWindowFeatures = "dialog=yes,dependent=yes,status=no,width=400,height=400" ; // for Firefox modal window
		var sWindowFeatures = "dialog=yes,dependent=yes,status=no," ; // for Firefox modal window
		if ( argWidth  == null ) argWidth  = 400 ;
		if ( argHeight == null ) argHeight = 400 ;
		sWindowFeatures += "width=" + argWidth + ",height=" + argHeight + ",";
		//--- Open or focus
		if ( window.popupWindow == null )
		{
			window.popupWindow = window.open(sUrl, sWindowName, sWindowFeatures );
		}
		else
		{
			if ( window.popupWindow.closed )
			{
				window.popupWindow = window.open(sUrl, sWindowName, sWindowFeatures);
			}
		}
		window.popupWindow.focus();
	}
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
function fwkPopupReturn( oReturn )
{
	if ( window.opener )
	{
		if ( window.opener.fwkSetPopupReturnObject )
		{
			window.opener.fwkSetPopupReturnObject(oReturn);
		}
		else
		{
			alert("ERROR : window.opener.fwkSetPopupReturnObject is not defined ! ");
		}
	}
	else
	{
		if ( window.dialogArguments )
		{
			//--- It's an IE modal dialog box
			window.returnValue = oReturn ;
		}
		else
		{
			alert("ERROR : window.opener and window.dialogArguments  not defined ! ");
		}
	}
	window.close();
}
//------------------------------------------------------------------------------

//---------------------------------------------------------------------------------
// TabSet_class.js
// Telosys framework
// Author : Laurent Gurin
//---------------------------------------------------------------------------------
// TabSet object : 
//  - a TabSet is composed of 1 to N tabs
//  - each tab is associated with a TabPannel
//---------------------------------------------------------------------------------
function TabSet(sClassNormal, sClassSelected )
{
	//==============================================================================
	// INSTANCE ATTRIBUTES
	//==============================================================================
	var _currentTab      = null ; // Current selected tab object ( TD tag )
	var _currentTabIndex = -1 ;   // Current selected tab index ( 0 to N )
	var _currentPanel    = null ; // Current visible panel ( DIV tag )
		
	var _tabClassNormal   = sClassNormal ;   // CSS class for a normal tab (not selected)
	var _tabClassSelected = sClassSelected ; // CSS class for a selected tab

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================		
	this.getCurrentTabIndex = function()
	{
		return _currentTabIndex ;
	}

	this.showPanel = function  ( oPanel )
	{
		//--- Cacher la page en cours 
		if ( _currentPanel != null )
		{
			_currentPanel.style.visibility = 'hidden' ;
		}
		//--- Changer de page en cours 
		_currentPanel = oPanel ;
		//--- Afficher la page en cours 
		if ( _currentPanel != null )
		{
			_currentPanel.style.visibility = 'visible' ;
		}
	}

	this.showTab = function  ( oTab )
	{
		if ( oTab != null )
		{
			//--- Neutralise l'onglet en cours 
			if ( _currentTab != null )
			{
				_currentTab.className = _tabClassNormal ;
			}
			//--- Active l'onglet en cours 
			oTab.className = _tabClassSelected ;
			//--- Set the new current tab  
			_currentTab = oTab ;
			_currentTabIndex = oTab.tabIndex ;
		}			
	}
}

//---------------------------------------------------------------------------------
// TabSet_func.js
// Telosys framework
// Author : Laurent Gurin
//---------------------------------------------------------------------------------

function fwkInitTab ( sTabId, iTabIndex, sPanelId, oTabSet )
{
	var oTab = document.getElementById(sTabId);
	if ( oTab == null ) 
	{
		alert ( "fwkLinkTabToPanel : tab '" + sTabId + "' not found ! " );
		return ;
	}
	//--- Set the current tabset object 
	oTab.tabSet = oTabSet ;
	//--- Set the index
	oTab.tabIndex = iTabIndex ;
	//--- Link Tab object with the given panel 
	oTab.linkedPanelId = sPanelId ;
	//alert ( sTabId + " linked to " + sPanelId ) ; 
}
	
function fwkSelectTab( tab )
{
	if ( tab == null ) 
	{
		alert( "fwkSelectTab() : tab is null !" );
		return false ;
	}
	if ( typeof tab == "string" )
	{
		return fwkSelectTabById( tab );
	}
	else
	{
		return fwkSelectTabByRef( tab );
	}
}

function fwkSelectTabById( sTabId )
{
	if ( sTabId == null ) 
	{
		alert( "fwkSelectTabById() : tab id is null !" );
		return false ;
	}
	else
	{
		var oTab = document.getElementById(sTabId);
		if ( oTab == null ) 
		{
			alert ( "ERROR : Tab  "+sTabId+" doesn't exist ( check the ID ) ! " );
			return false ;
		}
		else
		{
			return fwkSelectTabByRef(oTab);
		}	
	}
}
	
function fwkSelectTabByRef( oTab )
{
	if ( oTab == null ) 
	{
		alert ( "ERROR : Tab argument is null ! " );
		return false ;
	}
	else
	{
		if ( oTab.tabSet )
		{
			//--- Check this tab is not already selected
			if ( "tabIndex" in oTab )
			{
				if ( oTab.tabIndex == oTab.tabSet.getCurrentTabIndex() )
				{
					//--- Already selected
					return false ;
				}
			}
			else
			{
				alert ( "ERROR : Tab is not initialized (no tabIndex attribute) ! " );
				return false;
			}			
			//--- Select the new tab 
			oTab.tabSet.showTab ( oTab ) ;
			//--- If the tab is linked with a panel
			if ( oTab.linkedPanelId )
			{
				//--- Get the panel object
				if ( ! oTab.linkedPanel )
				{
					//--- Not yet initialized => search by ID
					oTab.linkedPanel = document.getElementById(oTab.linkedPanelId);
				}					
				if ( oTab.linkedPanel )
				{
					//--- Show the linked panel 
					oTab.tabSet.showPanel ( oTab.linkedPanel ) ;
				}
				else
				{
					//--- Still null => invalid ID
					alert ( "fwkSelectTabByRef : pannel '" + oTab.linkedPanelId + "' not found ! " );
					return false;							
				}	
			}			
		}
		else
		{
			alert ( "ERROR : Tab is not initialized (no tabset attribute) ! " );
			return false;
		}			
	}
	return true ;
}

//----------------------------------------------------------------------------------------------------
function fwkComboDisplayList(id) 
{
	if ( id != null ) 
	{
		//alert("fwkComboDisplayList(" + id + ")");
		var comboDiv = document.getElementById(id+"_main");
		var comboInput = document.getElementById(id);
		var comboPicto = document.getElementById(id+"_picto");
		var comboSelect = document.getElementById(id+"_select");
		if(comboDiv != null && comboSelect!=null) 
		{
			//alert("fwkComboDisplayList(" + id + ") Step 2 ");
			//var pos = fwkGetXY(comboDiv);
			var pos = fwkGetRelativeXY(comboDiv);
			if ( pos != null )
			{
				//alert("fwkComboDisplayList(" + id + ") Step 3 ");
				comboSelect.style.left = pos[0] ; // X
				comboSelect.style.top = pos[1] + comboDiv.offsetHeight + 1 ; // Y
				comboSelect.style.width = comboInput.offsetWidth + comboPicto.offsetWidth;
				comboSelect.style.display="block";
				comboSelect.focus();
			}
		}
	}
	else
	{
		fwkError("fwkComboDisplayList : ID argument is null !");	
	}
}

//----------------------------------------------------------------------------------------------------
function fwkComboHideList(id) 
{
	if ( id != null ) 
	{
		var comboSelect = document.getElementById(id+"_select");
		if(comboSelect != null) 
		{
			comboSelect.selectedIndex=-1;
			comboSelect.style.display="none";
		}
		else
		{
			fwkError("fwkComboHideList : No element for id '" + id + "' ");	
		}
	}
	else
	{
		fwkError("fwkComboHideList : ID argument is null !");	
	}
}

//----------------------------------------------------------------------------------------------------
function fwkComboSelectBlur(id) 
{
	fwkComboHideList(id) 
}

//----------------------------------------------------------------------------------------------------
function fwkComboSelectChange(select,id)
{
	if ( id != null ) 
	{
		var comboInput = document.getElementById(id);
		if(comboInput != null) 
		{
			comboInput.value = select.options[select.selectedIndex].text;
			comboInput.focus();
		}
		else
		{
			fwkError("fwkComboSelectChange : No element for id '" + id + "' ");	
		}
	}
	else
	{
		fwkError("fwkComboSelectChange : ID argument is null !");	
	}
}

function fwkUpload(id)
{
	//--- Check field validity 
	var oField = document.getElementById(id);
	if ( oField == null )
	{
		fwkError("fwkUpload() : Cannot get INPUT FILE element (id='"+id+"')" ) ;
		return;
	}	
	if ( oField.value == null )
	{
		fwkError("fwkUpload() : File path is null (id='"+id+"')" ) ;
		return;
	}	
	if ( oField.value == "" )
	{
		fwkError("fwkUpload() : File path is void (id='"+id+"')" ) ;
		return;
	}
	
	//--- Try to submit 
	var sFormId = id + "_form" ;
	var form = document.getElementById(sFormId);
	if (form != null) 
	{
		form.submit();
	}
	else
	{
		fwkError("fwkUpload() : Cannot get FORM element (id='" + sFormId + "')" ) ;		
	}		
}
// Callback method called by the IFRAME when it receives the response 
// ( <IFRAME ... onload="fwkUploadCallBack(this)" > )
function fwkUploadCallBack(iframe,funct)
{
	if (iframe != null) 
	{
		var ifBody = iframe.contentWindow.document.body;
		if (ifBody != null) 
		{
			var inner = ifBody.innerHTML;
			if (inner != null) 
			{
				var indSpace = inner.indexOf(' ');
				if (indSpace > -1)
				{
					var code = parseInt(inner.substring(0,indSpace));
					var msg = inner.substring(indSpace+1);
					if (funct != null) 
					{
						funct(code, msg);
					}
					else
					{
						if (code != 0) 
						{
							alert("UPLOAD ERROR :\n" + msg);
						} 
					}
				}
			}
		}
	}
}
//----------------------------------------------------------------------
// Rich-Text Editor functions
//----------------------------------------------------------------------
function fwkRTEButtonMouseOver(obj, sImage )
{
	obj.style.borderWidth = "1px" ;
	obj.style.borderColor = "#999999" ;
	obj.style.margin      = "0px" ;  
	obj.src = sImage ;
}
//----------------------------------------------------------------------
function fwkRTEButtonMouseOut(obj, sImage )
{
	obj.style.borderWidth = "0px" ;
	obj.style.borderColor = "transparent" ;
	obj.style.margin      = "1px" ;   
	obj.src = sImage ;
}
//----------------------------------------------------------------------
function fwkRTEGetText( sId )
{
	var doc = fwkGetIFrameDocument( sId );
	if ( doc != null )
	{
		return doc.body.innerHTML ;
	}
}
//----------------------------------------------------------------------
function fwkRTESetText( sId, sText )
{
	var doc = fwkGetIFrameDocument( sId );
	if ( doc != null )
	{
		doc.body.innerHTML = sText ;
	}
}
//----------------------------------------------------------------------
function fwkRTEClearText( arg ) // IFRAME id or IFRAME object
{
	var doc = fwkGetIFrameDocument( arg );
	/**
	var doc = null ;
	if ( typeof arg == "string" )
	{
		doc = fwkGetIFrameDocument( arg );
	}
	else if ( arg.body )
	{
		doc = arg ;
	}
	else
	{
		fwkError ( "fwkRTEClearText() invalid argument type ! ( type = " + typeof arg + " )" ) ;
		return ;
	}
	**/
	if ( doc != null )
	{
		doc.body.innerHTML = "" ;		
	}
	else
	{
		fwkError ( "fwkRTEClearText() document is null !" ) ;
	}
}
//----------------------------------------------------------------------
function fwkRTEDisable( arg ) // IFRAME id or IFRAME object
{
	var doc = fwkGetIFrameDocument( arg );
	if ( doc != null )
	{
		alert ( "set designMode OFF" );
		doc.designMode = "off"; // IE and FF/Moz
	}
	else
	{
		fwkError ( "fwkRTEDisable() document is null !" ) ;
	}
}
//----------------------------------------------------------------------
function fwkRTEShowSource( sId )
{
	var doc = fwkGetIFrameDocument( sId );
	if ( doc != null )
	{
		alert ( doc.body.innerHTML ) ;
	}
}
//----------------------------------------------------------------------
function fwkRTEInit( sIFrameId, sContent )
{
	var doc = fwkGetIFrameDocument( sIFrameId );
	if ( doc != null )
	{
		doc.open();
		if ( sContent != null )
		{
			doc.write( sContent );
		}
		else
		{
			doc.write( "   " ); // NB : at least 2 blanks to avoid <PRE> with IE
		}
		doc.close();
	}
	// Make the iframe editable in both Mozilla and IE
	//doc.body.contentEditable = true; // IE ( not FF or Mozilla )
	doc.designMode = "on"; // IE and FF/Moz
}
//----------------------------------------------------------------------
function fwkRTESelectFontSize( oCombo, sIFrameId )
{
	var iIndex = oCombo.selectedIndex ;
	if ( iIndex > 0 )
	{
		oCombo.selectedIndex = 0 ; // Reset Combo
		var sFontSize  = oCombo.options[ iIndex ].value ;
		//alert ( oCombo.selectedIndex + " : " + sFontSize );
		fwkRTEFormatText('FontSize', sIFrameId, sFontSize );
	}
	else
	{
		fwkRTEFocus( sIFrameId ); // Set focus  ????
	}
}
//----------------------------------------------------------------------
function fwkRTESelectFontName( oCombo, sIFrameId )
{
	var iIndex = oCombo.selectedIndex ;
	if ( iIndex > 0 )
	{
		oCombo.selectedIndex = 0 ; // Reset Combo
		var sFontName  = oCombo.options[ iIndex ].value ;
		//alert ( oCombo.selectedIndex + " : " + sFontName );
		fwkRTEFormatText('FontName', sIFrameId, sFontName );
	}
	else
	{
		fwkRTEFocus( sIFrameId ); // Set focus  ????
	}
}
//----------------------------------------------------------------------
function fwkRTEFocus( sIFrameId )
{
	var oFrame = document.getElementById(sIFrameId)
	if (oFrame != null)
	{
		oFrame.contentWindow.focus();
	}
	else
	{
		fwkError ( "fwkRTEFocus() : Cannot found the frame with id = " + sIFrameId ) ;
	}
}
//----------------------------------------------------------------------


//----------------------------------------------------------------------
function fwkRTEFormatText(sCommand, sIFrameId, sCommandParam) 
{
	// When user clicks toolbar button make sure it always targets its respective WYSIWYG
	document.getElementById(sIFrameId).contentWindow.focus();
	
	var doc = fwkGetIFrameDocument( sIFrameId );

	if ( sCommand == 'BackColor' ) // FireFox/Mozilla compatibility : replace 'BackColor' by 'hilitecolor'
	{
		//alert ("sCommand is 'BackColor' ");
		//if ( ! ( "contentEditable" in doc.body ) ) // not IE ( => FF or Mozilla )
		if ( navigator.appName == "Netscape" ) // FF or Mozilla
		{
			sCommand = 'hilitecolor' ;  // FireFox/Mozilla command for partial Background Color 
		}
	}
	
	// Commands with parameter 
	if ( sCommand == "FontSize" || sCommand == "FontName" || sCommand == 'ForeColor' || sCommand == 'BackColor' || sCommand == 'hilitecolor' ) 
	{
		doc.execCommand(sCommand, false, sCommandParam);
	}	
	else // Every other command
	{
		doc.execCommand(sCommand, false, null);
	}
};

//----------------------------------------------------------------------------------
// Class ColorPicker
//----------------------------------------------------------------------------------
function ColorPicker( sIdEditorFrame, sIdDivColor, sIdFieldColor, sIdFieldCode )
{
	//------------------------------------------------------------------------------
	// PRIVATE INSTANCE ATTRIBUTE(S)
	//------------------------------------------------------------------------------
	var _sIdEditorFrame = sIdEditorFrame ;
	var _oDivColor   = document.getElementById(sIdDivColor) ;
	var _oFieldColor = document.getElementById(sIdFieldColor) ;
	var _oFieldCode  = document.getElementById(sIdFieldCode) ;
	var _sCommand    = null ;
	var _bPositionSet = false ;

	if ( _oDivColor == null )
	{
		fwkError("Color Picker : Cannot found DIV for color picker ! Id = " + sIdDivColor );
	}
	if ( _oFieldColor == null )
	{
		fwkError("Color Picker : Cannot found field for color preview ! Id = " + sIdFieldColor );
	}
	if ( _oFieldCode == null )
	{
		fwkError("Color Picker : Cannot found field for color code ! Id = " + sIdFieldCode );
	}

	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.preview = function(color)
	{
		if ( _oFieldColor != null && _oFieldCode != null )
		{
			_oFieldColor.style.backgroundColor = color;
			_oFieldCode.value = color;
		}
		else
		{
			fwkError("ColorPicker.preview() : fields are not initialized !");
		}
	}
	//----------------------------------------------------------------------
	this.open = function(sCommand, oFrom) 
	{
		if ( sCommand == null )
		{
			fwkError("ColorPicker.open() : No 'command' argument !");
			return ;
		}
		if ( oFrom == null )
		{
			fwkError("ColorPicker.open() : No 'from' argument !");
			return ;
		}
		if ( ! _bPositionSet )
		{
			var position = fwkGetXY(oFrom); // X,Y of the caller object 
			if ( position != null )
			{
				var x = position[0];
				var y = position[1];
				_oDivColor.style.left = x - 100 ;
				_oDivColor.style.top  = y + 22 ;
			}
			_bPositionSet = true ;
		}
		
		_sCommand = sCommand ; // 'ForeColor' or 'BackColor'
		// Open (show) the color picker
		if ( _oDivColor != null )
		{
			_oFieldColor.style.backgroundColor = "#FFFFFF";
			_oFieldCode.value = "";
			_oDivColor.style.zIndex = 9999;
			_oDivColor.style.visibility = "visible" ;			
			_oFieldCode.focus(); // Just to set the focus on the DIV 
		}
	}
	//----------------------------------------------------------------------
	this.close = function() 
	{
		// Close (hide) the color picker
		if ( _oDivColor != null )
		{
			_oDivColor.style.visibility = "hidden" ;
		}
		fwkRTEFocus( _sIdEditorFrame );
	}
	//----------------------------------------------------------------------
	this.select = function(color) 
	{
		// Close (hide) the color picker
		if ( _oDivColor != null )
		{
			_oDivColor.style.visibility = "hidden" ;
		}
		
		// Format the text in the editor with the given color
		//fwkRTEFormatText('ForeColor', _sIdEditorFrame, color);
		fwkRTEFormatText(_sCommand, _sIdEditorFrame, color); // 'ForeColor' or 'BackColor'

		//var doc = fwkGetIFrameDocument( _sIdEditorFrame );
		//doc.execCommand('ForeColor', false, color);
		
		//window.event.cancelBubble = true ; // for IE and FF	
	}
}
//----------------------------------------------------------------------------------

//------------------------------------------------------------------------------

//--- Default style values : to be overloaded 
var FWK_LIST_ROW_SELECT_COLOR = null ;
var FWK_LIST_ROW_SELECT_CLASS = "telosys_row_selected" ;

var FWK_LIST_ROW_MOUSE_OVER_COLOR = null ;
var FWK_LIST_ROW_MOUSE_OVER_CLASS = "telosys_row_mouse_over" ;

//------------------------------------------------------------------------------
function fwkListGetTBody( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetSelectedRow" ;
	var oListDivBody = fwkGetObject(arg, sFctName );
	if ( oListDivBody != null )
	{
		//--- Get the <tbody> child tag
		var oTBody = oListDivBody.getElementsByTagName("tbody")[0] ;
		if ( oTBody == null ) 
		{ 
			fwkError ( sFctName + " : Cannot found <TBODY> in <DIV> " + oListDivBody.id ) ; 
		}
		return oTBody ;
	}
	return null ;
}
//------------------------------------------------------------------------------
function fwkListGetRowCount( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListGetRowCount" ) ;
	if ( oTBody != null ) 
	{ 
		return oTBody.rows.length ;
	}
	return 0 ;
}
//------------------------------------------------------------------------------
function fwkListGetRows( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetRows" ;
	var oTBody = fwkListGetTBody( arg, sFctName ) ;
	if ( oTBody != null ) 
	{ 
		//--- Get the ROWS array
		return oTBody.rows ;
	}
	return null;
}
//------------------------------------------------------------------------------
function fwkListGetSelectedRow( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetSelectedRow" ;
	var oTBody = fwkListGetTBody( arg, sFctName ) ;
	if ( oTBody != null ) 
	{ 
		//--- Get the selected row
		return oTBody.fwkSelectedRow ;
	}
	return null;
}
//------------------------------------------------------------------------------
function fwkListSelect( arg, index ) // index : 1 to N
{
	if ( index == null )
	{
		fwkError ( "fwkListSelect : row index is null ! " ) ; 
	}
	var oRows = fwkListGetRows( arg, "fwkListSelect" );
	if ( oRows != null ) 
	{
		if ( index > 0 && index <= oRows.length )
		{
			fwkListRowSelect( oRows[index-1] ) ;					
		}
		else
		{
			fwkError ( "fwkListSelect : invalid index : " + index ) ; 
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectFirst( arg )
{
	var oRows = fwkListGetRows( arg, "fwkListSelectFirst" );
	if ( oRows != null ) 
	{
		if ( oRows.length > 0 )
		{
			fwkListRowSelect( oRows[0] ) ;					
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectLast( arg )
{
	var oRows = fwkListGetRows( arg, "fwkListSelectLast" );
	if ( oRows != null ) 
	{
		if ( oRows.length > 0 )
		{
			fwkListRowSelect( oRows[oRows.length-1] ) ;					
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectNext( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListSelectNext" ) ;
	if ( oTBody != null ) 
	{ 
		var oSelectedRow = oTBody.fwkSelectedRow ;
		if ( oSelectedRow != null )
		{		
			if ( oSelectedRow.rowIndex < oTBody.rows.length-1 )
			{
				fwkListRowSelect( oTBody.rows[oSelectedRow.rowIndex+1] );
			}
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectPrev( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListSelectPrev" ) ;
	if ( oTBody != null ) 
	{ 
		var oSelectedRow = oTBody.fwkSelectedRow ;
		if ( oSelectedRow != null )
		{		
			if ( oSelectedRow.rowIndex > 0 )
			{
				fwkListRowSelect( oTBody.rows[oSelectedRow.rowIndex-1] );
			}
		}
	}
}
//------------------------------------------------------------------------------
function fwkListUnSelect( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListUnSelect" ) ;
	if ( oTBody != null ) 
	{ 
		if ( oTBody.fwkSelectedRow != null )
		{
			fwkListRowUnSelect( oTBody.fwkSelectedRow );
			oTBody.fwkSelectedRow = null ;
		}
	}	
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkListRowUnSelect( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowUnSelect : no ROW argument ! ");
		return ;
	}
	if ( oTR.fwkOriginalColor != null )
	{
		oTR.style.backgroundColor = oTR.fwkOriginalColor ; // Restore original color
	}
	if ( oTR.fwkOriginalClass != null )
	{
		oTR.className = oTR.fwkOriginalClass ; // Restore original class
	}
	oTR.fwkSelected = false ;
}
//------------------------------------------------------------------------------
function fwkListRowSelect( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowSelect : no ROW argument ! ");
		return ;
	}

	var oTBody = oTR.parentNode;
	if ( oTBody == null )
	{
		fwkError ( "fwkListRowSelect : cannot get parent TBody! ");
		return ;
	}
	
	var oSelectedRow = oTBody.fwkSelectedRow ;
	if ( oSelectedRow != null )
	{
		if ( oSelectedRow.rowIndex != oTR.rowIndex )
		{
			//--- Unselect the current row
			fwkListRowUnSelect( oSelectedRow );
		}
		else
		{
			//--- This row is already selected => noting to do
			return ; 
		}
	}

	//--- Select the given row
	oTR.fwkSelected = true ;	
	oTBody.fwkSelectedRow = oTR ; // Keep the new selected row	
	
	//--- Keep the original "BgColor" or "Class"
	if ( oTR.fwkOriginalColor == null ) 
	{
		oTR.fwkOriginalColor = oTR.style.backgroundColor ; // Keep original color
	}
	if ( oTR.fwkOriginalClass == null ) 
	{
		oTR.fwkOriginalClass = oTR.className ; // Keep original class
	}
	//--- Set the new "BgColor" or "Class"
	if ( FWK_LIST_ROW_SELECT_COLOR != null )
	{
		oTR.style.backgroundColor = FWK_LIST_ROW_SELECT_COLOR ; // Set new color
	}
	if ( FWK_LIST_ROW_SELECT_CLASS != null )
	{
		oTR.className = FWK_LIST_ROW_SELECT_CLASS ;	// Set new class
	}
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkListRowMouseOver( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowMouseOver : no ROW argument ! ");
		return ;
	}

	if ( ! oTR.fwkSelected )
	{
			if ( oTR.fwkOriginalColor == null ) 
			{
				oTR.fwkOriginalColor = oTR.style.backgroundColor ; // Keep original color
			}
			if ( oTR.fwkOriginalClass == null ) 
			{
				oTR.fwkOriginalClass = oTR.className ; // Keep original class
			}
			
		//--- Set the "BgColor" 
		if ( FWK_LIST_ROW_MOUSE_OVER_COLOR != null )
		{
			oTR.style.backgroundColor = FWK_LIST_ROW_MOUSE_OVER_COLOR ;	
		}
		//--- Set the "Class" 
		if ( FWK_LIST_ROW_MOUSE_OVER_CLASS != null )
		{
			oTR.className = FWK_LIST_ROW_MOUSE_OVER_CLASS ;	
		}
	}
}
//------------------------------------------------------------------------------
function fwkListRowMouseOut( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowMouseOut : no ROW argument ! " );
		return ;
	}
	//--- If line NOT SELECTED
	if ( ! oTR.fwkSelected )
	{
		if ( oTR.fwkOriginalColor != null )
		{
			oTR.style.backgroundColor = oTR.fwkOriginalColor ; // Restore original color
		}
		if ( oTR.fwkOriginalClass != null )
		{
			oTR.className = oTR.fwkOriginalClass ; // Restore original class
		}
	}
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkAdjustHeadWidth(sIdHead, sIdBody)
{
	var oHead = document.getElementById(sIdHead);
	if ( oHead == null )
	{
		fwkError("fwkAdjustHeadWidth : Cannot found LIST HEAD with id = " + sIdHead ) ;		
		return;
	}
	var oBody = document.getElementById(sIdBody);
	if ( oBody == null )
	{
		fwkError("fwkAdjustHeadWidth : Cannot found LIST BODY with id = " + sIdHead ) ;		
		return;
	}
	//--- Adjust the head WIDTH
	oHead.style.width = oBody.clientWidth;
}
//------------------------------------------------------------------------------
function fwkScrollHead(sIdHead, oBody)
{
	var oHead = document.getElementById(sIdHead);
	if ( oHead == null )
	{
		fwkError("fwkScrollHead : Cannot found LIST HEAD with id = " + sIdHead ) ;		
		return;
	}
	oHead.scrollLeft = oBody.scrollLeft;
}
//------------------------------------------------------------------------------

//---------------------------------------------------------------------------
function fwkAfterMenuItemClick( evt ) // Stop the event NOW !
{
//log.error("fwkAfterMenuItemClick(...) ========== ");
	fwkCancelEvent( evt );
	//fwkMenuBarReset( document.getElementById(window.fwkCurrentMenuBarId) );
	fwkResetMenuBar();
}
//---------------------------------------------------------------------------
function fwkSetMenuYX(menu, origin, where)
{
	if ( menu == null ) 
	{ 
		fwkError("fwkSetMenuYX : menu parameter is null"); 
		return; 
	}
	if ( menu.x != null ) return ; // allready set 
	if ( origin == null ) 
	{ 
		fwkError("fwkSetMenuYX : origin parameter is null"); 
		return; 
	}
	
	var posX = origin.offsetLeft;
	var posY = origin.offsetTop;
	//-----------------------------------
	//var obj = origin ;
	//while ( obj.offsetParent ) 
	//{
	//	obj = obj.offsetParent ;
	//	posX += obj.offsetLeft;
	//	posY += obj.offsetTop;
	//}
	//-----------------------------------
	var pos = fwkGetRelativeXY(origin);
	if ( pos != null )
	{
		posX = pos[0];
		posY = pos[1];
	}
	
	if ( where == "R" ) // Right
	{
		posX += origin.clientWidth ;
	}
	else if ( where == "B" ) // Below
	{
		posY += origin.clientHeight + 2;
	}
	else // Unknown position : + 20 px 
	{
		posX += 20 ;
		posY += 20 ;
	}
	menu.x = posX ;
	menu.y = posY ;
}
//---------------------------------------------------------------------------
function fwkShowMenu(menu) // menu is a DIV
{
//log.debug("fwkShowMenu(...) : " + ( menu != null ? ( menu.nodeName + " #" + menu.id ) : 'null' ) );
	if ( menu == null ) return ;
	if ( menu.bInit == null ) 
	{
//log.error("fwkShowMenu(...) : INIT "  );
		var frames = menu.getElementsByTagName("IFRAME");
		if ( frames.length > 0 )
		{
//log.debug("fwkShowMenu(...) : frame found "  );
			var f = frames[0];
			f.style.width  = menu.clientWidth + "px" ;
			f.style.height = menu.clientHeight + "px" ;
		}
		menu.bInit = true ;
	}
	
	menu.style.left = menu.x ;
	menu.style.top  = menu.y ;
	menu.style.visibility = "visible" ;
}
//---------------------------------------------------------------------------
function fwkHideMenu(menu) // menu is a DIV ( NB: recursive function => use "var" for each local variable ! )
{
//log.error("fwkHideMenu(...) : " + ( menu != null ? ( menu.nodeName + " #" + menu.id ) : 'null' ) );
	if ( menu == null ) return ;
	menu.style.visibility = "hidden" ;
	var rows = menu.getElementsByTagName("TR");
	for( var i = 0 ; i < rows.length; i++ )
	{
//log.debug("fwkHideMenu(...) : " + ( menu != null ? menu.id : 'null' ) + " ROW " + i + "/" + rows.length );
		var tr = rows[i] ;
		if ( tr.className != "off" )
		{
			tr.className = "off";
			if ( tr.submenu != null )
			{
				fwkHideMenu(tr.submenu);
			}
		}
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkSelectMenuItem() // TR event
{
//log.debug("fwkSelectMenuItem("+this.nodeName+":"+this.id+")" );
	var parentMenu = this.parentNode ; // TBody 
	if ( parentMenu != null )
	{
		var rows = parentMenu.getElementsByTagName("TR");
		for( var i = 0 ; i < rows.length; i++ )
		{
			rows[i].className = "off";
			if ( rows[i].submenu != null )
			{
				fwkHideMenu(rows[i].submenu);
			}
		}
	}
	//--- Hilight ITEM
	this.className = "on";
	
	//--- Set submenu if any
	if ( this.submenuId != null && this.submenu == null)
	{
		this.submenu = document.getElementById(this.submenuId);
		if ( this.submenu == null )
		{
			alert("ERROR : fwkSelectMenuItem : cannot found submenu with id = '" + this.submenuId + "'");
		}
	}
	
	//--- Show Sub menu if any 
	var m = this.submenu ;	
	if ( m != null )
	{
		fwkSetMenuYX(m, this, "R"); // Right
		fwkShowMenu(m);
	}	
}
//---------------------------------------------------------------------------
function fwkUnselectMenuItem() // TR event
{
	if ( this.submenu == null ) // leaf only
	{
		this.className = "off";
	}
}
//---------------------------------------------------------------------------
function fwkSelectMenuBarItem(td, menuId, menuPosition)
{
//log.warning("fwkSelectMenuBarItem(td,"+menuId+")" );
	if ( td == null ) 
	{ 
		fwkError("fwkSelectMenuBarItem : td parameter is null"); 
		return; 
	}

	//--- Get MenuBar
	if ( td.menubar == null )
	{
		td.menubar = fwkGetParentDIV(td);
	}
	var menuBar = td.menubar ;	
	if ( menuBar != null )
	{
//log.warning("fwkSelectMenuBarItem(td,"+menuId+") : menuBar != null : " + menuBar.nodeName );
		if ( menuBar.activeItem != null )
		{
			menuBar.activeItem.className = "off"; 
		}
		menuBar.activeItem = td ;
		if ( menuBar.activeMenu != null )
		{
			fwkHideMenu(menuBar.activeMenu);
			menuBar.activeMenu = null ;
		}
	}
	else
	{
		fwkError("fwkSelectMenuBarItem : cannot get menubar ( parent DIV )"); 
		return ;
	}
	
	//--- ITEM "ON"
	td.className = "on";
	
	var m = ( menuId != null ? document.getElementById(menuId) : null );
	if ( m != null )
	{
		var where = ( menuPosition != null ? menuPosition : "B" ); // Below by default
		fwkSetMenuYX(m, td, where); // Right
		
		//log.warning("fwkSelectMenuBarItem(tr,"+menuId+") : ShowMenu .." );
		fwkShowMenu(m);
		//log.warning("fwkSelectMenuBarItem(tr,"+menuId+") : Set active menu .." );
		menuBar.activeMenu = m ;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkResetMenuBar(pMenuBar) // menubar is a TABLE
{
//log.info("fwkResetMenuBar(menubar)" );
	var menubar = pMenuBar ;
	if ( menubar == null ) 
	{ 
		menubar = window.fwkCurrentMenuBar ;
		if ( menubar == null ) 
		{ 
			fwkError("fwkResetMenuBar : no menubar !"); 
			return; 
		}
	}
	if ( menubar.activeMenu != null )
	{
		//log.debug("fwkResetMenuBar(menubar) : menubar.activeMenu != null : id = " + menubar.activeMenu.id );
		fwkHideMenu( menubar.activeMenu );
	}
	else
	{
		//log.debug("fwkResetMenuBar(menubar) : menubar.activeMenu is null " );
	}

	var cells = menubar.getElementsByTagName("TD");
	for( var i = 0 ; i < cells.length; i++ )
	{
		if ( cells[i].className != "off" )
		{
			cells[i].className = "off";
		}
	}
}
//---------------------------------------------------------------------------
function fwkInitMenuItem( id, submenuId )
{
	var item = document.getElementById(id);
	if ( item != null )
	{
		//--- Set event handlers
		item.onmouseover = fwkSelectMenuItem ;
		item.onmouseout  = fwkUnselectMenuItem ;
		//--- Set submenu if any
		item.submenuId = submenuId ;
	}
	else
	{
		fwkError("fwkInitMenuItem : cannot found id '" + id + "'");
	}
}
//---------------------------------------------------------------------------
function fwkInitMenuBar( id )
{
	var menubar = document.getElementById(id);
	if ( menubar != null )
	{
		window.fwkCurrentMenuBarId = id ;
		window.fwkCurrentMenuBar = menubar;
	}
	else
	{
		fwkError("fwkInitMenuBar : cannot found id '" + id + "'");
	}
}
//---------------------------------------------------------------------------
function fwkMenuLink(s)
{	
	if ( s != null )
	{
		window.location = s ;	
	}
	else
	{
		alert("ERROR : fwkMenuLink(null) : Link is null ");
	}
}
//---------------------------------------------------------------------------

/* GLOBAL VARIABLES */
var TELOSYS_TREE_SELECTED = null;
var TELOSYS_TREE_SELECTED_MOVED = false;
var TELOSYS_MOUSE_IS_DOWN = false ;
/* END GLOBAL VARIABLES */

function fwkGetTreeDragAndDropContent() {
	var sID = "fwkTelosysTreeDragAndDrop";
	var e = document.getElementById(sID);
	if ( e == null )
	{
		e = document.createElement("UL");
		e.id = sID;
		e.className = "tree";
		e.style.position = "absolute";
		e.style.whiteSpace = "nowrap" ;
		//e.style.backgroundColor = "#DDDDDD";
		e.style.left = 0 ;
		e.style.top  = 0 ;
		e.style.width  = "20px" ;
		e.style.height = "auto" ;
		e.style.marginTop = 0 ;
		e.style.marginLeft = 0 ;
		e.style.paddingLeft = 0 ;
		if (typeof e.style.MozOpacity!="undefined") e.style.MozOpacity=0.7; //Firefox
		if (typeof e.style.filter!="undefined") e.style.filter="alpha(opacity=50)"; 
		if (typeof e.style.opacity!="undefined") e.style.opacity=0.7; 
		document.body.appendChild(e);
	}
	return e ;
}
	
// Open or close one node and fire click
function fwkTreeOpenCloseNode(target) {
	if (target.nodeName=="LI") {
		if (target.className=="closed") {
			target.className="opened";
			var uls = target.getElementsByTagName('ul');
			if (uls!=null && uls.length>0) {
				uls[0].style.display = "block";
			}
		} else if (target.className=="opened") {
			target.className="closed";
			var uls = target.getElementsByTagName('ul');
			if (uls!=null && uls.length>0) { // v 0.9.9 ( or -> and )
				uls[0].style.display = "none";
			}
		} 
		var act = target.getAttribute("action");
		if (act!=null)
			eval(act);
	}
}

// Move one node in the tree
function fwkTreeDropSelection(liSrc, liTarget) {
	if (liSrc!=null && liTarget!=null && liSrc!=liTarget) {
		var uls = liTarget.getElementsByTagName('ul');
		if (uls==null || uls.length==0) {
			var newUlTarget = document.createElement('ul');
			newUlTarget.appendChild(liSrc);
			liTarget.appendChild(newUlTarget);
			liTarget.className="opened"
		} else {
			uls[0].appendChild(liSrc);
		}
	}
}

// MouseDown event on the tree : prepare for DRAG
function fwkTreeMouseDown(evt) {
	TELOSYS_MOUSE_IS_DOWN = true ;
	if (!evt) 
		var evt = window.event;
	var target   = evt.target || evt.srcElement;
	if (target!=null && target.nodeName=="LI") {
		TELOSYS_TREE_SELECTED = target;
		TELOSYS_TREE_SELECTED_MOVED = false;
		document.onmousemove = fwkTreeMouseMove;
		document.onmouseup   = fwkTreeMouseUp;
	}
}

// MouseMove event on the tree
function fwkTreeMouseMove(evt) {
	if (!evt) 
		var evt = window.event;
	if ( TELOSYS_MOUSE_IS_DOWN )
	{
		if (TELOSYS_TREE_SELECTED != null) 
		{
			var drag = fwkGetTreeDragAndDropContent();
			if (!TELOSYS_TREE_SELECTED_MOVED) 
			{
				// First move after selection : Init the drag content and show it
				if ( drag.firstChild )
				{
					drag.removeChild(drag.firstChild);
				}
				drag.appendChild(TELOSYS_TREE_SELECTED.cloneNode(true));
				TELOSYS_TREE_SELECTED_MOVED = true;
				drag.style.display = "block";
			}
			drag.style.left = evt.clientX+5;
			drag.style.top  = evt.clientY+5;
		}
	}
}

// MouseUp event on the tree : DROP or CLICK
function fwkTreeMouseUp(evt) {
	TELOSYS_MOUSE_IS_DOWN = false ;
	if (!evt) 
		var evt = window.event;
	var target = evt.target || evt.srcElement;
	if (target!=null && TELOSYS_TREE_SELECTED!=null) {
		if (TELOSYS_TREE_SELECTED_MOVED) {
			// DROP
			var drag = fwkGetTreeDragAndDropContent();
			drag.removeChild(drag.lastChild);
			drag.style.display = "none";
			if ( fwkTreeTargetIsOK(target) )
			{
				if (target.className=="closed" || target.className=="opened") {
					fwkTreeDropSelection(TELOSYS_TREE_SELECTED, target);
				} else if (target.className=="leaf") {
					target.parentNode.insertBefore(TELOSYS_TREE_SELECTED, target);
				}
			}
		} else {
			// CLICK
			fwkTreeOpenCloseNode(target);
		}
		document.onmousemove = null ;
		document.onmouseup   = null ;
		TELOSYS_TREE_SELECTED = null;
		TELOSYS_TREE_SELECTED_MOVED = false;
	}
}

function fwkTreeTargetIsOK(target)
{
	if (target.nodeName!="LI" ) return false ;
	if (target== TELOSYS_TREE_SELECTED) return false ;
	// Do not drop in a child of the current selected node
	if ( TELOSYS_TREE_SELECTED.firstChild != null ) // has children
	{
		var n = target ;
		while ( n.parentNode != null )
		{
			if ( n.parentNode == TELOSYS_TREE_SELECTED )
			{
				return false ;
			}
			n = n.parentNode ;
			if ( n.treeviewroot ) // ( the UL root tag of the treeview )
				return n.drop ; // DROP enabled ? see init function 
		}
	}
	return true ;
}

//-----------------------------------------------------------
// Init TREE ( enable Drag and Drop )
//-----------------------------------------------------------
// Tree initialisation = fire events, disable text selection and init node style 
function fwkTreeInitTree(id){
	var tree = document.getElementById(id);
	if ( tree != null ) {
		tree.treeviewroot = true ;
		tree.drag = true ;
		tree.drop = true ;
		//tree.onmousemove 	 = fwkTreeMouseMove;
		tree.onmousedown	 = fwkTreeMouseDown;
		//document.onmouseup   = fwkTreeMouseUp;
	}
}

//-----------------------------------------------------------
// Init TREE ( No Drag and Drop )
//-----------------------------------------------------------
function fwkTreeOnClick(evt) {
	if (!evt) 
		var evt = window.event;
	var target = evt.target || evt.srcElement;
	fwkTreeOpenCloseNode(target);
}

function fwkTreeInitTreeNoDND(id){ // NO Drag and Drop
	var tree = document.getElementById(id);
	if ( tree != null ) {
		tree.treeviewroot = true ;
		tree.drag = false ;
		tree.drop = false ;
		tree.onclick = fwkTreeOnClick;
	}
}

//--------------------------------------------------------------------
// Functions for the SpinEdit widget
//--------------------------------------------------------------------
function fwkSpinEditClick(id, step, digit, min, max) // min & max facultatifs
{
	var spin = document.getElementById(id);
	if ( spin != null )
	{
		// parseFloat : if invalid value, doesn't throw exception, just return NaN
		var val = parseFloat(spin.value); 
		if ( isNaN(val) ) val = 0 ;
		val += step;
		if ( max != null )
		{
			if ( val > max ) val = max ;
		}
		if ( min != null )
		{
			if ( val < min ) val = min ;
		}
		if (digit>=0)
		{
			val = val.toFixed(digit);
		}
		spin.value = val;
	}
}
//--------------------------------------------------------------------
function fwkRefreshImage(arg)
{
	var image = fwkGetObject(arg, "fwkRefreshImage");
	if ( image != null )
	{
		if ( null == image.originalSrc ) // Not yet initialized
		{
			image.originalSrc = image.src ; // Keep the original src for reuse 
		}
		var originalSrc = image.originalSrc ;
		var tmp = new Date();
		newSrc = originalSrc + "#A" + tmp.getTime() ; // Change URL to force reload
		image.src = newSrc ;
		fwkSetVisible(image) ;
	}
}
function fwkClearImage(arg)
{
	var image = fwkGetObject(arg, "fwkClearImage");
	if ( image != null )
	{
		if ( null == image.originalSrc ) // Not yet initialized
		{
			image.originalSrc = image.src ; // Keep the original src for reuse 
		}
		image.src = null ;
		fwkSetHidden(image) ;		
	}
}

//------------------------------------------------------------------------------
function HttpRequester( pFct, pFctError )
{
	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------	
	var _oXMLHTTP            = null ; // THE "XMLHttpRequest" object
	var _sRequestContent     = null ; // The last request content
	var _sRequestContentType = null ; // The last request content type
	var _fctProcessResponse  = null ; // External function for response processing
	var _fctError            = null ; // External function for error processing 
	
	if ( pFct != null )
	{
		_fctProcessResponse = pFct ;
	}
	if ( pFctError != null )
	{
		_fctError = pFctError ;
	}
	
	//--- Instance init 	
    if (window.ActiveXObject) 
	{
    	//--- Internet Explorer
    	_oXMLHTTP = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if (window.XMLHttpRequest)
    {
    	//--- Mozilla & Safari
    	_oXMLHTTP = new XMLHttpRequest();
    }

	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// AJAX response processing : build the response and call the callBackFunction 
	//------------------------------------------------------------------------------
	function _processAjaxResponse() // Called for each state change (1,2,3 & 4)
	{
		//--- If new state is "COMPLETE" ...
		if ( _oXMLHTTP.readyState == 4 )
		{
			if ( _oXMLHTTP.status == 200 )
			{
				//--- Run the callback if it exists
				if ( _fctProcessResponse != null )
				{
					_fctProcessResponse( _oXMLHTTP ) ;
				}
			}
			else
			{
				if ( _fctError != null )
				{
					_fctError( _oXMLHTTP ) ;
				}
				else
				{
					fwkError ( "HTTP error : " + _oXMLHTTP.status + " " + _oXMLHTTP.statusText ); 
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// Send HttpRequest to the server 
	//------------------------------------------------------------------------------
	function _sendRequest ( sHttpMethod, sURL, bAsync, sContent, sContentType ) // RET : void 
	{
		if ( _oXMLHTTP == null )
    	{
			fwkError ( "_sendRequest() : XMLHttpRequest object is null !" ); return ;
    	}
    	//--- Check parameters 
		if ( sHttpMethod == null )
		{
			fwkError ( "_sendRequest() : HTTP Method is null ! " ); return ;
		}
		if ( sURL == null ) 
		{
			fwkError ( "_sendRequest() : URL is null ! " ); return ;
		}
		if ( bAsync == null )
		{
			bAsync = false ;
		}		

		_sRequestContent = sContent ;
		_sRequestContentType = sContentType ;
		
		//--- (1) Setup the HTTP Request Method and URL 
	    _oXMLHTTP.open (sHttpMethod, sURL, bAsync);  // false = SYNCHRONOUS  (true = ASYNCHRONOUS)	    
		if ( sContent != null )
		{
			if ( sContentType != null )
			{
		    	_oXMLHTTP.setRequestHeader("Content-Type", sContentType );
		    }
		}

		//--- (2) Configure the callback method (if ASYNCHRONOUS) 
	    if ( bAsync )
	    {
			_oXMLHTTP.onreadystatechange = _processAjaxResponse ;
		}

		//--- (3) Send the request to the server 
	    _oXMLHTTP.send (sContent); // Send the content (via HTTP)
	    
	    //--- (4) if this request is not ASYNCHRONOUS => call the method to process the response
	    if ( ! bAsync )
	    {
			_processAjaxResponse() ;
		}
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Get the last request content (request body)
	//------------------------------------------------------------------------------
	this.getRequestContent = function() 
	{
		return _sRequestContent ;
	}
	//------------------------------------------------------------------------------
	// Get the last request content (request body)
	//------------------------------------------------------------------------------
	this.getRequestContentType = function() 
	{
		return _sRequestContentType ;
	}
	
	//------------------------------------------------------------------------------
	// Get the last HTTP status 
	//------------------------------------------------------------------------------
	this.getHttpStatus = function() 
	{
		return _oXMLHTTP.status ;
	}
	//------------------------------------------------------------------------------
	// Get the last response as text 
	//------------------------------------------------------------------------------
	this.getResponseText = function() 
	{
		return _oXMLHTTP.responseText ;
	}
	//------------------------------------------------------------------------------
	// Get the last response as XML 
	//------------------------------------------------------------------------------
	this.getResponseXML = function() 
	{
		return _oXMLHTTP.responseXML ;
	}


	//------------------------------------------------------------------------------
	// SYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.httpGetSync = function ( sUrl, sContent, sContentType )
	{
		_sendRequest("GET", sUrl, false, sContent, sContentType);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.httpGetAsync = function ( sUrl, sContent, sContentType )
	{
		_sendRequest("GET", sUrl, true, sContent, sContentType);
	}
	//------------------------------------------------------------------------------
	// SYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.httpPostSync = function ( sUrl, sContent, sContentType )
	{
		_sendRequest("POST", sUrl, false, sContent, sContentType);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.httpPostAsync = function ( sUrl, sContent, sContentType )
	{
		_sendRequest("POST", sUrl, true, sContent, sContentType);
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Logger_class.js
// Telosys framework
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

function Logger(sLoggerName)
{
	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------
	var _iCount         = 0 ;
	var _sName          = ( sLoggerName != null ? sLoggerName : "logger" ) ;
	var _sConsoleId     = _sName + "_console" ;
	var _oConsole       = null ;
	var _sConsoleBodyId = _sName + "_console_body" ;
	var _oConsoleBody   = null ;
		
	//------------------------------------------------------------------------------
	// PRIVATE METHODS
	//------------------------------------------------------------------------------
	function getConsole() 
	{
		if ( _oConsole == null )
		{
			_oConsole = document.getElementById( _sConsoleId );
			if ( _oConsole == null )
			{
				alert("ERROR in Logger : Cannot get logger console ( ID = " + _sConsoleId + ")" );
				return null ;
			}
		}
		return _oConsole ;
	}
	//------------------------------------------------------------------------------
	function getConsoleBody() 
	{
		if ( _oConsoleBody == null )
		{
			_oConsoleBody = document.getElementById( _sConsoleBodyId );
			if ( _oConsoleBody == null )
			{
				alert("ERROR in Logger : Cannot get logger console body ( ID = " + _sConsoleBodyId + ")" );
				return null ;
			}
		}
		return _oConsoleBody ;
	}
	//------------------------------------------------------------------------------
	function createSeverity(sLevel) 
	{
		var oDIV = document.createElement("span");
		oDIV.style.marginLeft="2px";
		oDIV.style.paddingLeft="4px";
		oDIV.style.paddingRight="4px";
		oDIV.style.marginRight="2px";		
		// different colors for different severities
		if (sLevel == "DEBUG") {
			oDIV.style.backgroundColor="#CCCCCC";
		} else if (sLevel == "INFO") {
			oDIV.style.backgroundColor="#CCFFFF";
		} else if (sLevel == "WARN") {
			oDIV.style.backgroundColor="yellow";
		} else if (sLevel == "ERROR") {
			oDIV.style.backgroundColor="red";
		}		
		oDIV.appendChild(document.createTextNode("."));
		return oDIV ;
	}
	//------------------------------------------------------------------------------
	function createMessageRow(sLevel,sMsg) 
	{
		_iCount++;
		var oDivMsgRow = document.createElement("div");
		oDivMsgRow.style.borderBottom="1px solid #AAA";
		oDivMsgRow.style.verticalAlign="top";
		
		oDivMsgRow.appendChild( createSeverity(sLevel) );
		oDivMsgRow.appendChild( document.createTextNode("" + _iCount + " [" + sLevel+"] "+sMsg));
		
		return oDivMsgRow ;
	}
	//------------------------------------------------------------------------------
	function logMsg(sLevel,sMsg) 
	{
		var oConsoleBody = getConsoleBody();
		if ( oConsoleBody != null )
		{
			oConsoleBody.appendChild(createMessageRow(sLevel,sMsg));
		}
 	}
	//------------------------------------------------------------------------------
	function setConsoleDisplayStyle(s) 
	{
		var console = getConsole();
		if ( console != null )
		{
			console.style.display = s ;
		}
	}
	
	//------------------------------------------------------------------------------
	// PUBLIC METHODS
	//------------------------------------------------------------------------------
	this.debug = function(sMsg) 
	{
		logMsg("DEBUG",sMsg);
	}
	//------------------------------------------------------------------------------
	this.info = function(sMsg) 
	{
		logMsg("INFO",sMsg);
	}
	//------------------------------------------------------------------------------
	this.warning = function(sMsg) 
	{
		logMsg("WARN",sMsg);
	}
	//------------------------------------------------------------------------------
	this.error = function(sMsg) 
	{
		logMsg("ERROR",sMsg);
	}
	//------------------------------------------------------------------------------
	this.show = function() 
	{
		setConsoleDisplayStyle("block") ;
	}
	//------------------------------------------------------------------------------
	this.hide = function() 
	{
		setConsoleDisplayStyle("none") ;
	}
	//------------------------------------------------------------------------------
	this.clear = function() 
	{
		var oConsoleBody = getConsoleBody();
		if ( oConsoleBody != null )
		{
			oConsoleBody.innerHTML = "";
			_iCount = 0 ;
		}
	}
	//------------------------------------------------------------------------------
	this.eval = function(sId) 
	{
		if ( sId != null )
		{
			var oField = document.getElementById( sId );
			if ( oField != null )
			{
				if ( oField.value != null )
				{
					var result = eval(oField.value);
					alert ( "result = " + result) ;
				}
			}
			else
			{
				alert("ERROR in Logger.eval : No field with ID '" + sId + "'" );
			}
		}
		else
		{
			alert("ERROR in Logger.eval : Field ID parameter is null" );
		}
	}
	//------------------------------------------------------------------------------
	this.desc = function() 
	{
		alert("Logger object : " 
		+ "\n . name = " + _sName 
		+ "\n . console id = " + _sConsoleId 
		+ "\n . console body id  = " + _sConsoleBodyId 
		) ;
	}
	//------------------------------------------------------------------------------
	
}

function fwkCreateLoggerConsole(sLoggerName)
{
	var sName = ( sLoggerName != null ? sLoggerName : "logger" ) ;
	var s = 
	  "<div id='" + sName + "_console' " 
	+ "style='font-family:arial; color:black; font-size:12px; line-height:normal; letter-spacing: normal; "
	+ "width:600px; display:none; position:absolute; top:20px; left:20px;" 
	+ "z-index:10000; border : 1px solid black ;' >"
	
	+ "<table style='align:center; width:100%; background-color:#3300FF; border:none; color:black; cursor:default'  >"
	+ "<tr>"
	+ "<td style='text-align:center; width:100%; color:#FFFFFF; font-family:arial; font-size:14px; font-weight: bold;' >Javascript logger console</td>"
	+ "<td style='background-color:silver; font-family:arial; font-size:14px; font-weight: bold; ' onclick='" + sName + ".hide();'>&nbsp;X&nbsp;</td>"
	+ "</tr>"
	+ "</table>"

	+ "<table style='align:center; width:100%; color:black; background-color:#FFFFCC; border:1px solid black; font-family:Tahoma;  '  >"
	+ "<tr style='background-color:grey; font-size:12px;' >"
	+ "<td style='background-color:#DDDDDD;cursor:default;border:1px solid #AAAAAA;' onclick='" + sName + ".clear();'>&nbsp;&nbsp;Clear&nbsp;&nbsp;</td>"
	+ "<td style='background-color:#FFFFCC; width:100%;' >&nbsp;</td>"
	+ "<td style='text-align:center; width:100%;' ><input id='"+sName+"_eval_input' style='width:400px; '/></td>"
	+ "<td style='background-color:#DDDDDD;cursor:default;border:1px solid #AAAAAA;' onclick=\"" +sName+".eval('"+sName+"_eval_input');\">&nbsp;&nbsp;Eval&nbsp;&nbsp;</td>"
	+ "</tr>"
	+ "</table>"	
	
	+ "<div id='" + sName + "_console_body' style='height:240px; overflow:auto; background-color:#FFFFFF; ' ></div>"
	
	+ "<div "
	+ " style='height:12px; padding:2px; border-top:1px solid black; background-color:#FFFFCC;'>&nbsp;</div>"	
	+ "</div>"
	
	+ "</div>" ;
	
	document.write(s);
	return sName ;
}

function fwkCreateLogger(sLoggerName)
{
	var sName = ( sLoggerName != null ? sLoggerName : "logger" ) ;
	fwkCreateLoggerConsole( sName );
	var logger = new Logger( sName );	
	window[sName] = logger ;
}

